/*
 * ==============================
 *  创建团
 * ==============================
 */


// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	
	mnWebMain.cbBridgeInited = function()
	{
		GroupCreateController.groupId = _utility.getQueryString("groupId");
		GroupCreateController.init($scope);
		
	};
    
    mnWebMain.cbViewWillAppear = function()
    {
    };
    mnWebMain.cbNavRightClicked = function()
    {
    	var params = GroupCreateController.generateGroupValue(0);
    	if(params)
    	{
	    	saveLocalString(CREATE_GROUP, JSON.stringify(params));
			mnWebMain.openWebViewController(URL_GROUP_PREVIEW, "团预览");
    		
    	}
    };
});
var GroupCreateController = 
{
	groupId : null,//模版团id
	scope : null,
	unableTimeArr : [],//导游所有团的开始结束时间
	groupIcon : {},//导游头像(原图) url:"", width:"", height:""
	startTime : null,//出发时间
	endTime : null,//结束时间
	alongTime : null,//持续时间
	groupDestinationData : [],//目的地
	destinationInfo : {},//目的地须知内容  key：目的地名字  value
	contactsArr : [],//紧急联系人
	guidesArr : [],//当地导游
	safetyInfo : null,//安全须知
	goodsInfo : null,//携带物品须知
	state : null,//创建团时的地点是否是手动输入 0：不是  1：是

	currentUsername : null, // 当前用户的手机账号

	/**
	 * 生成团数据
	 * @param {Object} type 0：预览       1:提交
	 */
	generateGroupValue : function(type)
	{
		var self = this;
		var params = {};
		//团名称
		var groupName = self.scope.groupName; 
		if(!groupName || groupName == undefined){
			var arr = ["确定"];
			mnWebMain.showDialog(0, "提示", "请输入团名称！", arr);
			return;
		}
		params.groupName = groupName;
		//团头像
		if(self.groupIcon.url)
		{
			params.groupIcon = JSON.stringify(self.groupIcon);
		}
		else
		{
			params.groupIcon = "";
		}
		
		//集合时间
		var meetingTime = self.scope.meetingTime;
		if(!meetingTime || meetingTime == undefined)
		{
			var arr = ["确定"];
			mnWebMain.showDialog(0, "提示", "请选择集合时间！", arr);
			return;
		}
		params.meetingTime = meetingTime;
		
		//出发地点  (集合地点) 
		//var startLocation = $("#startLocation").attr("data-id");
		var startLocation = self.scope.startLocation;
		if(!startLocation || startLocation == undefined){
			var arr = ["确定"];
			mnWebMain.showDialog(0, "提示", "请选择集合地点！", arr);
			return;
		}
		params.startLocation = startLocation;
		
		//出行时间
		if(type == 1)
		{
			var startTime = self.startTime;
			if(!startTime || startTime == undefined){
				var arr = ["确定"];
				mnWebMain.showDialog(0, "提示", "请选择出行时间！", arr);
				return;
			}
			params.startTime = startTime;
			
			var endTime = self.endTime;
			if(!endTime || endTime == undefined){
				var arr = ["确定"];
				mnWebMain.showDialog(0, "提示", "请选择出行时间！", arr);
				return;
			}
			params.endTime = endTime;
		}
		else
		{
			var startTime = self.scope.startTime;
			if(!startTime || startTime == undefined){
				var arr = ["确定"];
				mnWebMain.showDialog(0, "提示", "请选择出行时间！", arr);
				return;
			}
			params.startTime = startTime;
			
			var endTime = self.scope.endTime;
			if(!endTime || endTime == undefined){
				var arr = ["确定"];
				mnWebMain.showDialog(0, "提示", "请选择出行时间！", arr);
				return;
			}
			params.endTime = endTime;
		}
		
		
		//目的地   ----------************---------------------------------
		if(self.groupDestinationData.length == 0)
		{
			var arr = ["确定"];
			mnWebMain.showDialog(0, "提示", "请选择至少一个目的地！", arr);
			return;
		}
		params.endLocation = JSON.stringify(self.groupDestinationData);

		//联系人姓名和电话号要分开存储
		var generateContactsArr = [];
		for(var i = 0; i < self.contactsArr.length; i++)
		{
			var contactItem = {};
			contactItem.contact_name = self.contactsArr[i].contact_name;
			contactItem.contact_phone = self.contactsArr[i].contact_phone;
			if(contactItem.contact_name && contactItem.contact_phone)
			{
				generateContactsArr.push(contactItem);
			}
		}
		if(generateContactsArr.length == 0){
			var arr = ["确定"];
			mnWebMain.showDialog(0, "提示", "请添加紧急联系人！", arr);
			return;
		}else
		{
		    for(var i in generateContactsArr)
		    {
		        if(!(/^1[34578]\d{9}$/.test(generateContactsArr[i].contact_phone)))
		        {
                     var arr = ["确定"];
                     mnWebMain.showDialog(0, "提示", "请输入正确的紧急联系人手机号码！", arr);
                     return;
                }
		    }
		}

		params.contacts = JSON.stringify(generateContactsArr);
		
		var generateGuidesArr = [];
		for(var i = 0; i < self.guidesArr.length; i++)
		{
			var guideItem = {};
			guideItem.guide_name = self.guidesArr[i].guide_name;
			guideItem.guide_phone = self.guidesArr[i].guide_phone;
			if(guideItem.guide_name && guideItem.guide_phone)
			{
				generateGuidesArr.push(guideItem);
			}
		}
		if(generateGuidesArr.length == 0){
			var arr = ["确定"];
			mnWebMain.showDialog(0, "提示", "请添加当地导游！", arr);
			return;
		}else
        {
         	for(var i in generateGuidesArr)
            {
         		if(!(/^1[34578]\d{9}$/.test(generateGuidesArr[i].guide_phone)))
         		{
                   var arr = ["确定"];
                   mnWebMain.showDialog(0, "提示", "请输入正确的导游手机号码！", arr);
                   return;
                }
            }
         }
		params.guides = JSON.stringify(generateGuidesArr);
		
		params.destinationInfo = JSON.stringify(self.destinationInfo);
		params.safetyInfo = self.safetyInfo;
		params.carryInfo = self.goodsInfo;//携带物品须知
		params.state = self.state;
		
		if(type == 1){
			mnWebMain.showProgressDialog("请稍候...");
		}
		return params;
	},
	init : function($scope)
	{
	    var self = this;

		this.scope = $scope;
		if(this.groupId)
		{
			this.getModelGroupData();
		}
		else
		{
			this.scope.groupIcon = "assets/images/default/group_img.png";
			this.scope.$apply();
			this.getSafetyInfo(SAFETY);//安全须知
			this.getGoodsInfo(GOOD_CHINA);//携带物品须知
			//如果不是模板创建，需要当地导游默认添加一个自己的姓名和电话号
			var userId = getUserId();
			if(userId)
			{
				var localInfos = getLocalString(USER_INFO);
				try 
				{
					var infoJson = JSON.parse(localInfos);
					var myInfo = infoJson.userObjArr[userId];
					if (myInfo) 
					{
						var guide_name = myInfo.realName;
						//名字最长不能超过5个字符
						if(guide_name && guide_name.length > 5)
						{
							guide_name = guide_name.substr(0, 5);
						}
						var guide_phone = getUsername();
						if(guide_name || guide_phone)
						{
							var guideMe = {};
							guideMe.guide_name = guide_name;
							guideMe.guide_phone = guide_phone;
							this.guidesArr.push(guideMe);
							this.scope.guidesArr = this.guidesArr;
							this.scope.$apply();
						}
					}
				} catch (e) {}
			}
			
		}
		this.getAllGroupTimeArr();
		this.onClickFunction();

	},
	//获取模版团数据
	getModelGroupData : function()
	{
		var self = this;
		var params = {};
		params.ids = "[\"" + this.groupId + "\"]";
		var path = API_GET_GROUP_WITH_ID;
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			var error = resultJob.error;
			if(error == 0)
			{
				var data = resultJob.data;
				var groupsObj = data.groups;
				var groupObj = groupsObj[self.groupId];
				//团名称
				self.scope.groupName = groupObj.groupName;
				//团头像
				try{
					if(groupObj.groupIcon)
					{
						var groupIcon = JSON.parse( groupObj.groupIcon );
						var groupIcon_url = groupIcon.url + IMG_CUT_WH2;
						self.groupIcon.url = groupIcon.url;
					}
					else
					{
						var groupIcon_url = "assets/images/default/group_img.png";
						self.groupIcon.url = "";
					}
					self.scope.groupIcon = groupIcon_url;
				}catch(e){
					var groupIcon_url = "assets/images/default/group_img.png";
					self.groupIcon.url = "";
					self.scope.groupIcon = groupIcon_url;
				}
				self.scope.startLocation = groupObj.startLocation;//集合地点
				
				var endLocation = groupObj.endLocation;//目的地
				var destinationInfoStr = groupObj.destinationInfo;//目的地信息
				self.groupDestinationData = JSON.parse(endLocation);
				self.destinationInfo = JSON.parse(destinationInfoStr);
				self.refreshGroupDestinationData();//刷新目的地列表
				
				//紧急联系人,当地导游
				try
				{
					var contacts = groupObj.contacts;
					self.contactsArr = JSON.parse(contacts);
					var guides = groupObj.guides;
					self.guidesArr = JSON.parse(guides);
				}catch(e){
				}
				self.scope.contactsArr = self.contactsArr;
				self.scope.guidesArr = self.guidesArr;
				//安全须知
				self.safetyInfo = groupObj.safetyInfo;
				//携带物品须知
				self.goodsInfo = groupObj.carryInfo;
				//如果没有安全须知，则使用默认安全须知
				if(!self.safetyInfo)
				{
					self.getSafetyInfo(SAFETY);//安全须知
				}
				//如果没有携带物品须知，则使用默认的携带物品须知
				if(!self.goodsInfo)
				{
					self.getGoodsInfo(GOOD_CHINA);//携带物品须知
				}
				self.scope.$apply();
			}
			else
			{
				mnWebMain.toastInfo("获取模版数据失败！");
				//模版数据获取失败，获取默认的须知数据
				self.getSafetyInfo(SAFETY);//安全须知
				self.getGoodsInfo(GOOD_CHINA);//携带物品须知
			}
		});
	},
	/**
	 * 刷新目的地列表
	 */
	refreshGroupDestinationData : function()
	{
		this.scope.groupDestinationData = this.groupDestinationData;
		this.scope.$apply();
	},
	//把本人所有参加的团的开始结束时间取出，用来判断当前所创建团的时间是否合法
	getAllGroupTimeArr : function()
	{
		var self = this;
		var params = {};
		params.startIndex = "0";
		params.num = "999";
		//将本人所有参加群取出并保存成一个数组
		mnWebMain.httpRequest('group/getGroupsStart',params,function(result)
		{
			var res = JSON.parse(result);
			if( res.error == 0 )
			{
				var data = res.data;
				var groups = data.groups;
				for(var i in groups)
				{
					var startTime = groups[i].startTime;
					var endTime = groups[i].endTime;
					var groupName = groups[i].groupName;
					var unableTimeJob = {};
					unableTimeJob.start = new Date(startTime.replace(/-/g, "/")).getTime();
					unableTimeJob.end = new Date(endTime.replace(/-/g, "/")).getTime();
					self.unableTimeArr.push(unableTimeJob);
				}
			}
			else
			{
			}
		});
	},
	onClickFunction : function()
	{
		var self = this;
		//团头像修改
		this.scope.groupIconClick = function()
		{
			var arr = ["拍照", "从相册选择", "取消"];
			mnWebMain.showDialog("2", "", "", arr, function(result)
			{
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var index = dataJob.index;
				if(index == 0)
				{
					mnWebMain.photoPicker(1, 0, 1, function(resultCamera)
					{
						var resultCameraJob = JSON.parse(resultCamera);
						var dataCameraJob = resultCameraJob.data;
						var myImgs = JSON.parse(dataCameraJob.imageURLs);
						self.groupIcon.url = myImgs[0];
						self.groupIcon.image_width = "";
						self.groupIcon.image_height = "";
						self.scope.groupIcon = myImgs[0] + IMG_CUT_WH2;
						self.scope.$apply();
					});
				}
				else if(index == 1)
				{
					mnWebMain.photoPicker(1, 2, 1, function(resultAlbum){
						var resultAlbumJob = JSON.parse(resultAlbum);
						var dataAlbumJob = resultAlbumJob.data;
						var myImgs = JSON.parse(dataAlbumJob.imageURLs);
						self.groupIcon.url = myImgs[0];
						self.groupIcon.image_width = "";
						self.groupIcon.image_height = "";
						self.scope.groupIcon = myImgs[0] + IMG_CUT_WH2;
						self.scope.$apply();
					});
				}
			});
		};
		//集合时间
		this.scope.meetingTimeClick = function()
		{
			mnWebMain.chooseDate(function(result)
			{
				var resultJob = JSON.parse(result).data;
				var time = resultJob.result;//集合时间字符串
				var s_time = time.replace(/-/g, "/");
				var sTimeStamp = new Date(s_time).getTime();//集合时间的时间戳
				var curTimeStamp = new Date().getTime();//当前时间戳
				//判断集合时间是否大于当前时间
				if(sTimeStamp < curTimeStamp)
				{
					var arr = ["确定"];
					mnWebMain.showDialog(0, "提示", "集合时间应晚于当前时间！", arr);
					return;
				}
				//可以设置时间
  				self.scope.meetingTime = time;
				self.scope.$apply();
			}, 1);
		};
		//集合地点
		this.scope.startLocationClick = function()
		{
			var startLocation = self.scope.startLocation;
			if(!startLocation)
			{
				startLocation = '';
			}
			mnWebMain.openViewControllerWithDataTransfer("ChooseFootprintController", "选择集合地点", startLocation, function(result){
				var res = JSON.parse(result);
				var data = res.data;
				self.scope.startLocation = data.location;
				self.scope.$apply();
			});
		};
		this.scope.groupTripTimeClick = function()
		{
			mnWebMain.chooseTripDate(function(result)
			{
				var resultJob = JSON.parse(result);
				var error = resultJob.error;
				if(error == 0)
				{
					var data = resultJob.data;
					var startTimeJob = data.startTime;
					var endTimeJob = data.endTime;
					var startTime = startTimeJob.year + "年" + parseInt(startTimeJob.month) + "月" + startTimeJob.day + "日";
					var startTimeToServer = startTimeJob.year + "-" + parseInt(startTimeJob.month) + "-" + startTimeJob.day + " 00:00:00";
					var endTime = endTimeJob.year + "年" + parseInt(endTimeJob.month) + "月" + endTimeJob.day + "日";
					var endTimeToServer = endTimeJob.year + "-" + parseInt(endTimeJob.month) + "-" + endTimeJob.day + " 23:59:59";
					//最开始的时间格式："2016-06-10 07:00:00"， 现在有所修正，为了使改动小些，继续保持这种时间格式
					//1.必须先选择出发时间，再选择结束时间
					//1.选择时间必须大于当前时间，弹出错误提示并return
					var curDate = new Date();
					var curTimeStamp = curDate.getTime() - (60 * 1000);// 当前时间去掉一分钟,否则直接获取的时间戳可能会大于通过日期算出的时间戳
					var curYear = curDate.getFullYear();
	  				var curMonth = (parseInt(curDate.getMonth()) + 1) + "";
	  				var curDay = curDate.getDate();
	  				if(parseInt(startTimeJob.year) == curYear && parseInt(startTimeJob.month) == curMonth && parseInt(startTimeJob.day) == curDay)
	  				{
	  					var curTime = " " + curDate.getHours() + ":" + curDate.getMinutes() + ":" + curDate.getSeconds();
	  					startTimeToServer = startTimeJob.year + "-" + parseInt(startTimeJob.month) + "-" + startTimeJob.day + curTime;
	  				}
					var sTimeStamp = new Date(startTimeToServer.replace(/-/g, "/")).getTime();//出发时间戳
	  				var eTimeStamp = new Date(endTimeToServer.replace(/-/g, "/")).getTime();//结束时间戳
	  				var alongTime = (eTimeStamp - sTimeStamp) / 86400000;
	  				try{
		  				alongTime = parseInt(alongTime);
	  				}catch(e){
	  					alongTime = 0;
	  				}
	  				var flag = 0;//1表示时间晚了，2表示冲突了
	  				if(sTimeStamp <= curTimeStamp)
	  				{
	  					flag = 1;
	  				}
					//2.结束时间必须大约出发时间
					//3.出发和结束时间不能与其他团时间冲突
	  				for(var i in self.unableTimeArr)
	  				{
	  					if(self.unableTimeArr[i].start > eTimeStamp || self.unableTimeArr[i].end < sTimeStamp)
	  					{
	  						//这种情况没有冲突
	  					}
	  					else
	  					{
	  						flag = 2;
	  						break;
	  					}
	  				}
	  				var arr = ["确定"];
	  				if(flag == 0 || flag == "0")
	  				{
	  					self.scope.startTime = startTime;
	  					self.startTime = startTimeToServer;
	  					self.scope.endTime = endTime;
	  					self.endTime = endTimeToServer;
	  					self.alongTime = "(共" + (alongTime + 1) + "日)";
	  					self.scope.alongTime = self.alongTime;
	  					self.scope.$apply();
	  				}
	  				else if(flag == 1 || flag == "1")
	  				{
	  					mnWebMain.showDialog(0, "提示", "出发时间不能晚于当前时间！", arr);
	  				}
	  				else if(flag == 2 || flag == "2")
	  				{
	  					mnWebMain.showDialog(0, "提示", "您的出行时间与您的其他团冲突！", arr);
	  				}
				}
			});
		};
		//添加目的地
		this.scope.addDestination = function()
		{
			var headObj = {};
			mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_COUNTRY_FOR_SIGHT, "选择目的地", headObj, function(result)
			{
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var paramsJob = JSON.parse(dataJob.params);
				var name = paramsJob.name;
				var cId = paramsJob.cId;
				var cityId = paramsJob.cityId;
//				var sightId = paramsJob.sightId;
//				var goodsType = paramsJob.goodsType;//因为支持多个地区，所以这个字段暂时没有用处
				if(self.groupDestinationData.indexOf(name) == -1)
				{
					self.groupDestinationData.push(name);
					self.destinationInfo[name] = name + "目的地须知";
					self.refreshGroupDestinationData();
					//修改目的地须知
					state = 0;
					if(cId)
					{
						//根据countryId获取对应的目的地须知
						self.getCountryDestinationInfo(cId, name);
						return;
					}
					
					if(cityId)
					{
						//根据cityId拿到对应的目的地须知
						self.getCityDestinationInfo(cityId, name);
						return;
					}
					state = 1;
				}
				else
				{
					var arr = ["确定"];
					mnWebMain.showDialog(0, "提示", "您已经添加了这个地区！", arr);
				}
			});
		};
		//添加紧急联系人
		this.scope.addContact = function()
		{
			if(self.contactsArr.length > 5)
			{
				var arr = ["确定"];
				mnWebMain.showDialog(0, "提示", "最多只能添加5个", arr);
				return;
			}
			var contactItem = {};
			contactItem.contact_name = "";
			contactItem.contact_phone = "";
			self.contactsArr.push(contactItem);
			self.scope.contactsArr = self.contactsArr;
			self.scope.$apply();
		};
		//添加当地导游
		this.scope.addGuide = function()
		{
			if(self.guidesArr.length > 5)
			{
				var arr = ["确定"];
				mnWebMain.showDialog(0, "提示", "最多只能添加5个", arr);
				return;
			}
			var guideItem = {};
			guideItem.guide_name = "";
			guideItem.guide_phone = "";
			self.guidesArr.push(guideItem);
			self.scope.guidesArr = self.guidesArr;
			self.scope.$apply();
		};
		//目的地须知子项点击（删除目的地）
		this.scope.destinationItemClick = function(index, name)
		{
			/**
			 * 没找到js去掉字典中的某组键值对的方法，所以直接遍历之前的字典去掉某个字段之后生成一个新的字典
			 */
			var groupDestinationDataCopied = {};
			for(var i in self.destinationInfo)
			{
				if(i != name)
				{
					groupDestinationDataCopied[i] = self.destinationInfo[i];
				}
			}
			self.destinationInfo = groupDestinationDataCopied;
			
			self.groupDestinationData.splice(index, 1);
			self.scope.groupDestinationData = self.groupDestinationData;
			self.scope.$apply();
		};
		//目的地须知
		this.scope.destinationClick = function()
		{
			if(self.groupDestinationData.length == 0)
			{
				var arr = ["确定"];
				mnWebMain.showDialog(0, "提示", "请先添加目的地！", arr);
				return;
			}
			//目的地须知
			saveLocalString(DESTIANTION_INFO_PRE, JSON.stringify(self.destinationInfo));
			var headObj = {};
			headObj.rightTitle = "确定";
			mnWebMain.openWebViewControllerWithDataTransfer(URL_GROUP_LOCA_NOTICE_EDIT, "目的地须知", headObj, function(result)
			{
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var destinationInfo = dataJob.params;
				self.destinationInfo = JSON.parse(destinationInfo);
			});
		};
		this.scope.safetyClick = function()
		{
			//安全提醒
			saveLocalString(SAFETY_INFO, self.safetyInfo);
			var headObj = {};
			headObj.rightTitle = "确定";
			mnWebMain.openWebViewControllerWithDataTransfer(URL_GROUP_SAFE_NOTICE_EDIT, "安全须知", headObj, function(result)
			{
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var safetyInfo = dataJob.params;
				self.safetyInfo = safetyInfo;
			});
		};
		this.scope.goodsClick = function()
		{
			saveLocalString(CARRY_INFO, self.goodsInfo);
			//携带物品须知
			var headObj = {};
			headObj.rightTitle = "确定";
			var jumpUrl  = URL_GROUP_GOODS_NOTICE + "?type=1";
			mnWebMain.openWebViewControllerWithDataTransfer(jumpUrl, "携带物品须知", headObj, function(result)
			{
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var goodsInfo = dataJob.params;
				self.goodsInfo = goodsInfo;
			});
		};
		this.scope.submitClick = function()
		{
			//创建行程
			var params = self.generateGroupValue(1);
			if(params)
			{
				if(self.groupId)
				{
					self.createGroup(params, self.groupId);//创建团,模版模式
				}
				else
				{
					self.createGroup(params);//创建团
				}
			}
		};
	},

	createGroup : function(params, modelGroupId)
	{
            var self = this;
            
			var guideList = JSON.parse(params.guides);

            for (var i = 0; i < guideList.length; i++) {
                if (self.currentUsername == guideList[i].guide_phone) {
                    if (guideList[i].guide_name) {
                        mnWebMain.saveCurrentRealName(guideList[i].guide_name);
                    }
                    break;
                }
            }


//		var self = this;
		var path = "group/createGroup";
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			var dataJob = resultJob.data;
			if(resultJob.error == 0)
			{
				var code = dataJob.identificationCode;
				var groupId = dataJob.groupId;

				var days = self.getTotalDays(params.startTime, params.endTime);
				var startday = params.startTime;
				var time_str1 = startday.replace(/-/g, "/");
				var new_time1 = new Date(time_str1).getTime();

				mnWebMain.dismissProgressDialog();
				saveLocalString(GROUP_REFRESH, '1');//本地维护一个数据，用来通知其他页面有新的团被创建
				if(modelGroupId)
				{
		    		mnWebMain.jumpToCreateTripActivity(days, new_time1, groupId, code, encodeURI(params.groupName), modelGroupId, 0);
				}
				else
				{
					mnWebMain.jumpToCreateTripActivity(days, new_time1, groupId, code, encodeURI(params.groupName), '', 1);
				}
			}else{
				mnWebMain.dismissProgressDialog();
			}
		});
	},
	//获取行程总天数
	getTotalDays : function(time1, time2){
		//格式2016-03-15 17:00
		var time_str1 = time1.replace(/-/g, "/");
		var new_time1 = new Date(time_str1).getTime(); 
		
		var time_str2 = time2.replace(/-/g, "/");
		var new_time2 = new Date(time_str2).getTime(); 
		var alongTimeStamp = (new_time2 - new_time1) / 86400000;
		try{
			alongTimeStamp = parseInt(alongTimeStamp);
		}catch(e){
			alongTimeStamp = 0;
		}
		return alongTimeStamp + 1;
	},
	//获取城市安全地须知
	getSafetyInfo : function(type)
	{
		var self = this;
		var params = {};
		params.type = type;
		var path = "group/getInstructions";
		mnWebMain.httpRequest(path, params, function(result){
			var res = JSON.parse(result);
			var data = res.data;
			if( res.error == 0 ){
				var instructions = data.instructions;
				self.safetyInfo = instructions[0].instructions;
			}else{
			}
		});
	},
	//获取携带物品须知
	getGoodsInfo : function(type)
	{
		var self = this;
		var params = {};
		params.type = type;
		var path = "group/getInstructions";
		mnWebMain.httpRequest(path, params, function(result)
		{
			var res = JSON.parse(result);
			var data = res.data;
			if(res.error == 0)
			{
				var instructions = data.instructions;
				self.goodsInfo = instructions[0].instructions;
			}
			else
			{
			}
		});
	},
	//获取国家目的地须知
	getCountryDestinationInfo : function(countryId, countryName)
	{
		var self = this;
		var params = {};
		params.countryId = countryId;
		var path = "common/getCountryInfo";
		mnWebMain.httpRequest(path, params, function(result){
			var res = JSON.parse(result);
			var data = res.data;
			if( res.error == 0 ){
				var country = data.country;
				/**
				 * 这里做个容错，如果没有该key对应的value，那么有可能是这一条已经被删除了
				 */
				if(self.destinationInfo[countryName] && country.destinationInfo)
				{
					self.destinationInfo[countryName] = country.destinationInfo;
				}
			}else{
			}
		});
	},
	
	//获取城市目的地须知
	getCityDestinationInfo : function(cityId, cityName)
	{
		var self = this;
		var params = {};
		params.cityId = cityId;
		var path = "common/getCityInfo";
		mnWebMain.httpRequest(path, params, function(result){
			var res = JSON.parse(result);
			var data = res.data;
			if( res.error == 0 ){
				var city = data.city;
				/**
				 * 这里做个容错，如果没有该key对应的value，那么有可能是这一条已经被删除了
				 */
				if(self.destinationInfo[cityName] && city.destinationInfo)
				{
					self.destinationInfo[cityName] = city.destinationInfo;
				}
			}else{
			}
		});
	},
};
