/*
 * ==============================
 *  团详情
 * ==============================
 */


// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

// 2. 调用Controller
app.controller('ctrl',function($scope){
	
	mnWebMain.cbBridgeInited = function(){
		GroupDetailsController.id = _utility.getQueryString("id");
		GroupDetailsController.init($scope);
	};
    
    mnWebMain.cbViewWillAppear = function(){
    };
});

var GroupDetailsController = {
	
	scope : null,
	
	id : null,
	groupObj : {},
	groupIcon : "",
	init : function($scope){
		
		$Loading.start();
		
		this.scope = $scope;
		
		this.getGroupDetail();
		
		this.bindClick();
	},
	
	getGroupDetail : function(){
		var self = this;
		
		var idsArr = [];
		idsArr.push(this.id);
		
		var params = {};
		params.ids = JSON.stringify(idsArr);
		
		mnWebMain.httpRequest(API_GET_GROUP_WITH_ID,params,function(data){
			var groups = JSON.parse(data).data.groups[self.id];
			
			self.groupObj.groupName = groups.groupName;
			self.groupObj.groupOwner = groups.groupOwner;
			self.groupObj.identificationCode = groups.identificationCode;
			self.groupObj.groupIcon = _utility.isEmpty(groups.groupIcon) ? DefaultGroupImg : JSON.parse(groups.groupIcon).url + IMG_CUT_WH2;
			self.groupIcon = _utility.isEmpty(groups.groupIcon) ? "" : JSON.parse(groups.groupIcon).url;
			self.groupObj.sTime = groups.startTime;
			self.groupObj.eTime = groups.endTime;
			self.groupObj.startTime = (groups.startTime.length > 10) ? groups.startTime.substring(0,10) : groups.startTime;
			self.groupObj.endTime = (groups.endTime.length > 10) ? groups.endTime.substring(0,10) : groups.endTime;
			self.groupObj.meetingTime = groups.meetingTime.substring(0,16);
			self.groupObj.dayLong = self.getDayLong(groups.startTime,groups.endTime) + 1;
			self.groupObj.startLocation = groups.startLocation;
			self.groupObj.endLocationArr = JSON.parse(groups.endLocation);
			self.groupObj.contacts = JSON.parse(groups.contacts);
			self.groupObj.guides = JSON.parse(groups.guides);
			self.groupObj.safetyInfo = groups.safetyInfo;
			self.groupObj.destinationInfo = groups.destinationInfo;
			self.groupObj.carryInfo = groups.carryInfo;
			
			self.scope.groupObj = self.groupObj;
			self.scope.$apply();
			
			$Loading.end();
		});
	},
	
	bindClick : function(){
		var self = this;
		self.scope.groupIconClick = function()
		{
			if(self.groupIcon)
			{
				var groupIconArr = [];
				groupIconArr.push(self.groupIcon);
				mnWebMain.browserPics(0, JSON.stringify(groupIconArr));
			}
			else
			{
				mnWebMain.toastInfo("没有头像信息！");
			}
		}
		self.scope.safeInfoClick = function(){
			saveLocalString(SAFETY_INFO,self.groupObj.safetyInfo);
			mnWebMain.openWebViewController(URL_GROUP_SAFE_NOTICE, "安全须知", {});
		};
		
		self.scope.destinationInfo = function(){
			saveLocalString(DESTIANTION_INFO_PRE,self.groupObj.destinationInfo);
			mnWebMain.openWebViewController(URL_GROUP_LOCA_NOTICE, "目的地须知", {});
		};
		
		self.scope.goodsNotice = function(){
            //本地没有存过
            if(_utility.isEmpty(getLocalString(CARRY_INFO_GROUPID)))
            {
            	var saveObj = {};
            	saveObj[self.id] = self.groupObj.carryInfo;
            	saveLocalString(CARRY_INFO_GROUPID,JSON.stringify(saveObj));
            }
            else
            {
            	var newString = JSON.parse(getLocalString(CARRY_INFO_GROUPID))[self.id];
            	//本地没有该团的记录
            	if(!newString)
            	{
            		var saveObj = JSON.parse(getLocalString(CARRY_INFO_GROUPID));
            		saveObj[self.id] = self.groupObj.carryInfo;
            		saveLocalString(CARRY_INFO_GROUPID,JSON.stringify(saveObj))
            	}
            }
            var headObj = {};
			headObj.rightTitle = "确定";
			var jumpUrl  = URL_GROUP_GOODS_NOTICE + "?type=2&groupId=" + self.id;
			mnWebMain.openWebViewController(jumpUrl, "携带物品须知", headObj);
		};
		
		self.scope.codeClick = function(code)
		{
			mnWebMain.showQWDialog(code);
		};
		
		self.scope.toTrip = function()
		{
			var headObj = {};
        	headObj.rightImage = "icon_edit";
        	var timeStr = self.groupObj.sTime.replace(/-/g, "/");
        	var timeStr2 = self.groupObj.eTime.replace(/-/g, "/");
        	var newStr = new Date(timeStr).getTime();
        	var newStr2 = new Date(timeStr2).getTime();
        	var currentTime = new Date().getTime();
        	var notend = (currentTime < newStr2) ? 1 : 0;
        	
        	var jumpUrl = JUMP_URL + "stroke_detail.html?id=" + self.id + "&day=" + self.groupObj.dayLong + "&startday=" + newStr + "&notend=" + notend + "&groupOwner=" + self.groupObj.groupOwner;
			mnWebMain.openWebViewController(jumpUrl, "行程详情", headObj);
		};
		
		self.scope.toChat = function()
		{
			mnWebMain.chat(2, self.id, self.groupObj.groupName);
		};
	},
	
	getDayLong : function(sTime , eTime){
		if(eTime && eTime.length >= 10)
		{
			var sTimeStamp = new Date(sTime.replace(/-/g, "/")).getTime();//出发时间戳
			var eTimeStamp = new Date(eTime.replace(/-/g, "/")).getTime();//结束时间戳
			var alongTimeStamp = (eTimeStamp - sTimeStamp) / 86400000;
			try{
  				alongTimeStamp = parseInt(alongTimeStamp);
			}
			catch(e)
			{
				alongTimeStamp = 0;
			}
			
			return alongTimeStamp;
		}
	},
	
}

$(".nav").on("tap",function(){
	if($(this).children().children("i").hasClass("active"))
	{
		$(this).children().children("i").removeClass('active');
		$(this).next("ul").hide();
	}
	else
	{
		$(this).children().children("i").addClass('active');
		$(this).next("ul").show();
	}
})