/*
 * ==============================
 *  携带物品须知
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

// 2. 调用Controller
app.controller('ctrl',function($scope){
	
	mnWebMain.cbBridgeInited = function(){
		GroupGoodsNoticeContoller.type = _utility.getQueryString("type");
		GroupGoodsNoticeContoller.groupId = _utility.getQueryString("groupId");
		GroupGoodsNoticeContoller.init($scope);
	};
    
    mnWebMain.cbNavRightClicked = function(){
    	GroupGoodsNoticeContoller.navRightClick();
    };
});

var GroupGoodsNoticeContoller = {
	
	//全局变量
	scope : null, 
	
	groupId : null,//团ID
	type : null,//跳转类型  1：表示创建团页面 2，团详情页面 3,团预览页面
	
	//数据模型
	selectedArr : [],
	unSelectedArr : [],
	
	init : function($scope)
	{
		
		this.scope = $scope;
		
		this.isHiddenBtn();
		
		this.getDataList();
		
		this.bindClick();
	},
	
	isHiddenBtn : function()
	{
		var btnClass = (this.type == 3) ? "hiddenIm" : "";
		this.scope.isHiddenBtn = btnClass;
		this.scope.$apply();
	},
	
	/**
	 * 获取列表
	 * @param {Object} 
	 * @param {Object} 
	 */
	getDataList : function()
	{
		var self = this;
		
		if(self.type == 2)
		{
			var data = JSON.parse(getLocalString(CARRY_INFO_GROUPID))[self.groupId];
		}
		else
		{
			var data = getLocalString(CARRY_INFO);
		}
		
		var dataArr = data.split(",");
		
		for(var i = 0 ; i < dataArr.length ; i ++)
		{
			if(dataArr[i].substring(0,1) == "-")
			{
				self.selectedArr.push(dataArr[i].substring(1,dataArr[i].length));
			}
			else
			{
				self.unSelectedArr.push(dataArr[i]);
			}
		}
		
		self.refreshProgress();
		self.upDateModel();
	},
	
	/**
	 * 所有点击事件
	 * @param {Object} 
	 * @param {Object} 
	 */
	bindClick : function()
	{
		var self = this;
		
		//全选
		self.scope.selectAll = function()
		{
			if(self.type == 2 || self.type == 1)
			{
				self.selectedArr = self.selectedArr.concat(self.unSelectedArr);
				self.unSelectedArr = [];
				
				self.refreshProgress();
				self.upDateModel();
			}
		};
		
		//全不选
		self.scope.unSelectAll = function()
		{
			if(self.type == 2 || self.type == 1)
			{
				self.unSelectedArr = self.unSelectedArr.concat(self.selectedArr);
				self.selectedArr = [];
				
				self.refreshProgress();
				self.upDateModel();
			}
		};
		
		//未完成列表的每一项的点击事件
		self.scope.unSelectedItemClick = function(index)
		{
			if(self.type == 2 || self.type == 1)
			{
				self.selectedArr.push(self.unSelectedArr[index]);
				self.unSelectedArr.splice(index,1);
				
				self.refreshProgress();
				self.upDateModel();
			}
		};
		
		//完成列表的每一项的点击事件
		self.scope.selectedItemClick = function(index)
		{
			if(self.type == 2 || self.type == 1)
			{
				self.unSelectedArr.push(self.selectedArr[index]);
				self.selectedArr.splice(index,1);
				
				self.refreshProgress();
				self.upDateModel();
			}
		};
		
		self.scope.addItem = function()
		{
			var arr = ["取消","确定"];
			mnWebMain.showDialog(1, "提示", "", arr, function(result)
			{
				var resultJson = JSON.parse(result);
				var data = resultJson.data;
				if(resultJson.error == 0)
				{
					var index = data.index;
					if(index == 1)
					{
						self.unSelectedArr.push(data.inputContent);
						self.refreshProgress();
						self.upDateModel();
					}
				}
			});
		}
	},
	
	/**
	 * 计算百分比
	 * @param {Object} 
	 * @param {Object} 
	 */
	refreshProgress : function(){
		var self = this;
		
		var total = self.selectedArr.length + self.unSelectedArr.length;
		var selectedLen = self.selectedArr.length;
		var percent = parseInt(selectedLen / total * 100) + '%';
		self.scope.percent = percent;
	},
	
	/**
	 * 更新数据模型
	 * @param {Object} 
	 * @param {Object} 
	 */
	upDateModel : function()
	{
		this.scope.selectedArr = this.selectedArr;
		this.scope.unSelectedArr = this.unSelectedArr;
		this.scope.$apply();
	},
	
	/**
	 * navbar确定的点击事件
	 * @param {Object} 
	 * @param {Object} 
	 */
	navRightClick : function()
	{
		var arr = [];
		var self = this;
		for(var i = 0 ; i < self.selectedArr.length ; i ++)
		{
			var item = '-' + self.selectedArr[i];
			arr.push(item);
		}
		for(var i = 0 ; i < self.unSelectedArr.length ; i ++)
		{
			var item = self.unSelectedArr[i];
			arr.push(item);
		}
		
		var newStr = arr.join(",");
		
		if(self.type == 2)
		{
			var locaObj = JSON.parse(getLocalString(CARRY_INFO_GROUPID));
			locaObj[self.groupId] = newStr;
			saveLocalString(CARRY_INFO_GROUPID,JSON.stringify(locaObj));
		}
		else if(self.type == 1)
		{
			mnWebMain.transferData(newStr);
		}
		else
		{
		}
		
		
		mnWebMain.closeSelfViewController(0);
	}
}
