/*
 * ==============================
 *  主页 - 游客
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope){
	
	mnWebMain.cbBridgeInited = function(){
		HomeController.init($scope);
	};
    
    mnWebMain.cbViewWillAppear = function(){
    	HomeController.isLogin();//每次进入页面判断登录状态
    	
    	if(HomeController.isRefresh)
    	{
    		HomeController.isRefresh = false;
    		HomeController.getMyAnswer();
    		HomeController.getQuestion();
    		HomeController.getGroupStart();
			HomeController.getGroupUnStart();
			HomeController.getGroupFinish();
    	}
    };
});

var HomeController = {
	
	//全局变量
	scope : null,
	isRefresh : false,//是否刷新当前页面
	hasLogin : false,
	swiperGroup : null,
	
	//数据模型
	hotQuesArr : [],
	
	//初始化
	init : function($scope){
		
		this.scope = $scope;
		
		this.getTab();
		
		getBanner(2);
		
		this.isLogin();
		
		this.getMyAnswer();
		
		this.getQuestion();
		
		this.bindClick();
		
		this.ngRepeatFinish();
		
		this.getGroupStart();
		
		this.getGroupUnStart();
		
		this.getGroupFinish();
	},
	
	//判断是否登录
	isLogin : function(){
		
		this.hasLogin = (_utility.isEmpty(getUserId())) ? false : true;
		
	},
	
	getTab : function(){
		this.scope.tabArr = tabArr;
		this.scope.$apply();
	},
	
	//获取我的提问
	getMyAnswer : function(){
		var self = this;
		
		if(_utility.isEmpty(getUserId()))
		{
			self.showAnswerSta(0);
			return;
		}
		
		var params = {};
		params.type = 0;
		params.startIndex = 0;
		params.num = 1;
		
		mnWebMain.httpRequest(API_GET_MY_RESPONSE,params,function(data){
			var anwObj = {};
			var questionReply = JSON.parse(data).data.questionReply;
			
			if(questionReply.length == 0)
			{
				self.showAnswerSta(1);
				return;
			}
			
			var praiseNum = questionReply[0].praiseNum;
			if( praiseNum > 999 ){
				var len = praiseNum.length;
				praiseNum = praiseNum.substring(0, len - 3) + "k";
			}
			
			var criticismNum = questionReply[0].criticismNum;
			if( criticismNum > 999 ){
				var len = criticismNum.length;
				criticismNum = criticismNum.substring(0, len - 3) + "k";
			}
			
			anwObj.questionId = questionReply[0].questionId;
			anwObj.praiseNum = praiseNum;
			anwObj.criticismNum = criticismNum;
			anwObj.question = questionReply[0].question;
			
			self.scope.anwObj = anwObj;
			self.scope.$apply();
			
			self.showAnswerSta(2);
			
		})
	},
	
	//获取未回答的问题
	getQuestion : function(){
		var self = this;
		
		var params = {};
		params.type = 0;
		params.startIndex = 0;
		params.num = 1;
		
		mnWebMain.httpRequest(API_GET_QUESTION_WITH_TYPE,params,function(data){
			var ques = JSON.parse(data).data.questionObjArr;
			if(ques.length == 0)
			{
				self.showQuestionSta(0);
				return;
			}
			
			ques[0].isHidden = (ques[0].replyNum > 0) ? "hidden" : "";
			self.scope.quesObj = ques[0];
			self.scope.$apply();
			
			self.showQuestionSta(1);
		});
	},
	
	bindClick : function(){
		var self = this;
		
		self.scope.toCreateQues = function(){
			if(self.hasLogin)
			{
				self.isRefresh = true;
				var headObj = {}; 
				headObj.leftTitle = "取消";
				headObj.rightTitle = "发布";
				
	    		mnWebMain.openWebViewController(URL_PUBLISH_QUES + "?type=2", "我要提问", headObj);
			}
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			
		};
		
		self.scope.toAnswerQuestion = function()
		{
			if(self.hasLogin)
			{
				self.isRefresh = true;
				var headObj = {}; 
	    		mnWebMain.openWebViewController(URL_QUESTION_FORANSWER, "我要回答", headObj);
			}
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
		};
		
		self.scope.toCreateGroup = function()
		{
			if(self.hasLogin)
			{
				self.isRefresh = true;
				//创建团
				var arr = ['普通创建', '模版创建','取消'];
				mnWebMain.showDialog(2, "", "", arr, function(result)
				{
					var resultJob = JSON.parse(result);
					var error = resultJob.error;
					if(error == 0)
					{
						var data = resultJob.data;
						var index = data.index;
						if(index == 0)
						{
							//普通创建团
			    			var headObj = {};
			    			headObj.leftTitle = "取消";
			    			headObj.rightTitle = "预览";
			    			headObj.pageId = RESORTS_1;
		    				mnWebMain.openWebViewController(URL_GROUP_CREATE, "创建团", headObj);
							
						}
						else if(index == 1)
						{
							//模版创建团
							var headObj = {};
							mnWebMain.openWebViewController(URL_GROUP_TEMPLATE, "团模版", headObj);
						}
						else
						{
							//取消
						}
					}
				});
			}
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
		};
		
		self.scope.myAnswerMore = function()
		{
			if(self.hasLogin)
			{
				self.isRefresh = true;
				var headObj = {};
	    		mnWebMain.openWebViewController(URL_QUESTION_MYANSWER, "我的回答", headObj);
			}
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
		};
		
		self.scope.myQuestionMore = function()
		{
			if(self.hasLogin)
			{
				self.isRefresh = true;
				var headObj = {};
	    		mnWebMain.openWebViewController(URL_MY_QUESTION, "我的提问", headObj);
			}
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
		};
		
		self.scope.tabItemClick = function(index){
			self.swiperGroup.slideTo(index);
			self.changeNavStyle(index);
		};
		
		self.scope.itemGroupClick = function(id){
			if(self.hasLogin)
			{
				var jumpUrl = URL_GROUP_DETAILS + "?id=" + id;
				mnWebMain.openWebViewController(jumpUrl, "团队详情", {});
			}
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
		};
		
		self.scope.toQuestionDetails = function(id){
			if(self.hasLogin)
			{
				var jumpUrl = URL_QUESTION_DETAILS + "?id=" + id;
				mnWebMain.openWebViewController(jumpUrl, "问题详情", {});
			}
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
		};
		
		self.scope.toChat = function(id,groupName,$event)
		{
			$event.stopPropagation();
			mnWebMain.chat(2, id, groupName);
		}
	},
	
	getGroupStart : function(){
		var self = this;
		
		var params = {};
		params.type = 2;
		params.startIndex = 0;
		params.num = 5;
		
		mnWebMain.httpRequest(API_GET_GROUPS,params,function(data){
			var groups = JSON.parse(data).data.groups;
			
			if(groups.length == 0)
			{
				$(".one-un").show();
				self.swiperInit();
				return;
			}
			
			$(".one-un").hide();
			var groupArr = [];
			
			for(var i = 0 ; i < groups.length;i ++)
			{
				var itemObj = {};
				itemObj.id = groups[i].id;
				itemObj.groupIcon = _utility.isEmpty(groups[i].groupIcon) ? DefaultGroupImg : JSON.parse(groups[i].groupIcon).url + IMG_CUT_WH2;
				itemObj.groupName = groups[i].groupName;
				itemObj.startTime = groups[i].startTime.substring(0,11);
				itemObj.membersNum = _utility.isEmpty(groups[i].members) ? 0 : JSON.parse(groups[i].members).length + 1;
				
				groupArr.push(itemObj);
			}
			
			self.scope.groupArr1 = groupArr;
			self.scope.$apply();
		})
	},
	
	getGroupUnStart : function(){
		var self = this;
		
		var params = {};
		params.type = 1;
		params.startIndex = 0;
		params.num = 5;
		
		mnWebMain.httpRequest(API_GET_GROUPS,params,function(data){
			var groups = JSON.parse(data).data.groups;
			
			if(groups.length == 0)
			{
				$(".two-un").show();
				self.swiperInit();
				return;
			}
			
			$(".two-un").hide();
			var groupArr = [];
			
			for(var i = 0 ; i < groups.length;i ++)
			{
				var itemObj = {};
				itemObj.id = groups[i].id;
				itemObj.groupIcon = _utility.isEmpty(groups[i].groupIcon) ? DefaultGroupImg : JSON.parse(groups[i].groupIcon).url + IMG_CUT_WH2;
				itemObj.groupName = groups[i].groupName;
				itemObj.startTime = groups[i].startTime.substring(0,11);
				itemObj.membersNum = _utility.isEmpty(groups[i].members) ? 0 : JSON.parse(groups[i].members).length + 1;
				
				groupArr.push(itemObj);
			}
			
			self.scope.groupArr2 = groupArr;
			self.scope.$apply();
		})
	},
	
	getGroupFinish : function(){
		var self = this;
		
		var params = {};
		params.type = 3;
		params.startIndex = 0;
		params.num = 5;
		
		mnWebMain.httpRequest(API_GET_GROUPS,params,function(data){
			var groups = JSON.parse(data).data.groups;
			
			if(groups.length == 0)
			{
				$(".three-un").show();
				self.swiperInit();
				return;
			}
			
			$(".three-un").hide();
			var groupArr = [];
			
			for(var i = 0 ; i < groups.length;i ++)
			{
				var itemObj = {};
				itemObj.id = groups[i].id;
				itemObj.groupIcon = _utility.isEmpty(groups[i].groupIcon) ? DefaultGroupImg : JSON.parse(groups[i].groupIcon).url + IMG_CUT_WH2;
				itemObj.groupName = groups[i].groupName;
				itemObj.startTime = groups[i].startTime.substring(0,11);
				itemObj.membersNum = _utility.isEmpty(groups[i].members) ? 0 : JSON.parse(groups[i].members).length + 1;
				
				groupArr.push(itemObj);
			}
			
			self.scope.groupArr3 = groupArr;
			self.scope.$apply();
		})
	},
	
	ngRepeatFinish : function(){
		var self = this;
		
		this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
			self.swiperInit();
			$(".one-has").show();
		});
	},
	
	//swiper初始化
	swiperInit : function(){
		var self = this;
		
		this.swiperGroup = new Swiper('.swiper-group', {
		    paginationClickable: true,
		    autoHeight: 'auto',
		    onSlideNextStart : function(swiper){
		    	self.changeNavStyle(swiper.activeIndex);
		    },
		    onSlidePrevStart : function(swiper){
		    	self.changeNavStyle(swiper.activeIndex);
		    },
		});
	},
	
	changeNavStyle : function(index){
		
		var cq =  100 * index + "%";
		$(".tabline").css({'-webkit-transform':'translateX('+cq+')'});
		$(".tab-item").removeClass("active");
		$(".tab-item").eq(index).addClass('active');
		
	},
	
	showAnswerSta : function(index){
		$(".anwitem").hide();
		$(".anwitem").eq(index).show();
	},
	
	showQuestionSta : function(index){
		$(".qitem").hide();
		$(".qitem").eq(index).show();
	},
	
};

var tabArr = [
    {
   	    id : "0",
        className : "active",
        tabName : "进行中"
    },
    {
   	    id : "1",
        className : "",
        tabName : "未开始"
    },
    {
   	    id : "2",
        className : "",
        tabName : "已完成"
    }
];
