/*
 * ==============================
 *  主页 - 游客
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope){
	
	mnWebMain.cbBridgeInited = function(){
		HomeController.init($scope);
	};
    
    mnWebMain.cbViewWillAppear = function(){
    	if(HomeController.isRefresh)
    	{
    		HomeController.getOneQuestion();
    	}
    };
});

var HomeController = {
	
	//全局变量
	scope : null,
	isRefresh : false,
	
	//swiper 
	swiperRecommandOrange : null,
	
	//数据模型
	hotQuesArr : [],
	
	//初始化
	init : function($scope){
		
		this.scope = $scope;
		
		getBanner(1);
		
		this.getRecommandOrange();
		
		this.isLogin();
		
		this.getHotQuestion();
		
		this.bindClick();
		
		this.ngRepeatFinish();
	},
	
	isLogin : function(){
		if(_utility.isEmpty(getUserId()))
		{
			this.showQuestionSta(0);
			return;
		}
		
		this.getOneQuestion();
	},
	
	getOneQuestion : function(){
		var self = this;
		
		var params = {};
		params.type = 0;
		params.startIndex = 0;
		params.num = 1;
		
		mnWebMain.httpRequest(API_GET_QUESTION_WITH_TYPE,params,function(data){
			var ques = JSON.parse(data).data.questionObjArr;
			if(ques.length == 0)
			{
				self.showQuestionSta(1);
				return;
			}
			
			ques[0].isHidden = (ques[0].replyNum > 0) ? "hidden" : "";
			self.scope.quesObj = ques[0];
			self.scope.$apply();
			
			self.showQuestionSta(2);
		});
	},
	
	//获取推荐桔子
	getRecommandOrange : function(){
		var self = this;
		
		var params = {};
		params.startIndex = 0;
		params.num = 10;
		
		var recArr = [];
		
		mnWebMain.httpRequest(API_GET_RECOMMABND_GUIDES,params,function(data){
			var recommendArr = JSON.parse(data).data.recommendArr;
			
			if(recommendArr.length == 0)
			{
				$(".no-orange").show();
				return;
			}
			
			for(var i = 0 ; i < recommendArr.length ; i ++)
			{
				var itemObj = {};
				itemObj.userId = recommendArr[i].userId;
				itemObj.icon = _utility.isEmpty(recommendArr[i].icon) ? DefaultGudiesIcon : JSON.parse(recommendArr[i].icon).url + IMG_CUT_WH;
				itemObj.nickName = recommendArr[i].nickName;
				//等级
				var iconName = 'a15.png';
				var status = recommendArr[i].status;
				var orangerLv = recommendArr[i].lv;
				if (orangerLv == 0) {
					iconName = 'b1.png';
				}
				if (4 == parseInt(status) && orangerLv != 0) {
					iconName = 'a' + orangerLv + '.png';
				} else if (orangerLv != 0) {
					iconName = 'b' + orangerLv + '.png';
				}
				itemObj.level = PATH_LEVEL_ICON + iconName;
				itemObj.lv = "Lv" + recommendArr[i].lv;
				recArr.push(itemObj);
			}
			
			self.scope.recArr = recArr;
			self.scope.$apply();
		})
	},
	
	getHotQuestion : function(){
		var self = this;
		
		mnWebMain.httpRequest(API_GET_HOT_QUESTIONS,{},function(data){
			self.hotQuesArr = [];
			var questionObjArr = JSON.parse(data).data.questionObjArr;
			
			if(questionObjArr.length == 0)
			{
				$(".c-list-data").show();
				return;
			}
			
			for(var i = 0 ; i < questionObjArr.length ; i ++)
			{
				var itemObj = {};
				itemObj.id = questionObjArr[i].id;
				itemObj.questionContent = questionObjArr[i].questionContent;
				var praiseNum = questionObjArr[i].praiseNum;
				if( praiseNum > 999 )
				{
					var len = praiseNum.length;
					praiseNum = praiseNum.substring(0, len - 3) + "k";
				}
				itemObj.praiseNum = praiseNum;
				
				self.hotQuesArr.push(itemObj);
			}
			
			self.scope.hotQuesArr = self.hotQuesArr;
			self.scope.$apply();
		});
	},
	
	bindClick : function(){
		var self = this;
		
		//点击去登陆
		this.scope.toLogin = function(){
			mnWebMain.openViewController("TOLoginNavigationController");
		};
		
		//点击我要提问
		this.scope.toCreateQues = function(){
		    if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			
			self.isRefresh = true;
			var headObj = {}; 
			headObj.leftTitle = "取消";
			headObj.rightTitle = "发布";
			
    		mnWebMain.openWebViewController(URL_PUBLISH_QUES + "?type=1", "我要提问", headObj);
		};
		
		//点击加入团
		this.scope.joinGroup = function(){
			if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			mnWebMain.openWebViewController(URL_JOIN_GROUP,"加入团");
		};
		
		this.scope.findOrange = function(){
			if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			
			mnWebMain.setTabbarSelectedIndex("1");//跳转桔树页面
		};
		
		this.scope.quesItemClick = function(id){
			if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			var jumpUrl = URL_QUESTION_DETAILS + "?id=" + id;
			mnWebMain.openWebViewController(jumpUrl,"问题详情");
		};
		
		this.scope.toMyQuestion = function(){
			if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			mnWebMain.openWebViewController(URL_MY_QUESTION, "我的提问");
		};
		
		this.scope.personalClick = function(id){
			if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			var jumpUrl = URL_PERSONAL_DETAILS + "?userId=" + id;
			mnWebMain.openWebViewController(jumpUrl, "个人详情");
		};
		
		this.scope.hotQuesItemClick = function(id){
			if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			var jumpUrl = URL_QUESTION_DETAILS + "?id=" + id;
			mnWebMain.openWebViewController(jumpUrl, "问题详情", {});
		};
		this.scope.moreRecommendGuide = function()
		{
			if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			var jumpUrl = URL_ORANGE_RECOMMEND;
			mnWebMain.openWebViewController(jumpUrl, "推荐桔子", {});
		};
		this.scope.moreHotQuestion = function()
		{
			if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			var jumpUrl = URL_QUESTION_ALL;
			mnWebMain.openWebViewController(jumpUrl, "所有问题", {});
		};
	},
	
	ngRepeatFinish : function(){
		var self = this;
		
		this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
			self.swiperInit();
		});
	},
	
	//推荐桔子swiper初始化
	swiperInit : function(){
		
		if(this.swiperRecommandOrange != null)
		{
			this.swiperRecommandOrange = null;
		}
		
		this.swiperRecommandOrange = new Swiper('.swiper-orange', {
	        slidesPerView: 'auto',
	        spaceBetween: 20
	    });
	},
	
	//提问模块状态显示
	showQuestionSta : function(index){
		$(".qitem").hide();
		$(".qitem").eq(index).show();
	}
}
