/*
 * ==============================
 *  主页 - 游客
 * ==============================
 */


// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope){
	mnWebMain.cbBridgeInited = function(){
		JoinGroupController.init($scope);
	};
    
});

var JoinGroupController = {
	
	//全局变量
	scope : null,
	isRefresh : false,
	
	//数据模型
	classModel : {
		isRead : true,
		btnClass : true,
	},
	
	//初始化
	init : function($scope){
		
		$Loading.start();
		
		this.scope = $scope;
		
		this.bindModel();
		
		this.getRecommandOrange();
		
		this.bindClick();
		
		this.ngRepeatFinish();
	},
	
	bindModel : function(){
		this.scope.classModel = this.classModel;
		this.scope.$apply();
	},
	
	//获取推荐桔子
	getRecommandOrange : function(){
		var self = this;
		
		var params = {};
		params.startIndex = 0;
		params.num = 10;
		
		var recArr = [];
		
		mnWebMain.httpRequest(API_GET_RECOMMABND_GUIDES,params,function(data){
			var recommendArr = JSON.parse(data).data.recommendArr;
			
			if(recommendArr.length == 0)
			{
				$(".no-orange").show();
				$Loading.end();
				return;
			}
			for(var i = 0 ; i < recommendArr.length ; i ++)
			{
				var itemObj = {};
				itemObj.userId = recommendArr[i].userId;
				itemObj.icon = _utility.isEmpty(recommendArr[i].icon) ? DefaultGudiesIcon : JSON.parse(recommendArr[i].icon).url;
				itemObj.nickName = recommendArr[i].nickName;
				//等级
				var iconName = 'a15.png';
				var status = recommendArr[i].status;
				var orangerLv = recommendArr[i].lv;
				if (orangerLv == 0) {
					iconName = 'b1.png';
				}
				if (4 == parseInt(status) && orangerLv != 0) {
					iconName = 'a' + orangerLv + '.png';
				} else if (orangerLv != 0) {
					iconName = 'b' + orangerLv + '.png';
				}
				itemObj.level = PATH_LEVEL_ICON + iconName;
				itemObj.lv = "Lv" + recommendArr[i].lv;
				recArr.push(itemObj);
			}
			
			self.scope.recArr = recArr;
			self.scope.$apply();
		})
	},
	
	
	bindClick : function(){
		var self = this;
		
		self.scope.toScanCode = function(){
			mnWebMain.openViewController("QRCodeReaderViewController");
		};
		
		self.scope.readRule = function(){
			self.classModel.isRead = !self.classModel.isRead;
			self.classModel.btnClass = !self.classModel.btnClass;
		};
		
		self.scope.toJoin = function(){
			if(self.classModel.btnClass)
			{
				if($("#groupCode").val() == "")
				{
					mnWebMain.toastInfo("请先输入团识别码！");
					return;
				}
				
				self.applyGroup($("#groupCode").val())
			}
		};
		this.scope.personalClick = function(id){
			if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			var jumpUrl = URL_PERSONAL_DETAILS + "?userId=" + id;
			mnWebMain.openWebViewController(jumpUrl, "个人详情");
		};
		this.scope.moreRecommendGuide = function()
		{
			if(_utility.isEmpty(getUserId()))
			{
				mnWebMain.openViewController("TOLoginNavigationController");
				return;
			}
			var jumpUrl = URL_ORANGE_RECOMMEND;
			mnWebMain.openWebViewController(jumpUrl, "推荐桔子", {});
		};
	},
	
	applyGroup : function(identificationCode){
		mnWebMain.showProgressDialog("正在加入团....");
		var self = this;
		var params = {};
		params.identificationCode = identificationCode;
		
		mnWebMain.httpRequest(API_APPLY_GROUP,params,function(data){
			mnWebMain.dismissProgressDialog();
			var res = JSON.parse(data);
			if( res.error == 0)
			{
				mnWebMain.toastInfo("您的入团申请已经提交，请等待桔子的审核！");
			}
			else
			{
				mnWebMain.toastInfo(res.errMsg);
			}
		});
	},
	
	ngRepeatFinish : function(){
		var self = this;
		
		this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
			$Loading.end();
			self.swiperInit();
		});
	},
	
	//推荐桔子swiper初始化
	swiperInit : function(){
		var swiper = new Swiper('.swiper-orange', {
	        slidesPerView: 3.5,
	        spaceBetween: 20,
	        freeMode: true,
	        preventLinksPropagation : false,
	        touchMoveStopPropagation : false
	    });
	},
	
}
