/*
 * ==============================
 *  我的问题
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope){
	
	mnWebMain.cbBridgeInited = function(){
		MyQuestionController.init($scope);
	};
});


var MyQuestionController = {
	
	scope : null,
	swiperGroup : null,
	
	//数据模型
	myQuesArr : [],
	
	init : function($scope){
		
		$Loading.start();
		
		this.scope = $scope;
		
		this.bindModel();
		
		this.swiperInit();
		
		this.bindClick();
		
		this.getAllQuestionList();
		
		this.getHasQuestionList();
		
		this.getUnQuestionList();
		
		this.ngRepeatFinish();
	},
	
	bindModel : function(){
		
		this.scope.tabArr = tabArr;
		this.scope.$apply();
		
	},
	
	bindClick : function(){
		var self = this;
		
		self.scope.tabClick = function(id){
			self.changeNavStyle(id);
			self.swiperGroup.slideTo(id);
		};
		self.scope.allQClick = function(id)
		{
			var jumpUrl = URL_QUESTION_DETAILS + "?id=" + id;
			mnWebMain.openWebViewController(jumpUrl, "问题详情", {});
		};
		self.scope.allHasClick = function(id)
		{
			var jumpUrl = URL_QUESTION_DETAILS + "?id=" + id;
			mnWebMain.openWebViewController(jumpUrl, "问题详情", {});
		};
		self.scope.allUnClick = function(id)
		{
			var jumpUrl = URL_QUESTION_DETAILS + "?id=" + id;
			mnWebMain.openWebViewController(jumpUrl, "问题详情", {});
		};
	},
	
	getAllQuestionList : function(){
		
		var self = this;
		
		var params = {};
		params.type = 0;
		params.startIndex = 0;
		params.num = 100000;
		
		mnWebMain.httpRequest(API_GET_QUESTION_WITH_TYPE,params,function(data){
			var result = JSON.parse(data);
			if( result.error == 0 ){
				
				self.myQuesArr = result.data.questionObjArr;
				
				if(self.myQuesArr.length == 0)
				{
					$("#unData1").show();
					$Loading.end();
					return;
				}
				
				for(var i = 0 ; i < self.myQuesArr.length ;i++)
				{
					try
					{
						self.myQuesArr[i]["questionTime"] = self.myQuesArr[i]["questionTime"].split(" ")[0];
					}catch(e){
					}
					self.myQuesArr[i]["questionLabels"] = JSON.parse(self.myQuesArr[i]["questionLabels"])
				}
				
				self.scope.myQuesArr1 = self.myQuesArr;
				self.scope.$apply();
			}
		})
	},
	
	getHasQuestionList : function(){
		
		var self = this;
		
		var params = {};
		params.type = 2;
		params.startIndex = 0;
		params.num = 100000;
		
		mnWebMain.httpRequest(API_GET_QUESTION_WITH_TYPE,params,function(data){
			var result = JSON.parse(data);
			if( result.error == 0 ){
				
				self.myQuesArr = result.data.questionObjArr;
				
				if(self.myQuesArr.length == 0)
				{
					$("#unData2").show();
					$Loading.end();
					return;
				}
				
				for(var i = 0 ; i < self.myQuesArr.length ;i++)
				{
					try
					{
						self.myQuesArr[i]["questionTime"] = self.myQuesArr[i]["questionTime"].split(" ")[0];
					}catch(e){
					}
					self.myQuesArr[i]["questionLabels"] = JSON.parse(self.myQuesArr[i]["questionLabels"])
				}
				
				self.scope.myQuesArr2 = self.myQuesArr;
				self.scope.$apply();
			}
		})
	},
	
	getUnQuestionList : function(){
		var self = this;
		
		var params = {};
		params.type = 1;
		params.startIndex = 0;
		params.num = 100000;
		
		mnWebMain.httpRequest(API_GET_QUESTION_WITH_TYPE,params,function(data){
			var result = JSON.parse(data);
			if( result.error == 0 ){
				
				self.myQuesArr = result.data.questionObjArr;
				if(self.myQuesArr.length == 0)
				{
					$("#unData3").show();
					$Loading.end();
					return;
				}
				
				for(var i = 0 ; i < self.myQuesArr.length ;i++)
				{
					try
					{
						self.myQuesArr[i]["questionTime"] = self.myQuesArr[i]["questionTime"].split(" ")[0];
					}catch(e){
					}
					self.myQuesArr[i]["questionLabels"] = JSON.parse(self.myQuesArr[i]["questionLabels"])
				}
				
				self.scope.myQuesArr3 = self.myQuesArr;
				self.scope.$apply();
			}
		})
	},
	
	swiperInit : function(){
		
		var self = this;
		this.swiperGroup = new Swiper('.swiper-container', {
		    paginationClickable: true,
		    autoHeight: 'auto',
		    onSlideNextStart : function(swiper){
		    	self.changeNavStyle(swiper.activeIndex);
		    },
		    onSlidePrevStart : function(swiper){
		    	self.changeNavStyle(swiper.activeIndex);
		    },
		});
	},
	
	changeNavStyle : function(index){
		var cq =  100 * index + "%";
		$(".line").css({'-webkit-transform':'translateX('+cq+')'});
		$(".tab-item span").removeClass("active");
		$(".tab-item").eq(index).children().addClass('active');
	},
	
	ngRepeatFinish : function(){
		var self = this;
		
		this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
			$Loading.end();
		});
	},
}
