
/*
 * ==============================
 *  个人详情
 * ==============================
 */


// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

// 2. 调用Controller
app.controller('ctrl',function($scope){
	
	mnWebMain.cbBridgeInited = function(){
		PersonalController.userId = _utility.getQueryString("userId");
		PersonalController.isHide = _utility.getQueryString("isHide");

		PersonalController.init($scope);
	};


	//点击单聊界面的查看个人详情隐藏发消息按钮
//            mnWebMain.hideBtnSend = function()
//            {
//                 mnWebMain.toastInfo("进入隐藏消息按钮！");
//            };
    
});

var PersonalController = {
	
	//全局变量
	scope : null,
	userId : null,//这个导游的id
	isHide:null,
	
	//数据模型
	userObj : {},
	userIcon : "",
	//初始化
	init : function($scope){
		
		this.scope = $scope;
		
		this.getUserInfo();
		
		this.bindClick();
		
	},
	
	getUserInfo : function(){



		var self = this;
		
		var idArr = new Array();
		idArr.push(this.userId);
		
		var params = {};
	    params.userIds = JSON.stringify(idArr);
	    
	    mnWebMain.httpRequest(API_GET_USEROBJ_BY_ID,params,function(data){
	    	var userObjArr = JSON.parse(data).data.userObjArr[self.userId];
	    	
	    	self.userObj.nickName = userObjArr.nickName;
	    	self.userObj.icon = _utility.isEmpty(userObjArr.icon) ? DefaultGudiesIcon : JSON.parse(userObjArr.icon).url + IMG_CUT_WH;
	    	self.userIcon = _utility.isEmpty(userObjArr.icon) ? "" : JSON.parse(userObjArr.icon).url;//大图
	    	self.userObj.sexClass = (userObjArr.gender == 0) ? "male" : "female";
	    	self.userObj.lvIcon = self.getLevelIcon(userObjArr.lv,userObjArr.status);
	    	self.userObj.selfEvaluation = userObjArr.selfEvaluation ? userObjArr.selfEvaluation.split("、") : [];
	    	self.userObj.lifeMotto = _utility.isEmpty(userObjArr.lifeMotto) ? "无" : userObjArr.lifeMotto;
	    	self.userObj.familiarPlace = userObjArr.familiarPlace ? userObjArr.familiarPlace : "无";
	    	
	    	var eva = userObjArr.evaluation;
			if (eva && (eva != 0.00 || eva != 0)) {
				eva = "好评率：" + accMul(parseFloat(eva), 20) + "%";
			} else {
				eva = '暂无';
			}
			self.userObj.eva = eva;
	    	
	    	self.scope.userObj = self.userObj;
	    	self.scope.$apply();
	    	
	    	self.isAttention();
	    	self.getLanguage(userObjArr.legallyLanguages);
	    	self.getFootprintImages(userObjArr.footMarks,self.userId);

	    	//self.hideBtnSend();
	    	if(self.isHide)
	    	{
	    	//mnWebMain.toastInfo("isHide1=="+self.isHide);
	    	   // $("#btn-send ripple").hide();

	    	   self.userObj.myChat = true;

	    	}else
	    	{
	    	//mnWebMain.toastInfo("isHide2=="+self.isHide);
	    	   //$("#btn-send ripple").show();
	    	    self.userObj.myChat = false;
	    	}


	    })
	},
	isAttention : function()
	{
		var self = this;
		var params = {};
		var myUserId = getUserId();
		params.userId = myUserId;
		params.startIndex = 0;
		params.num = 10000;
		var path = API_GET_FOCUS_GUIDE;
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			var attention = "添加关注";
			if(resultJob.error == 0){
				var dataJob = resultJob.data;
				var count = dataJob.count;
				var focusArr = dataJob.focus;
				if(count != 0)
				{
					for(var i = 0; i < focusArr.length; i++)
					{
						if(self.userId == focusArr[i].userId)
						{
							attention = "取消关注";
							break;
						}
					}
				}
			}
			self.userObj.attention = attention;
			self.scope.$apply();
		});
	},
	getLanguage : function(langArr)
	{
		var self = this;
		
		if(_utility.isEmpty(langArr) || langArr.length == 0)
		{
			self.scope.languageStr = "无";
			self.scope.$apply();
		}
		else
		{
			var langArrValue = "";
			var params = {};
			params.ids = langArr;
			
			mnWebMain.httpRequest(API_GET_LANGUAGE,params,function(data){
				var languages = JSON.parse(data).data.languages;
				for(var i in languages)
				{
					langArrValue += languages[i].languageName + "、";
				}
				if(langArrValue)
				{
					langArrValue = langArrValue.substring(0, langArrValue.length - 1)
				}
				self.scope.languageStr = langArrValue;
				self.scope.$apply();
			})
		}
	},
	
	getFootprintImages : function(footMarks,userId){
		
		var params = {};
		params.ids = footMarks;
		
		mnWebMain.httpRequest(API_GET_FOOT_MARK,params,function(result){
			var res = JSON.parse(result);
			if( res.error == 0 ){
				var dataInfo = res.data;
				var data = dataInfo.footMarkObjArr;
				
				var list = '';
				var flag = 0;
				for(var i in data)
				{
					if(data[i].pics == "" || data[i].pics == undefined)
					{
						var pictureArr = [];
					}
					else
					{
						var pictureArr = JSON.parse(data[i].pics);
					}
					for(var j in pictureArr){
						if(flag < 4){
							flag += 1;
							var icon = pictureArr[j] + IMG_CUT_WH;
							list += '<span style="background-image: url('+icon+');"></span>';
						}else{
							break;
						}
					}
				}
				$("#footprintImg").html(list);
			}
		})
	},
	
	getLevelIcon : function(lv,status){
		if(lv == 0)
		{
			iconName = 'b1.png';
		}
		if(4 == parseInt(status) && lv != 0)
		{
			iconName = 'a' + lv + '.png';
		}
		else if(lv != 0)
		{
			iconName = 'b' + lv + '.png';
		}
		
		return PATH_LEVEL_ICON + iconName;
	},
	
	bindClick : function(){
		var self = this;
		this.scope.iconClick = function()
		{
			if(self.userIcon)
			{
				var iconArr = [];
				iconArr.push(self.userIcon);
				mnWebMain.browserPics(0, JSON.stringify(iconArr));
			}
			else
			{
				mnWebMain.toastInfo("没有头像信息！");
			}
		};
		this.scope.footprintClick = function()
		{
			var page_url = URL_FOOTPRINT +　"?guideId=" + self.userId;
			mnWebMain.openWebViewController(page_url, "他的足迹");
		};
		this.scope.evaClick = function()
		{
			var page_url = URL_GUIDE_EVA_LIST + "?guideId=" + self.userId
			mnWebMain.openWebViewController(page_url, "TA的评价");
		};
		this.scope.chatClick = function()
		{
			var myUserId = getUserId();
			if (myUserId) {
				mnWebMain.chat(1, self.userId, self.userObj.nickName);
			} else {
				mnWebMain.openViewController("TOLoginNavigationController"); //打开登录页面
			}
		};
		this.scope.attentionClick = function()
		{
			var myUserId = getUserId();
			if (myUserId)
			{
				var attention = self.userObj.attention;
				if("添加关注" == attention)
				{
					self.focusOP(1, self.userId);
				}
				else if("取消关注" == attention)
				{
					self.focusOP(2, self.userId);
				}
			} 
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController"); //打开登录页面
			}
		};
		
	},
	//关注&取消关注
	focusOP : function (OPType, userId)
	{
		var self = this;
		var params = {};
		params.OPType = OPType;
		params.userId = userId;
		var path = API_FOCUS_OP;
		mnWebMain.httpRequest(path, params, function(result){
			var res = JSON.parse(result);
			if( res.error == 0 ){
				mnWebMain.toastInfo("操作成功！");
				if(OPType == 1)
				{
					self.userObj.attention = "取消关注";
				}
				else if(OPType == 2)
				{
					self.userObj.attention = "添加关注";
				}
				self.scope.$apply();
			}else{
				mnWebMain.toastInfo("操作失败！");
			}
		});
	},

//	hideBtnSend : function()
//    	{
//    	//点击单聊界面的查看个人详情隐藏发消息按钮
//            mnWebMain.hideBtnSend = function()
//            {
//                 mnWebMain.toastInfo("进入隐藏消息按钮！");
//            };
//    	},
}
