/*
 * ==============================
 *  主页 - 游客
 * ==============================
 */


// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

// 2. 调用Controller
app.controller('ctrl',function($scope){
	
	mnWebMain.cbBridgeInited = function(){
		PublishQuestionController.userType = _utility.getQueryString("type");
		PublishQuestionController.init($scope);
	};
	
    mnWebMain.cbNavRightClicked = function(){
    	PublishQuestionController.publishQuestion();
    };
    
    mnWebMain.cbNavLeftClicked = function(){
		mnWebMain.closeSelfViewController(0);
	}
});

var PublishQuestionController = {
	
	//全局变量
	scope : null,
	
	userType : null,
	
	//数据模型
	tipArr : [],
	
	//初始化
	init : function($scope){
		
		this.scope = $scope;
	
		this.userType = getUserType();
		
		this.getTip();
		
		this.bindClick();
		
	},
	
	getTip : function(){
		var self = this;
		
		mnWebMain.httpRequest(API_GET_ALL_LABEL,{},function(data){
			var questionLabels = JSON.parse(data).data.questionLabels;
			
			for(var i = 0 ; i < questionLabels.length ; i ++)
			{
				var itemObj = {};
				itemObj.isAct = "";
				itemObj.id = questionLabels[i].id;
				itemObj.labelName = questionLabels[i].labelName;
				
				self.tipArr.push(itemObj);
			}
			
			self.scope.tipArr = self.tipArr;
			self.scope.$apply();
		})
		
	},
	
	bindClick : function(){
		var self = this;
		
		self.scope.itemLabelClick = function(id){
			for(var i = 0 ; i < self.tipArr.length ; i ++)
			{
				if(self.tipArr[i].id == id)
				{
					self.tipArr[i].isAct = (self.tipArr[i].isAct == "active") ? "" : "active";
				}
			}
			
			self.scope.$apply();
		}
	},
	
	publishQuestion : function(){
		var question = $("#inputQuestion").val();
		
		if(question == "")
		{
			mnWebMain.toastInfo("请输入您的问题！");
			return;
		}
		if(question.length < 10)
		{
			mnWebMain.toastInfo("问题不得少于10个字符！");
			return;
		}
		
		var lableArr = [];
		for(var i = 0 ; i < this.tipArr.length; i ++)
		{
			if(this.tipArr[i].isAct == "active")
			{
				lableArr.push(this.tipArr[i].labelName);
			}
		}
		
		var params = {};
		params.questionContent = question;
		params.questionLabels = JSON.stringify(lableArr);
		params.questionLocation = "";
		
		var api = (this.userType == "1") ? API_PUBLISH_QUESTION_VISITOR : API_PUBLISH_QUESTION_GUIDE;
		mnWebMain.showProgressDialog("正在发布....");
		mnWebMain.httpRequest(api,params,function(data){
			mnWebMain.dismissProgressDialog(); 
			var res = JSON.parse(data);
			if( res.error == 0 )
			{
				mnWebMain.toastInfo("提问成功！");
				mnWebMain.closeSelfViewController(0);
			}
			else
			{
				mnWebMain.toastInfo(res.errMsg);
			}
		});
	},
}
