/*
 * ==============================
 *  所有问题
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		mnWebMain.refresh("2");
		QuestionAllController.init($scope);
	};
	mnWebMain.cbDownRefreshData = function()
	{
		QuestionAllController.setDefaultData();
		QuestionAllController.getAllQuestions(REFRESH);
	};
	mnWebMain.cbUpLoadData = function()
	{
		QuestionAllController.getAllQuestions(LOAD_MORE);
	};
});
var QuestionAllController = 
{
	scope : null,
	num : 10,
	currentIndex : 0,
	questionObjArr : [],
	init : function($scope)
	{
		$Loading.start();
		this.scope = $scope;
		this.setDefaultData();
		this.getAllQuestions(INIT);
	},
	setDefaultData : function()
	{
		this.currentIndex = 0;
		this.questionObjArr = [];
		this.onClickFunction();
	},
	getAllQuestions : function(refreshType)
	{
		var self = this;
		if(refreshType == LOAD_MORE)
		{
			this.currentIndex ++;
		}
		else
		{
			this.currentIndex = 0;
		}
		var path = API_GET_QUESTIONS;
		var params = {};
		params.startIndex = this.currentIndex * this.num;
		params.num = this.num;
		mnWebMain.httpRequest(path, params, function(result)
		{
			$Loading.end();
			var resultJob = JSON.parse(result);
			if(resultJob.error == 0)
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_SUCCESS);
				}
				var dataJob = resultJob.data;
				var questionObjArr = dataJob.questionObjArr;
				if(questionObjArr.length != 0)
				{
					$(".undata").hide();
					self.refreshUi(questionObjArr, refreshType);
				}
				else
				{
					//没有数据
					if(refreshType == INIT)
					{
						$(".undata").show();
					}
					else if(refreshType == LOAD_MORE)
					{
						mnWebMain.toastInfo("没有更多数据！");
					}
					else if(refreshType == REFRESH)
					{
						$(".undata").show();
					}
				}
			}
			else
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_FAILED);
				}
				mnWebMain.toastInfo(resultJob.errMsg);
			}
		});
	},
	refreshUi : function(data, refreshType)
	{
		for(var i = 0; i < data.length; i++)
		{
			var itemObj = {};
			var praiseNum = data[i].praiseNum;
			if (praiseNum > 999)
			{
				var len = praiseNum.length;
				praiseNum = praiseNum.substring(0, len - 3) + "k";
			}
			itemObj.praiseNum = praiseNum;
			itemObj.id = data[i].id;
			itemObj.questionContent = data[i].questionContent;
			this.questionObjArr.push(itemObj);
		}
		this.scope.questionObjArr = this.questionObjArr;
		this.scope.$apply();
		if (LOAD_MORE == refreshType)
		{
			var sHeight = document.body.scrollTop;
			document.body.scrollTop = sHeight + 50;
		}
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.itemClick = function(id)
		{
			var jumpUrl = URL_QUESTION_DETAILS + "?id=" + id;
			mnWebMain.openWebViewController(jumpUrl, "问题详情", {});
		};
	},
};
