/*
 * ==============================
 *  回答问题
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		QuestionAnswerController.questionId = _utility.getQueryString("questionId");
		QuestionAnswerController.init($scope);
	};
});
var QuestionAnswerController = 
{
	questionId : null,
	quesObj : {},
	scope : null,
	init : function($scope)
	{
		this.scope = $scope;
		this.getQuestionInfo();
		this.onClickFunction();
	},
	getQuestionInfo : function()
	{
		var self = this;
		var arr = [];
		arr.push(this.questionId);
		var params = {};
		params.questionIds = JSON.stringify(arr);
		mnWebMain.httpRequest(API_GET_QUESTIONOBJ_WITH_IDS, params, function(result)
		{
			var resultJob = JSON.parse(result);
			if(resultJob.error == 0)
			{
				var questionObjArr = resultJob.data.questionObjArr[0];
				var num = questionObjArr.replyNum;
				if(num > 999)
				{
					var len = num.length;
					num = num.substring(0, len - 3) + "k";
				}
				self.quesObj.replyNum = num;
				self.quesObj.questionContent = questionObjArr.questionContent;
				self.quesObj.questionTime = questionObjArr.questionTime.substring(0, 16);
				
				self.scope.quesObj = self.quesObj;
				self.scope.$apply();
			}
			else
			{
				mnWebMain.toastInfo(resultJob.errMsg);
			}
		});
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.submitClick = function()
		{
			var replyContent = self.scope.answerContent;
			if(!replyContent)
			{
				mnWebMain.toastInfo("请先输入您要回答的内容！");
				return;
			}
			mnWebMain.showProgressDialog("正在回复中....");
			var params = {};
			params.questionId = self.questionId;
			params.replyContent = replyContent;
			var path = "guide/reply";
			mnWebMain.httpRequest(path, params, function(result)
			{
				mnWebMain.dismissProgressDialog();
				var res = JSON.parse(result);
				if( res.error == 0 )
				{
					mnWebMain.getLocalStorage(USER_INFO, function(resInfo)
					{
						var res = JSON.parse(resInfo);
						var dataInfo = res.data;
						var gotValue = JSON.parse(dataInfo.gotValue);
						
						var data = gotValue.userObjArr;
						for(var i in data)
						{
							if( !data[i].myReplyQuestions || data[i].myReplyQuestions == null)
							{
								var myReplyQuestions = [];
							}else{
								var myReplyQuestions = JSON.parse(data[i].myReplyQuestions);
							}
							myReplyQuestions.push(parseInt(self.questionId));
							data[i].myReplyQuestions = JSON.stringify(myReplyQuestions);
						}
						
						var newObj = {};
						newObj.userObjArr = data;
						mnWebMain.setLocalStorage(USER_INFO, JSON.stringify(newObj));
						var arr = ["确定"];
						mnWebMain.showDialog(0, "提示", "回复成功！", arr, function()
						{
							var params = {};
							mnWebMain.transferData(JSON.stringify(params));//页面传值
							mnWebMain.closeSelfViewController(0);//关闭当前页面
						});
					});
				}else{
				}
			});
		};
	},
}
