/*
 * ==============================
 *  问题详情
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope){
	
	mnWebMain.cbBridgeInited = function(){
		mnWebMain.refresh("0");
		QuestionDetailsController.questionId = _utility.getQueryString("id");
		QuestionDetailsController.init($scope);
	};
	
	mnWebMain.cbUpLoadData = function(result){
		QuestionDetailsController.startIndex += 10;
		QuestionDetailsController.getOtherReply(QuestionDetailsController.startIndex);
	}
    
});

var QuestionDetailsController = {
	
	//全局变量
	scope : null,
	
	questionId : null,//问题ID
	isAccept : null,
	
	startIndex : 0,
	
	//数据模型
	quesObj : {},
	bestQuesObj : {},
	otherReplyArr : [],
	
	//初始化
	init : function($scope)
	{
		
		$Loading.start();
		
		this.scope = $scope;
		
		this.setDefault();
		
		this.getQuestionObjWithId();
		
		this.bindClick();
		
	},
	
	setDefault : function()
	{
		this.isAccept = null;
	
		this.startIndex = 0;
		
		//数据模型
		this.quesObj = {};
		this.bestQuesObj = {};
		this.otherReplyArr = [];
	},
	
	/**
	 * 问题详情
	 */
	getQuestionObjWithId : function()
	{
		var self = this;
		
		var arr = [];
		arr.push(self.questionId);
		
		var params = {};
		params.questionIds = JSON.stringify(arr);
		
		mnWebMain.httpRequest(API_GET_QUESTIONOBJ_WITH_IDS,params,function(data){
			
			var res = JSON.parse(data);
			if(res.error == 0)
			{
				var questionObjArr = res.data.questionObjArr[0];
				self.quesObj.replyNum = quesUtility.getReplyNum(questionObjArr.replyNum);
				self.quesObj.questionContent = questionObjArr.questionContent;
				self.quesObj.icon = quesUtility.getUserIcon(questionObjArr.icon);
				self.quesObj.publishUserId = questionObjArr.publishUserId;
				self.quesObj.nickName = questionObjArr.nickName;
				self.quesObj.questionLabels = quesUtility.getArr(questionObjArr.questionLabels);
				self.quesObj.lv = questionObjArr.lv;
				self.quesObj.questionTime = questionObjArr.questionTime.substring(0,16);
				var questionSupplementArr = quesUtility.getArr(questionObjArr.questionSupplement);
				self.quesObj.questionSupplement = (questionSupplementArr.length == 0) ? "" : questionSupplementArr[0];
				self.quesObj.ishiddenAdd = (questionSupplementArr.length == 0) ? "hidden" : "";
				self.quesObj.questionBtnClass = quesUtility.isHiddenAddQuestionBtn(questionSupplementArr,questionObjArr.publishUserId);
				
				self.isAccept = questionObjArr.isAccept;
				self.getBestReply(questionObjArr.isAccept)
				self.hasReplyedQuestion(questionObjArr.publishUserId,questionObjArr.replyNum);
				
				self.scope.quesObj = self.quesObj;
				self.scope.$apply();
				
				$Loading.end();
			}
			else
			{
				mnWebMain.toastInfo("获取数据失败！");
			}
			
		});
	},
	
	/**
	 * 获取最佳答案
	 * @param {Object} isAccept
	 */
	getBestReply : function(isAccept)
	{
		var self = this;
		
		if(isAccept == 1)
		{
			var params = {};
			params.questionId = self.questionId;
			
			mnWebMain.httpRequest(API_REPLY_GET_BEST_REPLY,params,function(data){
				var replyObj = JSON.parse(data).data.replyObj;
				
				self.bestQuesObj.id = replyObj.id;
				self.bestQuesObj.icon = quesUtility.getUserIcon(replyObj.icon);
				self.bestQuesObj.nickName = replyObj.nickName;
				//等级
				var iconName = 'a15.png';
				var status = replyObj.status;
				var orangerLv = replyObj.lv;
				if (orangerLv == 0) {
					iconName = 'b1.png';
				}
				if (4 == parseInt(status) && orangerLv != 0) {
					iconName = 'a' + orangerLv + '.png';
				} else if (orangerLv != 0) {
					iconName = 'b' + orangerLv + '.png';
				}
				self.bestQuesObj.level = PATH_LEVEL_ICON + iconName;
				self.bestQuesObj.lv = 'Lv' + replyObj.lv;
				self.bestQuesObj.replyContent = replyObj.replyContent;
				self.bestQuesObj.replyTime = replyObj.replyTime.substring(0,16);
				self.bestQuesObj.praiseNum = replyObj.praiseNum;
				self.bestQuesObj.criticismNum = replyObj.criticismNum;
				var replySupplement = quesUtility.getArr(replyObj.replySupplement);
				self.bestQuesObj.replySupplement = (replySupplement.length == 0) ? "" : replySupplement[0];
				self.bestQuesObj.ishiddenAdd = (replySupplement.length == 0) ? "hidden" : "";
				
				var operation = getReplyOperation(getUserId(), replyObj.id);
				self.bestQuesObj.pariseIcon = (operation == 1) ? HASPARSE : UNPARSE;
				self.bestQuesObj.criticismIcon = (operation == 2) ? HASCRITICISM : UNCRITICISM;
				
				self.scope.bestQuesObj = self.bestQuesObj;
				self.scope.$apply();
				
				$(".item").eq(1).show();
			})
		}
	},
	
	/**
	 * 是否评论过这个问题
	 * @param {Object} publishUserId
	 * @param {Object} replyNum
	 */
	hasReplyedQuestion : function(publishUserId, replyNum)
	{
		var self = this;
		var userType = getUserType();
		var userId = getUserId();
		
		if(userType == USER_TOURIST || userId == publishUserId)
		{
			self.getOtherReply(0);
		}
		else if(userType == USER_GUIDE && replyNum == 0) 
		{
			$(".item").eq(0).show();
		}
		else if(userType == USER_GUIDE)
		{
			self.getOtherReply(0);
			
			try
			{
				var userObj = JSON.parse(getLocalString(USER_INFO)).userObjArr[userId];
				var myReplyQuestions = userObj.myReplyQuestions;
				
				if(_utility.isEmpty(myReplyQuestions))
				{
					myReplyQuestions = [];
				}
				else
				{
					myReplyQuestions = JSON.parse(myReplyQuestions);
				}
				var canAnswer = quesUtility.arrayHasValue(myReplyQuestions,self.questionId);
				
				if(!canAnswer || myReplyQuestions.length == 0) 
				{
					$(".anw").show();
				}
				else
				{
					$(".anw").hide();
				}
			}
			catch(e)
			{
				//TODO handle the exception
			}
		}
	},
	
	/**
	 * @param {Object} userId
	 * @param {Object} questionId
	 * @param {Object} startIndex
	 * @param {Object} refreshType  2 表示加载更多,需要关闭加载状态
 	*/
	getOtherReply : function(startIndex)
	{
		var self = this;
		
		var params = {};
		params.startIndex = startIndex;
		params.num = 10;
		params.questionId = self.questionId;
		
		mnWebMain.httpRequest(API_GET_ITHER_REPLY,params,function(data){
			var res = JSON.parse(data);
			if(res.error == 0)
			{
				mnWebMain.refreshFinish(0);
				var replies = res.data.replies;
				
				if(_utility.isEmpty(replies))
				{
					if(startIndex == 0)
					{
						$(".no-anw").show();
					}
					else
					{
						mnWebMain.toastInfo("没有更多数据！");
					}
				}
				else
				{
					$(".no-anw").hide();
					
					for(var i = 0 ; i < replies.length ; i ++)
					{
						var itemObj = {};
						itemObj.id = replies[i].id;
						itemObj.praiseNum = replies[i].praiseNum;
						itemObj.criticismNum = replies[i].criticismNum;
						itemObj.replyContent = replies[i].replyContent;
						itemObj.isAccept = replies[i].isAccept;
						itemObj.replyTime = replies[i].replyTime.substring(0,16);
						itemObj.icon = quesUtility.getUserIcon(replies[i].icon);
						itemObj.nickName = replies[i].nickName;
						var replySupplement = quesUtility.getArr(replies[i].replySupplement);
						itemObj.replySupplement = (replySupplement.length == 0) ? "" : replySupplement[0];
						itemObj.ishiddenAdd = (replySupplement.length == 0) ? "hidden" : "";
						//等级
						var iconName = 'a15.png';
						var status = replies[i].status;
						var orangerLv = replies[i].lv;
						if (orangerLv == 0) {
							iconName = 'b1.png';
						}
						if (4 == parseInt(status) && orangerLv != 0) {
							iconName = 'a' + orangerLv + '.png';
						} else if (orangerLv != 0) {
							iconName = 'b' + orangerLv + '.png';
						}
						itemObj.level = PATH_LEVEL_ICON + iconName;
						itemObj.lv = "Lv" + replies[i].lv;
						var btnClickType = 0;
						var btnValue = "";
						var btnClass = "";
						if(replySupplement.length != 0)
						{
							if(self.isAccept == 0 && getUserId() == replies[i].publishUserId)
							{
								btnValue = "采纳";
								btnClickType = 1;
								btnClass = "";
							}
							else
							{
								btnClass = "hiddenIm";
							}
						}
						else
						{
							//回复人id
							var replyUserId = replies[i].replyUserId;
							//如果是我的回复
							if(getUserId() == replyUserId) {
								btnValue = "补充";
								btnClickType = 2;
								btnClass = "";
							}
							else if(self.isAccept == 0 && getUserId() == replies[i].publishUserId)
							{
								btnValue = "采纳";
								btnClickType = 1;
								btnClass = "";
							}
							else
							{
								btnClass = "hiddenIm";
							}
						}
						
						itemObj.btnValue = btnValue;
						itemObj.btnClickType = btnClickType;
						itemObj.btnClass = btnClass;
						
						var operation = getReplyOperation(getUserId(), replies[i].id);
						itemObj.pariseIcon = (operation == 1) ? HASPARSE : UNPARSE;
						itemObj.criticismIcon = (operation == 2) ? HASCRITICISM : UNCRITICISM;
						
						self.otherReplyArr.push(itemObj);
					}
					
					self.scope.replyArr = self.otherReplyArr;
					self.scope.$apply();
					
					$(".item").eq(2).show();
				}	
			}
		})
	},
	
	/**
	 * 点赞和踩
	 * @param {Object} listType
	 * @param {Object} oType
	 * @param {Object} replyId
	 */
	praiseOrCriticismClick : function(listType, oType, replyId)
	{
		var operation = isReplyOperated(getUserId(), replyId);
		//已经操作过
		if(operation == 1) 
		{
			this.showToast("重复操作！");
			return;
		} 
		
		//未操作过
		this.replyPraiseOrCriticism(listType, oType, replyId);
	},
	
	/**
	 * 点赞和踩
	 * @param {Object} listType
	 * @param {Object} oType
	 * @param {Object} replyId
	 */
	replyPraiseOrCriticism : function(listType, oType, replyId)
	{
		var self = this;
		var params = {};
		params.OPType = oType;
		params.replyId = replyId;
		
		mnWebMain.httpRequest(API_PRAISE_OR_CRI,params,function(data){
			var res = JSON.parse(data);
			var showMsg = '';
			
			if(res.error == 0)
			{
				//1 表示点赞
				if(oType == 1)
				{
					showMsg = "+1";
					setReplyUp(getUserId(),replyId);
					
					//最佳
					if(listType == 0)
					{
						self.bestQuesObj.pariseIcon = HASPARSE;
						self.bestQuesObj.praiseNum = parseInt(self.bestQuesObj.praiseNum) + 1;
					}
					//其他回答（列表 需要用replyId）
					else
					{
						for(var  i = 0 ; i < self.otherReplyArr.length ; i ++)
						{
							if(self.otherReplyArr[i].id == replyId)
							{
								self.otherReplyArr[i].pariseIcon = HASPARSE;
								self.otherReplyArr[i].praiseNum = parseInt(self.otherReplyArr[i].praiseNum) + 1;
							}
						}
					}
					
					self.scope.$apply();
				}
				else
				{
					showMsg = "+1";
					setReplyDown(getUserId(),replyId);
					
					//最佳
					if(listType == 0)
					{
						self.bestQuesObj.criticismIcon = HASCRITICISM;
						self.bestQuesObj.criticismNum = parseInt(self.bestQuesObj.criticismNum) + 1;
					}
					//其他回答（列表 需要用arrId）
					else
					{
						for(var  i = 0 ; i < self.otherReplyArr.length ; i ++)
						{
							if(self.otherReplyArr[i].id == replyId)
							{
								self.otherReplyArr[i].criticismIcon = HASCRITICISM;
								self.otherReplyArr[i].criticismNum = parseInt(self.otherReplyArr[i].criticismNum) + 1;
							}
						}
					}
					
					self.scope.$apply();
				}
			}
			else
			{
				showMsg = "请求失败！";
			}
			
			self.showToast(showMsg)
		})
	},
	
	/**
	 * 所有的点击事件
	 */
	bindClick : function()
	{
		var self = this;
		
		self.scope.praiseClick = function(listType, oType, replyId)
		{
			self.praiseOrCriticismClick(listType, oType, replyId);
		};
		
		
		/**
		 * //1采纳 2补充
		 * @param {Object} type
		 */
		self.scope.itemOtherReplyBtnClick = function(type,id)
		{
			if(type == 1)
			{
				var arr = ["取消", "确定"];
				mnWebMain.showDialog(0, "提示", "您确定采纳该回复吗?", arr, function(result) {
					var res = JSON.parse(result);
					var data = res.data;
					if(data.index == 1) 
					{
						self.acceptReply(id);
					}
				});
			}
			else if(type == 2)
			{
				var dialogArr = ['取消', '确定'];
				
				var u = navigator.userAgent;
				var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); 
				
				if(isiOS)
				{
					mnWebMain.showMutilLineImput(1, '补充回答', '', dialogArr, function(result){
						var resultJob = JSON.parse(result);
						if(resultJob.error == 0) 
						{
							var dataJob = resultJob.data;
							if(dataJob.index == 1) 
							{
								var inputContent = dataJob.inputContent;
								var supplyParams = {};
								supplyParams.replyId = id;
								supplyParams.replySupplement = inputContent;
								var supplyPath = "reply/replySupplement";
								
								mnWebMain.httpRequest(supplyPath, supplyParams, function(result) {
									mnWebMain.dismissProgressDialog();
									QuestionDetailsController.supplyCallBack(id,inputContent);
								});
							}
						}
					});
				}
				else
				{
					mnWebMain.showDialog(1, '补充回答', '', dialogArr, function(result) {
						var resultJob = JSON.parse(result);
						if(resultJob.error == 0) 
						{
							var dataJob = resultJob.data;
							if(dataJob.index == 1) 
							{
								var inputContent = dataJob.inputContent;
								var supplyParams = {};
								supplyParams.replyId = id;
								supplyParams.replySupplement = inputContent;
								var supplyPath = "reply/replySupplement";
								
								mnWebMain.httpRequest(supplyPath, supplyParams, function(result) {
									mnWebMain.dismissProgressDialog();
									QuestionDetailsController.supplyCallBack(id,inputContent);
								});
							}
						}
					});
				}
			}
		};
		
		//补充回答
		self.scope.addQuestion = function()
		{
			var dialogArr = ['取消', '确定'];
			mnWebMain.showDialog(1, '补充提问', '', dialogArr, function(result) {
				var resultJob = JSON.parse(result);
				if(resultJob.error == 0) {
					var dataJob = resultJob.data;
					if(dataJob.index == 1) 
					{
						//补充提问,通过id添加补充提问内容
						var inputContent = dataJob.inputContent;
						self.questionSupply(inputContent);
					}
				}
			});
		};
		
		self.scope.submitQuestion = function()
		{
			var inputQuestion = $("#inputQuestion").val();
			
			if(inputQuestion == "")
			{
				mnWebMain.toastInfo("请输入文字内容");
				return;
			}
			
			self.answerQuestion(inputQuestion);
		};
		self.scope.answerQuestion = function()
		{
			var pageUrl = URL_QUESTION_ANSWER + "?questionId=" + self.questionId;
			mnWebMain.openWebViewControllerWithDataTransfer(pageUrl, "我要回答", {}, function(result)
			{
				$Loading.start();
				
				self.setDefault();
				
				self.getQuestionObjWithId();
			});
		};
	},
	
	answerQuestion : function(replyContent)
	{
		var self = this;
		
		var params = {};
		params.questionId = self.questionId;
		params.replyContent = replyContent;
		
		var path = "guide/reply";
		
		mnWebMain.httpRequest(path, params, function(data){
			var userId = getUserId();
			var res = JSON.parse(data);
			if( res.error == 0 )
			{
				try
				{
					var data = JSON.parse(getLocalString(USER_INFO)).userObjArr;
					var userObj = data[userId];
					var myReplyQuestions = userObj.myReplyQuestions;
					
					if(_utility.isEmpty(myReplyQuestions))
					{
						myReplyQuestions = [];
					}
					else
					{
						myReplyQuestions = JSON.parse(myReplyQuestions);
					}
					
					myReplyQuestions.push(parseInt(self.questionId));
					userObj.myReplyQuestions = JSON.stringify(myReplyQuestions);
					
					var newObj = {};
					newObj.userObjArr = data;
					saveLocalString(USER_INFO,JSON.stringify(newObj));
					
					mnWebMain.toastInfo("回复成功");
					
					$(".item").hide();
					self.getQuestionObjWithId();
					
				}
				catch(e)
				{
					//TODO handle the exception
				}
			}
		})
	},
	
	/**
	 * 补充回答回调函数
	 * @param {Object} id
	 * @param {Object} inputContent
	 */
	supplyCallBack : function(id,inputContent)
	{
		var self = this;
		
		for(var i = 0 ; i < self.otherReplyArr.length ; i ++)
		{
			if(self.otherReplyArr[i].id == id)
			{
				self.otherReplyArr[i].replySupplement = inputContent;
				self.otherReplyArr[i].ishiddenAdd = "";
				self.otherReplyArr[i].btnClass = "hiddenIm";
			}
		}
		
		self.scope.$apply();
	},
	
	/**
	 * 采纳回复
	 * @param {Object} replyId
	 */
	acceptReply : function(replyId)
	{
		var self = this;
		
		var params = {};
		params.replyId = replyId;
		var path = "reply/acceptReply";
		
		mnWebMain.httpRequest(path, params, function(result) {
			var res = JSON.parse(result);
			if(res.error == 0) 
			{
				mnWebMain.toastInfo("采纳成功！");
				var delIndex = -1;
				for(var i = 0 ; i < self.otherReplyArr.length ; i ++)
				{
					self.otherReplyArr[i].btnClass = "hiddenIm";
					
					if(self.otherReplyArr[i].id == replyId)
					{
						delIndex = i;
					}
				}
				
				if(delIndex >= 0)
				{
					self.otherReplyArr.splice(delIndex,1);
				}
				
				self.isAccept = 0;
				self.getBestReply(1);
			} 
		});
	},
	
	/**
	 * 补充回答回调函数
	 * @param {Object} inputContent
	 */
	questionSupply : function(inputContent)
	{
		var self = this;
		
		var supplyParams = {};
		supplyParams.questionId = self.questionId;
		supplyParams.questionSupplement = inputContent;
		
		var supplyPath = "question/questionSupplement";
		
		mnWebMain.httpRequest(supplyPath, supplyParams, function(result) {
			
			self.quesObj.questionSupplement = inputContent;
			self.quesObj.ishiddenAdd = "";
			self.quesObj.questionBtnClass = "hiddenIm";
			
			self.scope.$apply();
		});
	},
	
	/**
	 * 弹出提示框
	 * @param {Object} value
	 */
	showToast : function(value)
	{
		$("#fade-in-out").text(value);
		$("#fade-in-out").show().addClass("fade_block");
		setTimeout(function(){
			$("#fade-in-out").removeClass("fade_block").hide();
		}, 2000);
	}
	
	
};

var quesUtility = {
	
	/**
	 * 处理回答数并返回
	 * @param {Object} num
	 */
	getReplyNum : function(num)
	{
		if(num > 999)
		{
			var len = num.length;
			num = num.substring(0, len - 3) + "k";
		}
		return num;
	},
	
	/**
	 * 处理头像并返回
	 * @param {Object} icon
	 */
	getUserIcon : function(icon)
	{
		if(_utility.isEmpty(icon))
		{
			return DefaultGudiesIcon;
		}
		else
		{
			var reticon = JSON.parse(icon).url + IMG_CUT_WH;
			return reticon;
		}
	},
	
	/**
	 * 处理空数组并返回
	 * @param {Object} icon
	 */
	getArr : function(arr)
	{
		var retArr = [];
		if(_utility.isEmpty(arr) || JSON.parse(arr).length == 0)
		{
			retArr = [];
		}
		else
		{
			retArr = JSON.parse(arr);
		}
		return retArr;
	},
	
	/**
	 * 判断有没有补充提问按钮
	 * @param {Object} arr
	 * @param {Object} publishUserId
	 */
	isHiddenAddQuestionBtn : function(arr,publishUserId)
	{
		var className = "";
		var userId = getUserId();
		
		if(arr.length != 0)
		{
			className = "hiddenIm";
		}
		else
		{
			if(userId == publishUserId)
			{
				className = "";
			}
			else
			{
				className = "hiddenIm";
			}
		}
		
		return className;
	},
	
	/**
	 * 判断数组中是否含有某个值
	 * @param {Object} data
	 * @param {Object} value
	 */
	arrayHasValue : function(data , value)
	{
		for(var i = 0; i < data.length; i++)
		{
			if(data[i] == value)
			{
				return true;  
			}
		}
		return false;  
	}
	
};


