/*
 * ==============================
 *  我要回答
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	
	mnWebMain.cbBridgeInited = function()
	{
		mnWebMain.refresh("2");
		QuestionForAnswerController.init($scope);
	};
	mnWebMain.cbDownRefreshData = function()
	{
		QuestionForAnswerController.setDefault();
		QuestionForAnswerController.getWillAnswerList(REFRESH);
	};
	mnWebMain.cbUpLoadData = function()
	{
		QuestionForAnswerController.getWillAnswerList(LOAD_MORE);
	};
});
var QuestionForAnswerController = 
{
	scope : null,
	currentIndex : 0,
	pageSize : 10,
	questionObjArr : [],
	init : function($scope)
	{
		$Loading.start();
		this.scope = $scope;
		this.setDefault();
		this.getWillAnswerList(INIT);
		this.onClickFunction();
	},
	/**
	 * 重置变量
	 */
	setDefault : function()
	{
		this.questionObjArr = [];
		this.currentIndex = 0;
	},
	//获取待回答问题列表
	getWillAnswerList : function (refreshType){
		var self = this;
		var params = {};
		if(refreshType == LOAD_MORE)
		{
			this.currentIndex++;	
		}
		else
		{
			this.currentIndex = 0;
		}
		var startIndex = this.currentIndex * this.pageSize;
		params.startIndex = startIndex;
		params.num = this.pageSize;
		var path = API_GET_NO_REPLY_QUESTION;
		mnWebMain.httpRequest(path, params, function(result)
		{
			$Loading.end();
			var resultJob = JSON.parse(result);
			if( resultJob.error == 0 )
			{
				var dataJob = resultJob.data;
				var questionObjArr = dataJob.questionObjArr;
				
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_SUCCESS);
				}
				if(questionObjArr.length != 0)
				{
					$(".undata").hide();
					self.refreshUi(questionObjArr, refreshType);
				}
				else
				{
					//没有数据
					if(refreshType == INIT)
					{
						$(".undata").show();
						self.scope.questionObjArr = self.questionObjArr;
						self.scope.$apply();
					}
					else if(refreshType == LOAD_MORE)
					{
						mnWebMain.toastInfo("没有更多数据！");
					}
					else if(refreshType == REFRESH)
					{
						$(".undata").show();
						self.scope.questionObjArr = self.questionObjArr;
						self.scope.$apply();
					}
				}
			}
			else
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_FAILED);
				}
				mnWebMain.toast(resultJob.errMsg);
			}
		});
	},
	refreshUi : function(data, refreshType)
	{
		for(var i = 0; i < data.length; i++)
		{
			var itemObj = {};
			//id, isAccept
			itemObj.id = data[i].id;
			itemObj.isAccept = [i].isAccept;
			//内容
			itemObj.questionContent = data[i].questionContent;
			//回答数
			var replyNum = data[i].replyNum;
			if( replyNum > 999 ){
				var len = replyNum.length;
				replyNum = replyNum.substring(0, len - 3) + "k";
			}
			itemObj.replyNum = replyNum;
			//时间
			try{
				var questionTime = data[i].questionTime.split(" ")[0];
				itemObj.questionTime = questionTime;
			}catch(e){
			}
			//标签
			var questionLabels = JSON.parse(data[i].questionLabels);
			itemObj.questionLabels = questionLabels;
			if(questionLabels && questionLabels.length != 0)
			{
				itemObj.labelsShow = "";
			}
			else
			{
				itemObj.labelsShow = "hidden";
			}
			this.questionObjArr.push(itemObj);
		}
		this.scope.questionObjArr = this.questionObjArr;
		this.scope.$apply();
		if (LOAD_MORE == refreshType) {
			var sHeight = document.body.scrollTop;
			document.body.scrollTop = sHeight + 50;
		}
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.itemClick = function(id)
		{
			var jumpUrl = URL_QUESTION_DETAILS + "?id=" + id;
			mnWebMain.openWebViewController(jumpUrl, "问题详情", {});
		};
	},
};
