/*
 * ==============================
 *  我的回答
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		mnWebMain.refresh("2");
		QuestionMyAnswerController.init($scope);
	};
	mnWebMain.cbDownRefreshData = function()
	{
		QuestionMyAnswerController.setDefault();
		QuestionMyAnswerController.getAnsweredList(REFRESH);
	};
	mnWebMain.cbUpLoadData = function()
	{
		QuestionMyAnswerController.getAnsweredList(LOAD_MORE);
	};
});
var QuestionMyAnswerController = 
{
	scope : null,
	currentIndex : 0,
	pageSize : 10,
	questionReplyArr : [],
	init : function($scope)
	{
		$Loading.start();
		this.scope = $scope;
		this.setDefault();
		this.getAnsweredList(INIT);
		this.onClickFunction();
	},
	/**
	 * 重置变量
	 */
	setDefault : function()
	{
		this.questionReplyArr = [];
		this.currentIndex = 0;
	},
	//获取我的回答问题列表
	getAnsweredList : function(refreshType)
	{
		var self = this;
		if(refreshType == LOAD_MORE)
		{
			this.currentIndex++;	
		}
		else
		{
			this.currentIndex = 0;
		}
		var startIndex = this.currentIndex * this.pageSize;
		
		var params = {};
		params.type = 0;
		params.startIndex = startIndex;
		params.num = this.pageSize;
		
		var path = API_GET_MY_RESPONSE;
		
		mnWebMain.httpRequest(path, params, function(result)
		{
			$Loading.end();
			var resultJob = JSON.parse(result);
			if( resultJob.error == 0 )
			{
				var dataJob = resultJob.data;
				var questionReply = dataJob.questionReply;
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_SUCCESS);
				}
				if(questionReply.length != 0)
				{
					$(".undata").hide();
					self.refreshUi(questionReply, refreshType);
				}
				else
				{
					//没有数据
					if(refreshType == INIT)
					{
						$(".undata").show();
						self.scope.questionReplyArr = self.questionReplyArr;
						self.scope.$apply();
					}
					else if(refreshType == LOAD_MORE)
					{
						mnWebMain.toastInfo("没有更多数据！");
					}
					else if(refreshType == REFRESH)
					{
						$(".undata").show();
						self.scope.questionReplyArr = self.questionReplyArr;
						self.scope.$apply();
					}
				}
			}
			else
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_FAILED);
				}
				mnWebMain.toast(resultJob.errMsg);
			}
		});
	},
	refreshUi : function(data, refreshType)
	{
		for(var i = 0; i < data.length; i++)
		{
			var itemJob = {};
			//id, isAccept
			itemJob.questionId = data[i].questionId;
			itemJob.isAccept = data[i].isAccept;
			//内容
			itemJob.question = data[i].question;
			//回复内容
			itemJob.replyContent = data[i].replyContent;
			//回复数
			var replyNum = data[i].replyNum;
			if( replyNum > 999 )
			{
				var len = replyNum.length;
				replyNum = replyNum.substring(0, len - 3) + "k";
			}
			itemJob.replyNum = replyNum;
			//赞的数量
			var praiseNum = data[i].praiseNum;
			if( praiseNum > 999 )
			{
				var len = praiseNum.length;
				praiseNum = praiseNum.substring(0, len - 3) + "k";
			}
			itemJob.praiseNum = praiseNum;
			//踩的数量
			var criticismNum = data[i].criticismNum;
			if( criticismNum > 999 )
			{
				var len = criticismNum.length;
				criticismNum = criticismNum.substring(0, len - 3) + "k";
			}
			itemJob.criticismNum = criticismNum;
			//时间
			try
			{
				var replyTime = data[i].replyTime.split(" ")[0];
				itemJob.replyTime = replyTime;
			}catch(e){
			}
			//是否已经采纳
			var questionAccepted = "";
			if(data[i].questionAccepted != 0)
			{
				questionAccepted = "";
			}
			else
			{
				questionAccepted = "hiddenIm";
			}
			itemJob.questionAccepted = questionAccepted;
			this.questionReplyArr.push(itemJob);
		}
		this.scope.questionReplyArr = this.questionReplyArr;
		this.scope.$apply();
		if (LOAD_MORE == refreshType) 
		{
			var sHeight = document.body.scrollTop;
			document.body.scrollTop = sHeight + 50;
		}
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.itemClick = function(id)
		{
			var jumpUrl = URL_QUESTION_DETAILS + "?id=" + id;
			mnWebMain.openWebViewController(jumpUrl, "问题详情", {});
		};
	},
};
