/*
 * ==============================
 *  城市选择
 * ==============================
 */

// 1. 获取module
var app = angular.module("app", []).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl', function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		SelectCityController.id = _utility.getQueryString("id");
		SelectCityController.idType = _utility.getQueryString("idType");
		SelectCityController.name = getLocalString(KPROVINCE_NAME);
		saveLocalString(KPROVINCE_NAME, "");
		SelectCityController.init($scope);
	};
});
var SelectCityController = 
{
	id : null,
	name : null,
	idType : 0,//0表示国家id  1表示省份id
	scope : null,
	cityArr : [],
	init : function($scope)
	{
		this.scope = $scope;
		if(this.idType == 0)
		{
			this.getForeignProvinceId(this.id)
		}
		else if(this.idType == 1)
		{
			this.getCityList(this.id, this.name);
		}
		this.onClickFunction();
	},
	//获取国外省id
	getForeignProvinceId : function (id){
		var self = this;
		mnWebMain.getProvinces(id, function(result){
			var res = JSON.parse(result);
			if( res.error == 0 ){
				var dataInfo = res.data;
				var data = dataInfo.provinces;
				
				var	name = data[0].name;
				var len = name.length;
				var p_name = name.substring(0, len-2);
				
				self.getCityList(data[0].id, p_name);
			}else{
			}
		});
	},
	//根据省id或者城市列表
	getCityList : function(id, name)
	{
		var self = this;
		mnWebMain.getCitys(id, function(result){
			var res = JSON.parse(result);
			if( res.error == 0 ){
				var dataInfo = res.data;
				var data = dataInfo.cities;
				var cityItem = {};
				cityItem.name = name;
				self.cityArr.push(cityItem);
				for(var i in data)
				{
					self.cityArr.push(data[i]);
	//				data[i].id
	//				data[i].name
				}
				self.scope.cityArr = self.cityArr;
				self.scope.$apply();
				
			}else{
			}
		});
	},
	onClickFunction : function()
	{
		this.scope.itemClick = function(name)
		{
			mnWebMain.transferData(name);
			mnWebMain.closeSelfViewController(0);
		};
		this.scope.inputClick = function()
		{
			var arr = ["取消", "确定"];
			mnWebMain.showDialog(1, "城市", "", arr, function(result)
			{
				var resultJob = JSON.parse(result);
				var err = resultJob.error;
				if(err == 0)
				{
					var dataJob = resultJob.data;
					if(dataJob.index == 1)
					{
						var inputContent = dataJob.inputContent;
						mnWebMain.transferData(inputContent);
						mnWebMain.closeSelfViewController(0);
					}
				}
			});
		};
	},
};
