/*
 * ==============================
 *  国家/省份选择(选择熟悉城市等 所跳转的页面)
 * ==============================
 */

// 1. 获取module
var app = angular.module("app", []).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl', function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		SelectCountryController.init($scope);
	};
});
var SelectCountryController = 
{
	scope : null,
	countryArr : [],
	provinceArr : [],// id    name
	searchResultArr : [],
	init : function($scope)
	{
		this.scope = $scope;
		this.getProvinces();
		this.getCountryList();
		this.onClickFunction();
	},
	getProvinces : function()
	{
		var self = this;
		mnWebMain.getProvinces(ID_CHINA, function(result)
		{
			var resultJob = JSON.parse(result);
			if( resultJob.error == 0 )
			{
				var dataJob = resultJob.data;
				var provinces = dataJob.provinces;
				self.provinceArr = provinces;
				self.scope.provinceArr = self.provinceArr;
				self.scope.$apply();
			}else{
			}
		});
	},
	//获取其他国家
	getCountryList :function (){
		var self = this;
		mnWebMain.getCountrys(function(result){
			var resultJob = JSON.parse(result);
			if( resultJob.error == 0 ){
				var dataJob = resultJob.data;
				var countries = dataJob.countries;
				try
				{
					countries.splice(0,1);
				}catch(e){
				}
				self.countryArr = countries;
				self.scope.countryArr = self.countryArr;
				self.scope.$apply();
			}else{
			}
		});
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.provinceClick = function(id, name)
		{
			//
			var headObj = {};
			saveLocalString(KPROVINCE_NAME, name);
    		mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_CITY + "?id=" + id + "&idType=1", "选择城市", headObj, function(result)
    		{
    			var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var name = dataJob.params;
				mnWebMain.transferData(name);
				mnWebMain.closeSelfViewController(0);
    		});
		};
		this.scope.countryClick = function(id)
		{
			var headObj = {};
    		mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_CITY + "?id=" + id + "&idType=0", "选择城市", headObj, function(result)
    		{
    			var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var name = dataJob.params;
				mnWebMain.transferData(name);
				mnWebMain.closeSelfViewController(0);
    		});
		}
		this.scope.resultClick = function(name)
		{
			mnWebMain.transferData(name);
			mnWebMain.closeSelfViewController(0);
		}
		$("#search_input").on("input onpropertychange",function(){
			var searchContent = $("#search_input").val();
			if(searchContent)
			{
				showSearchResult(2);
				self.getDataWithKeyword(searchContent);
			}
			else
			{
				showSearchResult(0);
			}
		})
	},
	getDataWithKeyword : function (keyWord)
	{
		var self = this;
		var path = "common/getCityOrSightsWithKeyWord";
		var params = {};
		params.keyWord = keyWord;
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			var error = resultJob.error;
			var dataJob = resultJob.data;
			if(error == 0)
			{
				self.searchResultArr = [];
				var countryInfo = dataJob.countryInfo;
				if(countryInfo)
				{
					for(var i in countryInfo)
					{
						var item = countryInfo[i];
						item.type = 1;
						self.searchResultArr.push(item);
					}
				}
				var provinceInfo = dataJob.provinceInfo;
				if(provinceInfo)
				{
					for(var j in provinceInfo)
					{
						var item = provinceInfo[j];
						item.type = 2;
						self.searchResultArr.push(item);
					}
				}
				var cityInfo = dataJob.cityInfo;
				if(cityInfo)
				{
					for(var k in cityInfo)
					{
						var item = cityInfo[k];
						item.type = 3;
						self.searchResultArr.push(item);
					}
				}
				self.scope.searchResultArr = self.searchResultArr;
				self.scope.$apply();
			}
			else
			{
			}
		});
	},
};
