/*
 * ==============================
 *  国家/省份选择(创建团的时候选择目的地所要跳转的页面)
 * ==============================
 */

// 1. 获取module
var app = angular.module("app", []).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl', function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		SelectCountryController.init($scope);
	};
});
var SelectCountryController = 
{
	scope : null,
	countryArr : [],
	provinceArr : [],// id    name
	searchResultArr : [],
	init : function($scope)
	{
		this.scope = $scope;
		this.getProvinces();
		this.getCountryList();
		this.onClickFunction();
	},
	getProvinces : function()
	{
		var self = this;
		mnWebMain.getProvinces(ID_CHINA, function(result)
		{
			var resultJob = JSON.parse(result);
			if( resultJob.error == 0 )
			{
				var dataJob = resultJob.data;
				var provinces = dataJob.provinces;
				self.provinceArr = provinces;
				self.scope.provinceArr = self.provinceArr;
				self.scope.$apply();
			}else{
			}
		});
	},
	//获取其他国家
	getCountryList :function (){
		var self = this;
		mnWebMain.getCountrys(function(result){
			var resultJob = JSON.parse(result);
			if( resultJob.error == 0 ){
				var dataJob = resultJob.data;
				var countries = dataJob.countries;
				try
				{
					countries.splice(0,1);
				}catch(e){
				}
				self.countryArr = countries;
				self.scope.countryArr = self.countryArr;
				self.scope.$apply();
			}else{
			}
		});
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.provinceClick = function(id, name)
		{
			//
			var headObj = {};
			headObj.rightTitle = "手动输入";
    		mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_SIGHT + "?id=" + id + "&idType=1", "选择地区", headObj, function(result)
    		{
    			var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var paramsJob = dataJob.params;
				mnWebMain.transferData(paramsJob);
				mnWebMain.closeSelfViewController(0);
    		});
		};
		this.scope.countryClick = function(id)
		{
			var headObj = {};
			headObj.rightTitle = "手动输入";
    		mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_SIGHT + "?id=" + id + "&idType=0", "选择地区", headObj, function(result)
    		{
    			var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var paramsJob = dataJob.params;
				mnWebMain.transferData(paramsJob);
				mnWebMain.closeSelfViewController(0);
    		});
		}
		this.scope.resultClick = function(index, type, name)
		{
			if(type == 1)
			{
				//国家或者省   去地点的二级页面看代码，找到本地存储的内容，存应该保存的数据，并关闭页面即可
				var countryId = self.searchResultArr[index].cId;
				if(ID_CHINA == countryId)
				{
					var goodType = GOOD_CHINA;
				}
				else
				{
					var goodType = GOOD_FOREIN;
				}
				self.setLocationDataAndDestory(name, goodType, countryId, '', '');
			}
			else if(type == 2)
			{
				//省
				var countryId = self.searchResultArr[index].cId;
				var pid = self.searchResultArr[index].pId;
				var goodType = self.getGoodType(countryId, pid);
				self.setLocationDataAndDestory(name, goodType, countryId, '', '');
			}
			else if(type == 3)
			{
				//市
				var cityId = self.searchResultArr[index].cityId;
				//城市和景区需要处理携带物品须知！缺少接口
				self.getCityIdWithCountryId(cityId, name, '')
			}
			else if(type == 4)
			{
				//景区
				var cityId = self.searchResultArr[index].cityId;
				var sightId = self.searchResultArr[index].sightId;
				self.getCityIdWithCountryId(cityId, name, sightId)
			}
			
			
		}
		$("#search_input").on("input onpropertychange",function(){
			var searchContent = $("#search_input").val();
			if(searchContent)
			{
				showSearchResult(2);
				self.getDataWithKeyword(searchContent);
			}
			else
			{
				showSearchResult(0);
			}
		})
	},
	getDataWithKeyword : function (keyWord)
	{
		var self = this;
		var path = "common/getCityOrSightsWithKeyWord";
		var params = {};
		params.keyWord = keyWord;
		params.type = 1;//有景点
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			var error = resultJob.error;
			var dataJob = resultJob.data;
			if(error == 0)
			{
				self.searchResultArr = [];
				var countryInfo = dataJob.countryInfo;
				if(countryInfo)
				{
					for(var i in countryInfo)
					{
						var item = {};
						item.type = 1;
						item.cId = countryInfo[i].id;
						item.name = countryInfo[i].name;
						item.cityId = "";//城市id
						item.sightId = "";
						
						self.searchResultArr.push(item);
					}
				}
				var provinceInfo = dataJob.provinceInfo;
				if(provinceInfo)
				{
					for(var j in provinceInfo)
					{
						var item = {};
						item.type = 2;
						item.cId = provinceInfo[j].country;
						item.name = provinceInfo[j].name;
						item.cityId = "";//城市id
						item.sightId = "";
						
						item.pId = provinceInfo[j].id;

						self.searchResultArr.push(item);
					}
				}
				var cityInfo = dataJob.cityInfo;
				if(cityInfo)
				{
					for(var k in cityInfo)
					{
						var item = {};
						item.type = 3;
						item.cId = "";
						item.name = cityInfo[k].name;
						item.cityId = cityInfo[k].id;
						item.sightId = "";
						
						self.searchResultArr.push(item);
					}
				}
				var sightsInfo = dataJob.sightsInfo;
				if(sightsInfo)
				{
					for(var l in sightsInfo)
					{
						var item = {};
						item.type = 4;
						item.cId = "";
						item.name = sightsInfo[l].name;
						item.cityId = sightsInfo[l].city;
						item.sightId = sightsInfo[l].id;
						
						self.searchResultArr.push(item);
					}
				}
				
				self.scope.searchResultArr = self.searchResultArr;
				self.scope.$apply();
			}
			else
			{
			}
		});
	},
	getCityIdWithCountryId : function(cityId, cityName, sightId)
	{
		var self = this;
		var path = "common/getCityIdWithCountryId";
		var params = {};
		params.cityId = cityId;
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			var error = resultJob.error;
			if(error == 0)
			{
				var dataJob = resultJob.data;
				var country = dataJob.country;
				var province = dataJob.province;
				if(country && province)
				{
					var goodType = self.getGoodType(country, province);
				}
				else
				{
					var goodType = GOOD_CHINA;
				}
				
			}
			else
			{
				var goodType = GOOD_CHINA;
			}
			if(sightId)
			{
				self.setLocationDataAndDestory(cityName, goodType, '', cityId, sightId);
			}
			else
			{
				self.setLocationDataAndDestory(cityName, goodType, '', cityId, '');
			}
		});
	},
	/**
	 * 将搜索结果列表子项的数据保存到本地并关闭页面
	 * @param {Object} addressName
	 * @param {Object} goodType
	 * @param {Object} countryId
	 * @param {Object} cityId
	 * @param {Object} sightId
	 */
	setLocationDataAndDestory : function(addressName, goodType, countryId, cityId, sightId)
	{
		var sightObj = {};
		sightObj.name = addressName;//名字
		sightObj.cId = countryId;//国家id
		sightObj.cityId = cityId;//城市id
		sightObj.sightId = sightId;
		sightObj.goodsType = goodType;//携带物品须知
		mnWebMain.transferData(JSON.stringify(sightObj));
		mnWebMain.closeSelfViewController(0);
	},
	/**
	 * 根据国家id 和省id获取携带物品须知的类型
	 * @param {Object} countryId
	 * @param {Object} pid
	 */
	
	getGoodType : function(countryId, pid)
	{
		if(ID_CHINA == countryId)
		{
			if(pid)
			{
				if(pid == HONGKONG || pid == MEKAO)
				{
					return GOOD_HM;
				}
				else if(pid == TAIWAN)
				{
					return GOOD_TAIWAN;
				}
				else
				{
					return GOOD_CHINA;
				}
			}
			else
			{
				return GOOD_CHINA;
			}
		}
		else
		{
			return GOOD_FOREIN;
		}
	},
};
