/*
 * ==============================
 *  城市-景区选择
 * ==============================
 */

// 1. 获取module
var app = angular.module("app", []).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl', function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		SelectSightController.id = _utility.getQueryString("id");
		SelectSightController.idType = _utility.getQueryString("idType");
		SelectSightController.name = getLocalString(KPROVINCE_NAME);
		SelectSightController.init($scope);
	};
	mnWebMain.cbNavRightClicked = function()
	{
		var arr = ['取消', '确定'];
		mnWebMain.showDialog(1, '输入内容', '', arr, function(result)
		{
			var res = JSON.parse(result);
			var data = res.data;
			var index = data.index;
			var inputContent = data.inputContent;
			if(index == 1)
			{
				var sightObj = {};
				sightObj.name = inputContent;//名字
				sightObj.cId = "";//国家id
				sightObj.cityId = "";//城市id
				sightObj.sightId = "";
				sightObj.goodsType = GOOD_CHINA;//携带物品须知
				mnWebMain.transferData(JSON.stringify(sightObj));
				mnWebMain.closeSelfViewController(0);
			}
		});
	};
});
var SelectSightController = 
{
	id : null,
	name : null,
	idType : 0,//0表示国家id  1表示省份id
	scope : null,
	leftArr : [],
	rightArr : [],
	init : function($scope)
	{
		this.scope = $scope;
		//国外国家id
		if(this.idType == 0)
		{
			this.getForeignProvinces();
		}
		//国内省份id
		else if(this.idType == 1)
		{
			this.getChineseCities();
		}
		this.onClickFunction();
		
		this.ngRepeatFinish();
	},
	//获取国外的省
	getForeignProvinces : function()
	{
		var self = this;
		mnWebMain.getProvinces(this.id, function(result){
			var resultJob = JSON.parse(result);
			if( resultJob.error == 0 ){
				var dataJob = resultJob.data;
				var provinces = dataJob.provinces;
				//左边的列表
				var	name = provinces[0].name;
				var len = name.length;
				var p_name = name.substring(0, len-2);
				var pId = provinces[0].id;
				var leftItem = {};
				leftItem.checked = "active";
				leftItem.pId = pId;
				leftItem.name = p_name;
				self.leftArr = [];
				self.leftArr.push(leftItem);
				self.scope.leftArr = self.leftArr;
				self.scope.$apply();
				//右边的列表
				self.getForeignCities(pId, p_name);
			}else{
			}
		});
	},
	//根据国外省id获取国外的市
	getForeignCities : function(pid, pName)
	{
		var self = this;
		mnWebMain.getCitys(pid, function(result)
		{
			var resultJob = JSON.parse(result);
			if(resultJob.error == 0)
			{
				var dataJob = resultJob.data;
				var cities = dataJob.cities;
				//第一项是左侧的国外省份名称
				var firstRightItem = {};
				firstRightItem.cId = self.id;//国家id
				firstRightItem.name = pName;
				self.rightArr.push(firstRightItem);
				//省份下的城市
				for(var i in cities)
				{
					var rightItem = {};
					rightItem.cityId = cities[i].id;
					rightItem.name = cities[i].name;
					self.rightArr.push(rightItem);
				}
				self.scope.rightArr = self.rightArr;
				self.scope.$apply();
			}else{
			}
		});
	},
	//根据国内省份获取城市列表
	getChineseCities : function()
	{
		var self = this;
		mnWebMain.getCitys(this.id, function(result)
		{
			var resultJob = JSON.parse(result);
			if( resultJob.error == 0 ){
				var dataJob = resultJob.data;
				var cities = dataJob.cities;
				self.leftArr = [];
				for(var i in cities)
				{
					var leftItem = {};
					if(i == 0)
					{
						leftItem.checked = "active";
					}
					else
					{
						leftItem.checked = "";
					}
					leftItem.cityId = cities[i].id;
					leftItem.name = cities[i].name;
					self.leftArr.push(leftItem);
				}
				self.scope.leftArr = self.leftArr;
				self.scope.$apply();
				try
				{
					var firstId = cities[0].id;
					var firstName = cities[0].name;
					self.getChineseSights(firstId, firstName);
				}catch(e){
				}
			}else{}
		});
	},
	getChineseSights : function(cityId, cityName)
	{
		var self = this;
		mnWebMain.getSights(cityId, function(result)
		{
			self.rightArr = [];
			var resultJob = JSON.parse(result);
			if(resultJob.error == 0)
			{
				var dataJob = resultJob.data;
				var sights = dataJob.sights;
				var firstRightItem = {};
				firstRightItem.cityId = cityId;
				firstRightItem.sightId = "";
				firstRightItem.name = cityName;
				self.rightArr.push(firstRightItem);
				for(var i in sights)
				{
					var rightItem = {};
					rightItem.sightId = sights[i].id;
					rightItem.cityId = cityId;
					rightItem.name = sights[i].name;
					self.rightArr.push(rightItem);
				}
				self.scope.rightArr = self.rightArr;
				self.scope.$apply();
				document.getElementById("wrapper2").scrollTop = 0;
			}else{}
		});
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.leftClick = function(index)
		{
			//国外
			if(self.idType == 0)
			{
				//国外的国家就一个省，所以左侧列表无需点击事件
			}
			//国内省份id
			else if(self.idType == 1)
			{
				for(var i in self.leftArr)
				{
					//选中项样式
					if(i == index)
					{
						self.leftArr[i].checked = "active";
					}
					else
					{
						self.leftArr[i].checked = "";
					}
				}
				self.getChineseSights(self.leftArr[index].cityId, self.leftArr[index].name);
			}
		};
		this.scope.rightItemClick = function(index)
		{
			//国外
			if(self.idType == 0)
			{
				var sightObj = {};
				sightObj.name = self.rightArr[index].name;//名字
				sightObj.cId = self.rightArr[index].cId;//国家id
				sightObj.cityId = self.rightArr[index].cityId;//城市id
				sightObj.sightId = "";
				sightObj.goodsType = GOOD_FOREIN;//携带物品须知
				mnWebMain.transferData(JSON.stringify(sightObj));
				mnWebMain.closeSelfViewController(0);
			}
			//国内省份id
			else if(self.idType == 1)
			{
				var sightObj = {};
				sightObj.name = self.rightArr[index].name;//名字
				sightObj.cId = "";
				sightObj.cityId = self.rightArr[index].cityId;//城市id
				sightObj.sightId = self.rightArr[index].sightId;//景区id
				if(self.id)
				{
					switch(self.id)
					{
						case HONGKONG://香港，
						case MEKAO://澳门
							sightObj.goodsType = GOOD_HM;
							break;
						case TAIWAN://台湾
							sightObj.goodsType = GOOD_TAIWAN;
							break;
						default:
							sightObj.goodsType = GOOD_CHINA;
					}
				}
				mnWebMain.transferData(JSON.stringify(sightObj));
				mnWebMain.closeSelfViewController(0);
			}
		};
		
	},
	
	ngRepeatFinish : function(){
		var self = this;
		
		this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
//			setTimeout(function(){
//				self.leftIscrollInit();
//				self.rightIscrollInit();
//			},300);
		});
	},
	
//	leftIscrollInit : function()
//	{
//		var myScroll1 = new IScroll('#wrapper1', {click:true});
//	},
//	
//	rightIscrollInit : function()
//	{
//		var myScroll2 = new IScroll('#wrapper2', {click:true});
//	}
};
