/*
 * ==============================
 *  我的认证-编辑
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		MineApproveController.userId = getUserId();
		MineApproveController.userType = getUserType();
		MineApproveController.init($scope);
	};
});
var MineApproveController = 
{
	userId : null,
	userType : null,
	scope : null,
	genderType : 0,//0:男   1:女
	hasLegally : 0,//0:没有  1：有
	legallyLanguages : null,
	pictureArr : [],
	canDriver : 0,
	tourTime : 1,
	canAnswer : 0,
	canProvideLine : 0,
	familiarPlaceArr : [],
	freeTime : 0,
	init : function($scope)
	{
		this.scope = $scope;
		this.getMyInfo();
		this.onClickFunction();
	},
	getMyInfo : function()
	{
		var self = this;
		var path = API_GET_USEROBJ_BY_ID;
		var userIdArr = [];
		userIdArr.push(self.userId);
		var params = {};
		params.userIds = JSON.stringify(userIdArr);
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			if(resultJob.error == 0)
			{
				var dataJob = resultJob.data;
				var userObj = dataJob.userObjArr[self.userId];
				//昵称
				if (userObj.nickName) 
				{
					self.scope.nickName = userObj.nickName;
				}

				//真实姓名
				if (userObj.realName)
				{
					self.scope.realName = userObj.realName;
				}

				//所在地
				if (userObj.location) 
				{
					self.scope.location = userObj.location;
				}

				//性别
				if (userObj.gender == "0")
				{
					self.genderType = 0;
					self.scope.gender = "男";
				} 
				else if (userObj.gender == "1") 
				{
					self.genderType = 1;
					self.scope.gender = "女";
				}

				//出生年月
				if (userObj.birthday)
				{
					try
					{
						self.scope.birthday = userObj.birthday.substring(0, 10);
					}catch(e){
					}
				}
				//是否有导游证
				if (userObj.legallyNumber) 
				{
					self.scope.showLegallyInfo = "";
					self.hasLegally = 1;//0:没有  1：有
					self.scope.hasLegally = "有";
					self.scope.legallyNumber = userObj.legallyNumber;
					
					if (userObj.legallyLanguages)
					{
						self.legallyLanguages = userObj.legallyLanguages;
						self.getExpertLanguage(userObj.legallyLanguages); //导游证语种
					}

					//导游证颁发时间
					if (userObj.legallyTime)
					{
						self.scope.legallyTime = userObj.legallyTime;
					}

					//导游证图片
					if (userObj.legallyPhotos)
					{
						var legallyPhotos = JSON.parse(userObj.legallyPhotos);
						for (var j = 0; j < legallyPhotos.length; j++)
						{
							var iconItem = {};
							iconItem.small = legallyPhotos[j] + IMG_CUT_WH;
							iconItem.big = legallyPhotos[j];
							self.pictureArr.push(iconItem);
						}
						self.scope.pictureArr = self.pictureArr;
						if(self.pictureArr.length == 0)
						{
							self.scope.plusLegally = "";
							self.scope.legallyIconList = "hidden";
						}
						else
						{
							self.scope.plusLegally = "hidden";
							self.scope.legallyIconList = "";
						}
					}
					else
					{
						self.scope.plusLegally = "";
						self.scope.legallyIconList = "hidden";
					}
				}
				else
				{
					self.hasLegally = 0;
					self.scope.hasLegally = "无";
					self.scope.showLegallyInfo = "hidden";
				}

				//是否有驾照
				if (userObj.canDriver == "0")
				{
					self.canDriver = 0;
					self.scope.canDriver = "没有";
				} 
				else if (userObj.canDriver == "1")
				{
					self.canDriver = 1;
					self.scope.canDriver = "有";
				}

				//带团时间
				if (userObj.tourTime == "1") 
				{
					self.tourTime = 1;
					self.scope.tourTime = "3年以内";
				}
				else if (userObj.tourTime == "2")
				{
					self.tourTime = 2;
					self.scope.tourTime = "3-6年"
				} 
				else if (userObj.tourTime == "3") 
				{
					self.tourTime = 3;
					self.scope.tourTime = "6年以上"
				}
				else
				{
					self.tourTime = "3年以内"
					self.scope.tourTime = 1;
				}

				//是否愿意回答提问
				if (userObj.canAnswer == "0") 
				{
					self.canAnswer = 0;
					self.scope.canAnswer = "unChecked";
				} 
				else if (userObj.canAnswer == "1")
				{
					self.canAnswer = 1;
					self.scope.canAnswer = "checked";
				}

				//是否帮助用户制定路线
				if (userObj.canProvideLine == "0")
				{
					self.canProvideLine = 0;
					self.scope.canProvideLine = "unChecked";
				} 
				else if (userObj.canProvideLine == "1") 
				{
					self.canProvideLine = 1;
					self.scope.canProvideLine = "checked";
				}

				//熟悉的城市
				if (userObj.familiarPlace) 
				{
					try
					{
						self.familiarPlaceArr = userObj.familiarPlace.split("、");
					}catch(e){
						self.familiarPlaceArr = [];
					}
					self.scope.familiarPlaceArr = self.familiarPlaceArr;
				}

				//我的标签
				if (userObj.guideKeyword)
				{
					self.scope.guideKeyword = userObj.guideKeyword;
				}

				//自我评价
				if (userObj.selfEvaluation)
				{
					self.scope.selfEvaluation = userObj.selfEvaluation;
				}

				//人生格言
				if (userObj.lifeMotto) 
				{
					self.scope.lifeMotto = userObj.lifeMotto;
				}
				if (userObj.freeTime)
				{
					switch (parseInt(userObj.freeTime))
					{
						case 1:
							self.scope.freeTime = "全天";
							self.freeTime = 1;
							break;
						case 2:
							self.scope.freeTime = "双休";
							self.freeTime = 2;
							break;
						case 3:
							self.scope.freeTime = "周日";
							self.freeTime = 3;
							break;
						default:
							break;
					}
				}
				self.scope.$apply();
			}
		});
		
	},
	//获取语种列表
	getExpertLanguage : function(ids)
	{
		var self = this;
		var params = {};
		params.ids = ids;
		var path = API_GET_LANGUAGE;
		mnWebMain.httpRequest(path, params, function(result) {
			var resultJob = JSON.parse(result);
			if (resultJob.error == 0) {
				var dataJob = resultJob.data;
				var languages = dataJob.languages;
				var languageStr = "";
				for (var i in languages) {
					languageStr += languages[i].languageName + "、";
				}

				if (languageStr == "") {
					self.scope.language = "无";
				} else {
					try{
						languageStr = languageStr.substring(0, languageStr.length - 1);
					}catch(e){
					}
					self.scope.language = languageStr;
				}
				self.scope.$apply();
			} else {
			}
		});
	},
	onClickFunction : function()
	{
		var self = this;
		//所在地
		this.scope.locationClick = function()
		{
			var headObj = {};
    		mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_COUNTRY, "选择地区", headObj, function(result)
    		{
    			var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var name = dataJob.params;
				self.scope.location = name;
				self.scope.$apply();
    		});
		};
		//性别
		this.scope.genderClick = function()
		{
			var arr = ["男", "女", "取消"];
			mnWebMain.showDialog(2, "", "", arr, function(result)
			{
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				if(dataJob.index == 0)
				{
					self.genderType = 0;
					self.scope.gender = "男";
					self.scope.$apply();
				}
				else if(dataJob.index == 1)
				{
					self.genderType = 1;
					self.scope.gender = "女";
					self.scope.$apply();
				}
			});
		};
		//出生年月日
		this.scope.birthdayClick = function()
		{
			mnWebMain.chooseDateType(0, function(result)
			{
				var dataJob = JSON.parse(result).data;
				var time = dataJob.result;
				//出生时间不能大于当前时间
				var curTimeStamp = new Date().getTime(); //当前时间戳
				var s_time = time.replace(/-/g, "/");
				var sTimeStamp = new Date(s_time).getTime(); //生日
				if (sTimeStamp + 86400000 > curTimeStamp) 
				{
					var arr = ["确定"];
					mnWebMain.showDialog(0, "提示", "出生年月日不能大于当前时间！", arr);
					return;
				}
				self.scope.birthday = time;
				self.scope.$apply();
			}, "1");
		};
		//有无导游证
		this.scope.hasLegallyClick = function()
		{
			var arr = ["有", "没有", "取消"];
			mnWebMain.showDialog(2, "", "", arr, function(result)
			{
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				if (dataJob.index == 0) 
				{
					self.scope.showLegallyInfo = "";
					self.hasLegally = 1;//0:没有  1：有
					self.scope.hasLegally = "有";
					
				}
				else if (dataJob.index == 1)
				{
					self.scope.showLegallyInfo = "hidden";
					self.hasLegally = 0;//0:没有  1：有
					self.scope.hasLegally = "没有";
				}
				self.scope.$apply();
			});
		};
		//导游证语种
		this.scope.languageClick = function()
		{
			var headObj = {};
			headObj.leftTitle = "取消";
			headObj.rightTitle = "确定";
    		mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_LANGUAGE, "语种选择", headObj, function(result){
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var params = JSON.parse(dataJob.params);
				var txt = params.txt;
				self.legallyLanguages = params.id;
				self.scope.language = txt;
				self.scope.$apply();
			});
		};
		//添加导游证
		this.scope.addPic = function()
		{
			//最多上传两张
			var hasPicCount = self.pictureArr.length;
			var leftPicCount = 2 - hasPicCount;
			if(hasPicCount >= 2)
			{
				var arr = ["确定"];
				mnWebMain.showDialog("0", "提示", "证件照最多只能上传两张", arr);
				return;
			}
			var arr = ["拍照", "从相册选择", "取消"];
			mnWebMain.showDialog("2", "", "", arr, function(result) {
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				if (dataJob.index == "0") 
				{ //拍照
					mnWebMain.photoPicker(1, 0, 1, function(resultCamera) 
					{
						var resultCameraJob = JSON.parse(resultCamera);
						var dataCameraJob = resultCameraJob.data;
						var myImgs = JSON.parse(dataCameraJob.imageURLs);
						
						for (var j in myImgs)
						{
							var iconItem = {};
							iconItem.small = myImgs[j] + IMG_CUT_WH;
							iconItem.big = myImgs[j];
							self.pictureArr.push(iconItem);
						}
						self.scope.pictureArr = self.pictureArr;
						//如果没有图片了，
						if(self.pictureArr.length == 0)
						{
							self.scope.plusLegally = "";
							self.scope.legallyIconList = "hidden";
						}
						//如果有图片
						else
						{
							self.scope.plusLegally = "hidden";
							self.scope.legallyIconList = "";
						}
						self.scope.$apply();
					})
				} 
				else if (dataJob.index == "1")
				{ //相册
					mnWebMain.photoPicker(1, 2, leftPicCount, function(resultAlbum) 
					{
						var resultAlbumJob = JSON.parse(resultAlbum);
						var dataAlbumJob = resultAlbumJob.data;
						var myImgs = JSON.parse(dataAlbumJob.imageURLs);

						for (var j in myImgs)
						{
							var iconItem = {};
							iconItem.small = myImgs[j] + IMG_CUT_WH;
							iconItem.big = myImgs[j];
							self.pictureArr.push(iconItem);
						}
						self.scope.pictureArr = self.pictureArr;
						//如果没有图片了，
						if(self.pictureArr.length == 0)
						{
							self.scope.plusLegally = "";
							self.scope.legallyIconList = "hidden";
						}
						//如果有图片
						else
						{
							self.scope.plusLegally = "hidden";
							self.scope.legallyIconList = "";
						}
						self.scope.$apply();
					})
				}
			});
		};
		//导游证图片子项删除
		this.scope.iconClick = function($index)
		{
			self.pictureArr.splice($index, 1);
			self.scope.pictureArr = self.pictureArr;
			//如果没有图片了，
			if(self.pictureArr.length == 0)
			{
				self.scope.plusLegally = "";
				self.scope.legallyIconList = "hidden";
			}
			//如果有图片
			else
			{
				self.scope.plusLegally = "hidden";
				self.scope.legallyIconList = "";
			}
			self.scope.$apply();
		};
		//导游证颁发时间
		this.scope.legallyTimeClick = function()
		{
			mnWebMain.chooseDateType(0, function(result)
			{
				var dataJob = JSON.parse(result).data;
				var time = dataJob.result;
				var curTimeStamp = new Date().getTime(); //当前时间戳
				var s_time = time.replace(/-/g, "/");
				var sTimeStamp = new Date(s_time).getTime(); //生日
				if (sTimeStamp + 86400000 > curTimeStamp)
				{
					var arr = ["确定"];
					mnWebMain.showDialog(0, "提示", "导游证颁发时间不能大于当前时间！", arr);
					return;
				}
				var rzAge = self.scope.birthday;
				if (rzAge) 
				{
					var s_rzAge = rzAge.replace(/-/g, "/");
					if (s_time <= s_rzAge) {
						var arr = ["确定"];
						mnWebMain.showDialog(0, "提示", "导游证颁发时间不能小于出生年月日！", arr);
						return;
					}
				}
				else
				{
					var arr = ["确定"];
					mnWebMain.showDialog(0, "提示", "请先选择出生年月日！", arr);
					return;
				}
				self.scope.legallyTime = time;
				self.scope.$apply();
			});
		};
		this.scope.tourTimeClick = function()
		{
			var arr = ["3年以内", "3-6年", "6年以上", "取消"];
			mnWebMain.showDialog(2, "", "", arr, function(result)
			{
				var res = JSON.parse(result);
				var data = res.data;
				var error = res.error;
				if (error == 0) 
				{
					var index = parseInt(data.index);
					switch (index)
					{
						case 0:
							self.scope.tourTime = "3年以内";
							self.tourTime = 1;
							break;
						case 1:
							self.scope.tourTime = "3-6年";
							self.tourTime = 2;
							break;
						case 2:
							self.scope.tourTime = "6年以上";
							self.tourTime = 3;
							break;
						case 3:
							self.scope.tourTime = "3年以内";
							self.tourTime = 1;
							break;
						default:
							break;
					}
					self.scope.$apply();
				}
			});
		};
		this.scope.canDriverClick = function()
		{
			var arr = ["有", "没有", "取消"];
			mnWebMain.showDialog(2, "", "", arr, function(result)
			{
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				if (dataJob.index == 0) 
				{
					self.scope.canDriver = "有";
					self.canDriver = 1;
					self.scope.$apply();
				}
				else if (dataJob.index == 1)
				{
					self.scope.canDriver = "有";
					self.canDriver = 1;
					self.scope.$apply();
				}
			});
		};
		this.scope.canAnswerClick = function()
		{
			if(self.canAnswer == 0)
			{
				self.canAnswer = 1;
				self.scope.canAnswer = "checked";
			}
			else
			{
				self.canAnswer = 0;
				self.scope.canAnswer = "unChecked";
			}
			self.scope.$apply();
		};
		this.scope.canProvideLineClick = function()
		{
			if(self.canProvideLine == 0)
			{
				self.canProvideLine = 1;
				self.scope.canProvideLine = "checked";
			}
			else
			{
				self.canProvideLine = 0;
				self.scope.canProvideLine = "unChecked";
			}
			self.scope.$apply();
		};
		this.scope.familiarPlaceClick = function()
		{
			var headObj = {};
    		mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_COUNTRY, "选择地区", headObj, function(result)
    		{
    			var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var name = dataJob.params;
				var isAdd = true;
				for(var i = 0; i < self.familiarPlaceArr.length; i++)
				{
					if(name == self.familiarPlaceArr[i])
					{
						isAdd = false;
						break;
					}
				}
				if(isAdd)
				{
					self.familiarPlaceArr.push(name);
					self.scope.familiarPlaceArr = self.familiarPlaceArr;
					self.scope.$apply();
				}
				else
				{
					var arr = ['确定'];
					mnWebMain.showDialog(0, '提示', '该熟悉地已经存在！', arr);
				}
    		});
		};
		//熟悉的城市
		this.scope.familliarItemClick = function($index)
		{
			self.familiarPlaceArr.splice($index, 1);
			self.scope.familiarPlaceArr = self.familiarPlaceArr;
			self.scope.$apply();
		};
		this.scope.guideKeywordClick = function()
		{
			var headObj = {};
			headObj.rightTitle = "确定";
			mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_LABLE, "标签选择", headObj, function(result) 
			{
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var returnTxt = dataJob.params;
				self.scope.guideKeyword = returnTxt;
				self.scope.$apply();
			});
		};
		this.scope.selfEvaluationClick = function()
		{
			var headObj = {};
			headObj.rightTitle = "确定";
			mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_ASSESS, "自我评价", headObj, function(result) 
			{
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var params = JSON.parse(dataJob.params);
				self.scope.selfEvaluation = params.txt;
				self.scope.$apply();
			});
		};
		this.scope.freeTimeClick = function()
		{
			var arr = ['全天', '双休', '周日'];
			mnWebMain.showDialog(2, '', '', arr, function(result) 
			{
				var resultJob = JSON.parse(result);
				var error = resultJob.error;
				if (error == 0) 
				{
					var index = parseInt(resultJob.data.index);
					switch (index) 
					{
						case 0:
							self.scope.freeTime = "全天";
							self.freeTime = 1;
							break;
						case 1:
							self.scope.freeTime = "双休";
							self.freeTime = 2;
							break;
						case 2:
							self.scope.freeTime = "周日";
							self.freeTime = 3;
							break;
						default:
							break;
					}
					self.scope.$apply();
				}
			});
		};
		this.scope.submit = function()
		{
			var arr = ["确定"];
			var params = {};
			//昵称
			var nickName = self.scope.nickName;
			if (!nickName)
			{
				mnWebMain.showDialog(0, "提示", "请输入昵称！", arr);
				return;
			}
			params.nickName = nickName;
			//真实姓名
			var realName = self.scope.realName;
			if (!realName)
			{
				mnWebMain.showDialog(0, "提示", "请输入真实姓名！", arr);
				return;
			}
			params.realName = realName;

			//所在地
			var rzLocation = self.scope.location;
			if (!rzLocation) 
			{
				mnWebMain.showDialog(0, "提示", "请选择所在地！", arr);
				return;
			}
			params.location = rzLocation;

			//性别
			params.gender = self.genderType + "";

			//出生年月
			var rzAge = self.scope.birthday;
			if (!rzAge) 
			{
				mnWebMain.showDialog(0, "提示", "请选择所出生年月日！", arr);
				return;
			}
			params.birthday = rzAge;

			//是否有导游证
			var hasCard = self.hasLegally;
			if (hasCard == 1)
			{
				//导游证编号
				var rzCodeNum = self.scope.legallyNumber;
				if (!rzCodeNum) 
				{
					mnWebMain.showDialog(0, "提示", "请选择导游证编号！", arr);
					return;
				}
				params.legallyNumber = rzCodeNum;

				//导游证语种
				var rzLanguage = self.legallyLanguages;
				if (!rzLanguage) 
				{
					mnWebMain.showDialog(0, "提示", "请选择导游证语种！", arr);
					return;
				}
				params.legallyLanguages = rzLanguage;
				//导游证颁发时间
				var rzAwardTime = self.scope.legallyTime;
				if (!rzAwardTime) 
				{
					mnWebMain.showDialog(0, "提示", "请选择导游证颁发时间！", arr);
					return;
				}
				params.legallyTime = rzAwardTime;
				var picArr = [];
				for(var i = 0; i < self.pictureArr.length; i++)
				{
					picArr.push(self.pictureArr[i].big);
				}
				params.legallyPhotos = JSON.stringify(picArr); //导游证图片
			} 
			else
			{
				params.legallyNumber = "";
				params.legallyLanguages = "";
				params.legallyTime = "";
				params.legallyPhotos = "";
			}
			//带团时间 默认是3年一下
			params.tourTime = self.tourTime;

			//是否有驾照
			params.canDriver = self.canDriver + "";

			//是否愿意回答提问
			params.canAnswer = self.canAnswer + "";

			//是否帮助用户制定路线
			params.canProvideLine = self.canProvideLine + "";
			//熟悉的城市
			if (self.familiarPlaceArr.length == 0) 
			{
				mnWebMain.showDialog(0, "提示", "请选择熟悉的城市！", arr);
				return;
			}
			var familiarPlace = "";
			for(var i = 0; i < self.familiarPlaceArr.length; i++)
			{
				familiarPlace += self.familiarPlaceArr[i];
				if(i != self.familiarPlaceArr.length - 1)
				{
					familiarPlace += "、";
				}
			}
			params.familiarPlace = familiarPlace;

			//我的标签
			var myLable = self.scope.guideKeyword;
			if (!myLable) 
			{
				mnWebMain.showDialog(0, "提示", "请选择我的标签！", arr);
				return;
			}
			params.guideKeyword = myLable;

			//自我评价
			var selfEvaluation = self.scope.selfEvaluation;
			if (!selfEvaluation) 
			{
				mnWebMain.showDialog(0, "提示", "请选择自我评价！", arr);
				return;
			}
			params.selfEvaluation = selfEvaluation;

			//人生格言
			var lifeMotto = self.scope.lifeMotto;
			params.lifeMotto = lifeMotto;
			//空闲时间
			var freeTime = self.freeTime;
			if (freeTime == 0)
			{
				mnWebMain.showDialog(0, "提示", "请选择空闲时间！", arr);
				return;
			}
			params.freeTime = freeTime + "";
			self.certificate(getUserId(), JSON.stringify(params));
		};
	},
	certificate : function(guideId, certificateInfo)
	{
		var self = this;
		mnWebMain.showProgressDialog("请稍候");
		var params = {};
		params.guideId = guideId;
		params.certificateInfo = certificateInfo;
		var path = "guide/certificate";
		mnWebMain.httpRequest(path, params, function(result) {
			var res = JSON.parse(result);
			if (res.error == 0) {
				mnWebMain.dismissProgressDialog();
				self.getBasicInfo();

			} else {
				var arr = ["确定"];
				mnWebMain.dismissProgressDialog();
				mnWebMain.showDialog(0, "提示", res.errMsg, arr, function() {
					mnWebMain.closeSelfViewController(0);
				});
			}
		});
	},
	getBasicInfo : function()
	{
		var path = API_GET_USEROBJ_BY_ID;
		var userId = getUserId();
		var userIds = [];
		userIds.push(userId);
		var params = {};
		params.userIds = JSON.stringify(userIds);
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			if(resultJob.error == 0)
			{
				var userInfo = JSON.stringify(resultJob.data);
				saveLocalString(USER_INFO, userInfo);
			}
			var arr = ["确定"];
			mnWebMain.showDialog(0, "提示", "修改认证成功！", arr, function() {
				mnWebMain.closeSelfViewController(0);
			});
		});
		
	},
};
