/*
 * ==============================
 *  我的
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		if(/(Android)/i.test(navigator.userAgent))
		{
			MineController.isFirst = false;
		}
		else
		{
			MineController.isFirst = true;
		}
		MineController.init($scope);
	}
	mnWebMain.cbViewWillAppear = function()
	{
		if(MineController.isFirst)
		{
			MineController.isFirst = false;
		}
		else
		{
			MineController.setUserInfo();
		}
	}

});
var MineController = 
{
	userId : null,
	userType : null,
	isFirst : true,//是否是第一次加载页面
	//全局变量
	scope : null,
	userIcon : "",
	//初始化
	init : function($scope)
	{
		this.scope = $scope;
		this.setUserInfo();
		this.onClickFunction();
	},
	/**
	 * 设置用户信息
	 */
	setUserInfo : function()
	{
		this.userId = getUserId();
		this.userType = getUserType();
		if(this.userId)
		{
			$("#m_login").hide();
			$("#m_name_container").show();
			$("#m_jf_container").show();
			$("#loginOut").show();
			this.getMyInfo();
			this.scope.logout = function()
			{
				mnWebMain.logout(function(result)
				{
					MineController.userId = "";					//设置默认头像
					$("#m_avator").attr("style", "background-image: url(" + DefaultGudiesIcon + ");");
					
					//修改登录样式
					$("#m_login").show();
					$("#m_name_container").hide();
					$("#m_jf_container").hide();
					//登录按钮隐藏
					$("#loginOut").hide();
					//登录按钮点击事件
					MineController.scope.login = function()
					{
						mnWebMain.openViewController("TOLoginNavigationController");
					};
				});
			};
		}
		else
		{
			$("#m_login").show();
			$("#m_name_container").hide();
			$("#m_jf_container").hide();
			$("#loginOut").hide();
			$("#m_avator").attr("style", "background-image: url(" + DefaultGudiesIcon + ");");
	
			MineController.scope.login = function()
			{
				mnWebMain.openViewController("TOLoginNavigationController");
			};
		}
		
	},
	getMyInfo : function()
	{
		var localInfos = getLocalString(USER_INFO);
		try 
		{
			var infoJson = JSON.parse(localInfos);
			var myInfo = infoJson.userObjArr[this.userId];
			if (myInfo) 
			{
				//导游
				if (this.userType == USER_GUIDE) 
				{
					$("#mine_approve").show();
					$("#mine_footprint").show();
					this.setGuideInfo(myInfo);
				}
				//游客
				else if (this.userType == USER_TOURIST) 
				{
					$("#mine_approve").hide();
					$("#mine_footprint").hide();
					this.setVisitorInfo(myInfo);
				}
			}
		} catch (e) {}
		//本地的数据只是为了显示，再重新取一次服务器的数据
		this.getMyInfoFromServer();
	},
	getMyInfoFromServer : function()
	{
		var path = API_GET_INTEGRAL;
		var params = {};
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			var error = resultJob.error;
			if(error == 0)
			{
				var data = resultJob.data;
				var integral = data.integral;
				if (MineController.userType == USER_GUIDE)
				{
					
					try
					{
						var status = data.status;
					}catch(e){
						var status = 1;
					}
					$("#mine_approve").show();
					$("#mine_footprint").show();
					//已认证
					if (4 == parseInt(status)) 
					{
						$("#m_jf").attr("data-status", 4);
						$("#m_jf").text("积分：" + integral);
					}
					//认证中
					else if (2 == parseInt(status)) 
					{
						$("#m_jf").attr("data-status", 2);
						$("#m_jf").text("认证中");
						//点击去认证
					}
					//认证失败
					else if (3 == parseInt(status))
					{
						$("#m_jf").attr("data-status", 3);
						$("#m_jf").text("认证失败，马上去认证");
						//3表示未认证或者认证失败，不显示等级
					}
					//1未认证
					else 
					{
						$("#m_jf").attr("data-status", 1);
						$("#m_jf").text("未认证，马上去认证");
						//1表示未认证
					}
				}
				//游客
				else if (MineController.userType == USER_TOURIST)
				{
					$("#mine_approve").hide();
					$("#mine_footprint").hide();
					//积分
					if (!myInfo.integral) 
					{
						var integral = 0;
					} 
					else 
					{
						var integral = myInfo.integral;
					}
					$("#m_jf").text("积分：" + integral);
				}
				var intergalWh = $(".jf-value-con span").width();
				var hf_2 = intergalWh / 2;
			
				$(".jf-value").css("margin-left", "-" + hf_2 + "px");
			}
		});
	},
	setGuideInfo : function(myInfo)
	{
		//昵称
		var nickName = myInfo.nickName;
		$("#m_name").text(nickName)
		//头像
		var avator = myInfo.icon;
		if (avator) 
		{
			var mytx = JSON.parse(avator).url;
			this.userIcon = mytx;
			$("#m_avator").attr("style", "background-image: url(" + mytx + ');');
		}
		var integral = myInfo.integral;
		var status = myInfo.status;
		//已认证
		if (4 == parseInt(status)) 
		{
			$("#m_jf").attr("data-status", 4);
			$("#m_jf").text("积分：" + integral);
		}
		//认证中
		else if (2 == parseInt(status))
		{
			$("#m_jf").attr("data-status", 2);
			$("#m_jf").text("认证中");
			//点击去认证
		}
		//认证失败
		else if (3 == parseInt(status)) 
		{
			$("#m_jf").attr("data-status", 3);
			$("#m_jf").text("认证失败，马上去认证");
			//3表示未认证或者认证失败，不显示等级
		}
		//1未认证
		else 
		{
			$("#m_jf").attr("data-status", 1);
			$("#m_jf").text("未认证，马上去认证");
			//1表示未认证
		}
		this.setHeaderInfoStyle();
		//设置认证的点击事件
		this.scope.approveClick = function()
		{
			var status = $("#m_jf").attr("data-status");
			if (2 == parseInt(status))
			{
				//正在认证中，提示用户耐心等待
				var arr = ['确定'];
				mnWebMain.showDialog(0, '提示', '您已提交了认证，正在审核中，请耐心等待....', arr);
			} 
			else if (4 == parseInt(status))
			{
				//已认证,无需处理
			} 
			else 
			{
				var headObj = {};
				var page_url = URL_EDIT_MY_APPROVE;
				mnWebMain.openWebViewController(page_url, "我的导游", headObj);
			}
		};
		this.scope.modBaseInfo = function()
		{
			var headObj = {};
			headObj.rightTitle = "保存";
			var page_url = URL_MINE_MOD_INFO;
			mnWebMain.openWebViewController(page_url, "修改用户信息", headObj);
		};
		this.scope.modBasicInfo = function()
		{
			var headObj = {};
			headObj.rightTitle = "保存";
			var page_url = URL_MINE_MOD_INFO;
			mnWebMain.openWebViewController(page_url, "修改用户信息", headObj);
		};
	},
	setVisitorInfo : function(myInfo)
	{
		var nickName = myInfo.nickName;
		$("#m_name").text(nickName)
			//头像
		var avator = myInfo.icon;
		if (avator) {
			var mytx = JSON.parse(avator).url;
			this.userIcon = mytx;
			$("#m_avator").attr("style", "background-image: url(" + mytx + ');');
		}
		//积分
		if (!myInfo.integral) {
			var integral = 0;
		} else {
			var integral = myInfo.integral;
		}
		$("#m_jf").text("积分：" + integral);
		this.setHeaderInfoStyle();
		//修改昵称和性别
		this.scope.modBaseInfo = function()
		{
			var headObj = {};
			headObj.rightTitle = "保存";
			var page_url = URL_MINE_MOD_INFO;
			mnWebMain.openWebViewController(page_url, "修改用户信息", headObj);
		};
		$("#m_name_container").off("tap").on("tap", function() {
//			var nickName = $("#m_name").text();
//			var headObj = {};
//			headObj.rightTitle = "保存";
//			var page_url = BASE_PATH + PAGE_MINE_MODIFY + "?name=" + encodeURI(nickName);
//			mnWebMain.openWebViewController(page_url, "修改用户信息", headObj);
		});
		this.scope.modBasicInfo = function()
		{
			var headObj = {};
			headObj.rightTitle = "保存";
			var page_url = URL_MINE_MOD_INFO;
			mnWebMain.openWebViewController(page_url, "修改用户信息", headObj);
		};
	},
	onClickFunction : function()
	{
		var self = this;
		//客服电话
		this.scope.phoneService = function()
		{
			mnWebMain.getServicePhone(function(result)
			{
				var res = JSON.parse(result);
				var data = res.data;
				var phoneNumber = data.phoneNumber;
				var arr = ['拨打', '取消'];
				mnWebMain.showDialog(2, "", "", arr, function(result) 
				{
					var indexRes = JSON.parse(result);
					var indexData = indexRes.data;
					var index = indexData.index;
					if (index == 0 || index == 1) 
					{
						mnWebMain.phoneCall(phoneNumber);
					}
				});
			});
		};
		this.scope.setUserAvator = function()
		{
			self.userId = getUserId();
			if (self.userId) 
			{
				//如果已登录
				var arr = ["查看", "拍照", "从相册选择", "取消"];
				mnWebMain.showDialog("2", "", "", arr, function(result)
				{
					var res = JSON.parse(result);
					var data = res.data;
					var index = data.index;
					if(index == 0)
					{
						if(self.userIcon)
						{
							var iconArr = [];
							iconArr.push(self.userIcon);
							mnWebMain.browserPics(0, JSON.stringify(iconArr));
						}
						else
						{
							mnWebMain.toastInfo("没有头像信息！");
						}
					}
					else if (index == 1)
					{
						mnWebMain.photoPicker(0, 0, 1, function(result2) 
						{
							var res2 = JSON.parse(result2);
							var data2 = res2.data;
							var myImgs = JSON.parse(data2.imageURLs);
							$("#m_avator").attr("style", "background-image: url(" + myImgs[0] + ");");
							var imgObj = {};
							imgObj.url = myImgs[0];
							imgObj.image_width = "";
							imgObj.image_height = "";
							self.modifyMyIconInfo(JSON.stringify(imgObj)); //修改服务器和本地个人数据
						});
					} 
					else if (index == 2)
					{
						mnWebMain.photoPicker(0, 1, 1, function(result2)
						{
							var res2 = JSON.parse(result2);
							var data2 = res2.data;
							var myImgs = JSON.parse(data2.imageURLs);
							$("#m_avator").attr("style", "background-image: url(" + myImgs[0] + ');');
							var imgObj = {};
							imgObj.url = myImgs[0];
							imgObj.image_width = "";
							imgObj.image_height = "";
							self.modifyMyIconInfo(JSON.stringify(imgObj)); //修改服务器和本地个人数据
						});
					}
				});
			} 
			else
			{
				//如果未登录
				var arr = ['确定'];
				mnWebMain.showDialog("0", "提示", "登录后才能修改头像！", arr);
			}
		};
		this.scope.myOrange = function()
		{
			self.userId = getUserId();
			if(self.userId)
			{
				mnWebMain.openWebViewController(URL_MINE_ORANGE, "我的桔子");
			}
			else
			{
				mnWebMain.openViewController('TOLoginNavigationController');
			}
		};
		this.scope.myFoot = function()
		{
			self.userId = getUserId();
			if(self.userId)
			{
				var page_url = URL_FOOTPRINT +　"?guideId=" + self.userId;
				mnWebMain.openWebViewController(page_url, "我的足迹");
			}
			else
			{
				mnWebMain.openViewController('TOLoginNavigationController');
			}
		};
		this.scope.myApprove = function()
		{
			self.userId = getUserId();
			if(self.userId)
			{
				//如果已经认证或者认证中，跳进查看认证
				var myStatus = $("#m_jf").attr("data-status");
				if("2" == myStatus || "4" == myStatus)
				{
					var headObj = {};
					headObj.rightTitle = "编辑";
					mnWebMain.openWebViewController(ULR_MINE_APPROVE_PREVIEW, "我的认证", headObj);
				}
				else
				{
					var headObj = {};
		mnWebMain.openWebViewController(URL_EDIT_MY_APPROVE, "我的认证", headObj);
				}
			}
			else
			{
				mnWebMain.openViewController('TOLoginNavigationController');
			}
		};
		this.scope.myQuestion = function()
		{
			self.userId = getUserId();
			if(self.userId)
			{
				mnWebMain.openWebViewController(URL_MY_QUESTION, "我的提问");
			}
			else
			{
				mnWebMain.openViewController('TOLoginNavigationController');
			}
		};
		
		this.scope.myEva = function()
		{
			self.userId = getUserId();
			if(self.userId)
			{
				mnWebMain.openWebViewController(URL_MINE_EVALUATION, "我的评价");
			}
			else
			{
				mnWebMain.openViewController('TOLoginNavigationController');
			}
		};
		this.scope.mySign = function()
		{
			self.userId = getUserId();
			if(self.userId)
			{
				mnWebMain.openMySignDialog();
			}
			else
			{
				mnWebMain.openViewController('TOLoginNavigationController');
			}
		};
		this.scope.myIntegral = function()
		{
			self.userId = getUserId();
			if(self.userId)
			{
				mnWebMain.openWebViewController(URL_MY_INTEGRAL, "我的积分");
			}
			else
			{
				mnWebMain.openViewController('TOLoginNavigationController');
			}
		};
		this.scope.myContact = function()
		{
			self.userId = getUserId();
			if(self.userId)
			{
				mnWebMain.openContactController();
			}
			else
			{
				mnWebMain.openViewController('TOLoginNavigationController');
			}
		};
		this.scope.myFriend = function()
		{
			self.userId = getUserId();
			if(self.userId)
			{
				mnWebMain.shareFriend();
			}
			else
			{
				mnWebMain.openViewController('TOLoginNavigationController');
			}
		};
		this.scope.myMore = function()
		{
			self.userId = getUserId();
			if(self.userId)
			{
				mnWebMain.openWebViewController(URL_MINE_MORE, "更多");
			}
			else
			{
				mnWebMain.openViewController('TOLoginNavigationController');
			}
		};
	},
	/**
	 * 修改本地和服务器的头像信息
	 */
	modifyMyIconInfo : function(iconStr)
	{
		var self = this;
		var params = {};
		params.userId = this.userId;
		var modifyObj = {};
		modifyObj.icon = iconStr;
		params.modData = JSON.stringify(modifyObj);
		if(this.userType == USER_GUIDE)
		{
			var path = API_GUIDE_MOD_GUIDEOBJ;
		}
		else
		{
			var path = API_VISITOR_MOD_VISITOROBJ;
		}
		mnWebMain.httpRequest(path, params, function(result)
		{
			var res = JSON.parse(result);
			if( res.error == 0 )
			{
				//更新本地数据
				try{
					var localInfos = getLocalString(USER_INFO);
					var infoJson = JSON.parse(localInfos);
					var userObjArr = infoJson.userObjArr;
					userObjArr[self.userId].icon = iconStr;
					var newObj = {};
					newObj.userObjArr = userObjArr;
					saveLocalString(USER_INFO, JSON.stringify(newObj));
					mnWebMain.toastInfo("修改头像成功！");
				}catch(e){
				}
			}
			else
			{
				mnWebMain.toastInfo("修改头像失败！");
			}
		});
	},
	setHeaderInfoStyle : function()
	{
		var nickWh = $(".name-value-con span").width();
		var intergalWh = $(".jf-value-con span").width();
		
		var hf_1 = nickWh / 2;
		var hf_2 = intergalWh / 2;
	
		$(".name-value").css("margin-left", "-" + hf_1 + "px");
		$(".jf-value").css("margin-left", "-" + hf_2 + "px");
	},
}
