/**
 * 我的评价
 */
// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		EvaluationController.userType = getUserType();
		EvaluationController.userId = getUserId();
		mnWebMain.refresh("2");//上下拉刷新
		EvaluationController.init($scope);
	}
	mnWebMain.cbDownRefreshData = function()
	{
		EvaluationController.setDefault();
		EvaluationController.getMineEvaluationList(REFRESH);
	}
	mnWebMain.cbUpLoadData = function()
	{
		EvaluationController.getMineEvaluationList(LOAD_MORE);
	}
});
var EvaluationController = 
{
	//全局变量
	scope : null,
	currentIndex : 0,
	pageSize : 10,
	userType : null,
	userId : null,
	//数据模型
	evaluationArr : [],
	/**
	 * 初始化
	 */
	init : function($scope)
	{
		$Loading.start();
		this.scope = $scope;
		this.getMineEvaluationList(INIT);
		this.onClickFunction();
	},
	/**
	 * 重置变量
	 */
	setDefault : function()
	{
		this.evaluationArr = [];
		this.currentIndex = 0;
	},
	/**
	 * 获取我的评价列表
	 */
	getMineEvaluationList : function(refreshType)
	{
		this.getMineEvaList(this.userId, refreshType);
	},
	//获取我的被评价列表(导游)
	getMineEvaList : function(userId, refreshType)
	{
		var self = this;
		var params = {};
		if(refreshType == LOAD_MORE)
		{
			this.currentIndex++;	
		}
		else
		{
			this.currentIndex = 0;
		}
		var startIndex = this.currentIndex * this.pageSize;
		params.startIndex = startIndex;
		params.num = this.pageSize;
		
		if(this.userType == USER_GUIDE)
		{
			var path = API_GUIDE_GET_GUIDE_EVALUATION;
			params.guideId = userId;
		}
		else
		{
			var path = API_GET_EVALUATION;
			params.visitorId = userId;
		}
		mnWebMain.httpRequest(path, params, function(result)
		{
			$Loading.end();
			var resultData = JSON.parse(result);
			var err = resultData.error;
			if(err == 0)
			{
				mnWebMain.refreshFinish(REFRESH_SUCCESS);
				var evaluationArr = resultData.data.evaluation;
				if(evaluationArr.length == 0)
				{
					if(refreshType == INIT)
					{
						$(".undata").show();
					}
					else if(refreshType == REFRESH)
					{
						$(".undata").show();
					}
					else if(refreshType == LOAD_MORE)
					{
						mnWebMain.toastInfo("没有更多数据！");
					}
				}
				else
				{
					$(".undata").hide();
					self.refreshUi(evaluationArr);
				}
			}
			else
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_FAILED);
				}
				mnWebMain.toast(resultData.errMsg);
			}
		});
	},
	refreshUi : function(evaluationArr)
	{
		for(var i = 0; i < evaluationArr.length; i++)
		{
			var itemObj = {};
			//团id
			itemObj.groupId = evaluationArr[i].groupId;
			//评价人id
			if(this.userType == USER_GUIDE)
			{
				itemObj.evaedUserId = this.userId;	
				itemObj.evaUserId = evaluationArr[i].userId;
			}
			else
			{
				itemObj.evaUserId = this.userId;
				itemObj.evaedUserId = evaluationArr[i].userId;	
			}
			//被评价人id
			//头像
			var iconString = evaluationArr[i].icon;
			try{
				itemObj.icon = JSON.parse(iconString).url + IMG_CUT_WH;				
			}catch(e){
				itemObj.icon = DefaultGudiesIcon;
			}
			//时间
			try{
				itemObj.evaTime = evaluationArr[i].evaTime.substring(0, 10);
			}catch(e){
			}
			//昵称
			if(this.userType == USER_GUIDE)
			{
				var nickName = evaluationArr[i].nickName;
				try{
					nickName = nickName.substring(0, 1) + "***";					
				}catch(e){
					nickName = "****";
				}
				itemObj.nickName = nickName;
				itemObj.prefix = "";
				itemObj.suffix = "对你发表评论";
			}
			else
			{
				itemObj.nickName = evaluationArr[i].nickName;
				itemObj.prefix = "你对";
				itemObj.suffix = "发表评论";
			}
			//评分
			var starArr = [];
			var score =	parseInt(evaluationArr[i].evaScore) - 1;
			for(var j = 0; j < 5; j++)
			{
				if(score >= j)
				{
					starArr.push("assets/images/mine/assess_2.png");
				}
				else
				{
					starArr.push("assets/images/mine/assess_1.png");
				}
			}
			itemObj.starArr = starArr;
			this.evaluationArr.push(itemObj);
		}
		this.scope.evaluationArr = this.evaluationArr;
		this.scope.$apply();
		//ng-repeat完成回调
        this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
        });
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.itemClick = function(evaUserId, evaedUserId, groupId)
		{
			var showIconType = "0";
			if(self.userType == USER_GUIDE)
			{
				showIconType = "0";
			}
			else
			{
				showIconType = "1";
			}
			var pageUrl = URL_EVA_DETAIL + "?evaUserId=" + evaUserId 
							+ "&evaedUserId=" + evaedUserId
							+ "&groupId=" + groupId
							+ "&showIconType=" + showIconType;
			mnWebMain.openWebViewController(pageUrl, "评价详情", {});
		}
	},
}

