/*
 * ==============================
 *  我合作过的桔子
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		mnWebMain.refresh("2");
		MineCooperationController.userId = getUserId();
		MineCooperationController.init($scope);
	}
	/**
	 * 下拉刷新
	 */
	mnWebMain.cbDownRefreshData = function()
	{
		MineCooperationController.setDefaultData();
		MineCooperationController.getCooperationOrange(REFRESH);
	}
	/**
	 * 上拉加载更多
	 */
	mnWebMain.cbUpLoadData = function()
	{
		MineCooperationController.getCooperationOrange(LOAD_MORE);
	}

});
var MineCooperationController = 
{
	currentIndex : 0,
	num : 10,
	scope : null,
	userId : null,
	guideArr : [],
	init : function($scope)
	{
		$Loading.start();
		this.scope = $scope;
		this.setDefaultData();
		this.getCooperationOrange(INIT);
		this.onClickFunction();
	},
	setDefaultData : function()
	{
		this.currentIndex = 0;
		this.guideArr = [];
	},
	getCooperationOrange : function(refreshType)
	{
		var self = this;
		if(refreshType == LOAD_MORE)
		{
			this.currentIndex ++;
		}
		else
		{
			this.currentIndex = 0;
		}
		var path = API_GET_VISITOR_GUIDE;
		var params = {};
		params.startIndex = this.currentIndex * this.num;
		params.num = this.num;
		params.visitorId = this.userId;
		mnWebMain.httpRequest(path, params, function(result)
		{
			$Loading.end();
			var resultData = JSON.parse(result)
			if (resultData.error == 0)
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_SUCCESS);
				}
				var dataJob = resultData.data;
				var guideArr = dataJob.guide;
				var count = dataJob.count;
				self.scope.attCount = count;
				self.scope.$apply();
				if(guideArr.length != 0)
				{
					$(".undata").hide();
					self.refreshUi(guideArr, refreshType);
				}
				else
				{
					//没有数据
					if(refreshType == INIT)
					{
						$(".undata").show();
					}
					else if(refreshType == LOAD_MORE)
					{
						mnWebMain.toastInfo("没有更多数据！");
					}
					else if(refreshType == REFRESH)
					{
						$(".undata").show();
					}
				}
			}
			else
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_FAILED);
				}
				mnWebMain.toastInfo(resultData.errMsg);
			}
		});
	},
	refreshUi : function(data, refreshType)
	{
		for(var i = 0; i < data.length; i++)
		{
			var itemObj = {};
			itemObj.userId = data[i].userId;//id
			
			itemObj.nickName = data[i].nickName;//昵称
			
			if (!data[i].icon || data[i].icon == null) {
				var orange_icon = DefaultGudiesIcon;
			} else {
				var icon = JSON.parse(data[i].icon);
				var orange_icon = icon.url + IMG_CUT_WH;
			}
			itemObj.icon = orange_icon;
			
			//年龄
//			var birthdayYear = data[i].birthday.split("-")[0];
//			var myDate = new Date();
//			var nowYear = myDate.getFullYear();
//			var age = parseInt(nowYear) - parseInt(birthdayYear);
//			itemObj.age = age;
			
			//性别
			if (data[i].gender == "0") {
				var sex_class = "icon_boy"; //男
			} else {
				var sex_class = "icon_girl"; //女
			}
			itemObj.sex_class = sex_class;
			//等级
			var iconName = 'a15.png';
			var status = data[i].status;
			var orangerLv = data[i].lv;
			if (orangerLv == 0) {
				iconName = 'b1.png';
			}
			if (4 == parseInt(status) && orangerLv != 0) {
				iconName = 'a' + orangerLv + '.png';
			} else if (orangerLv != 0) {
				iconName = 'b' + orangerLv + '.png';
			}
			itemObj.iconName = PATH_LEVEL_ICON + iconName;
			//地点
			if (data[i].location == "" || data[i].location == null) {
				var orange_location = "暂无数据"
			} else {
				var orange_location = data[i].location;
			}
			itemObj.location = orange_location;
			
			var eva = data[i].evaluation;
			if (eva && (eva != 0.00 || eva != 0)) {
				eva = "好评率：" + accMul(parseFloat(eva), 20) + "%";
			} else {
				eva = '好评率：暂无';
			}
			itemObj.eva = eva;
			this.guideArr.push(itemObj);
		}
		this.scope.guideArr = this.guideArr;
		this.scope.$apply();
		if (LOAD_MORE == refreshType) {
			var sHeight = document.body.scrollTop;
			document.body.scrollTop = sHeight + 50;
		}
		//ng-repeat完成回调
        this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
        });
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.itemClick = function(itemUserId)
		{
			self.userId = getUserId();
			if(self.userId)
			{
				var jumpUrl = URL_PERSONAL_DETAILS + "?userId=" + itemUserId;
				mnWebMain.openWebViewController(jumpUrl, "个人详情");
			}
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController"); //打开登录页面
			}
		};
		this.scope.itemChat = function(itemUserId, itemNickName, $event)
		{
			$event.stopPropagation();
			self.userId = getUserId();
			if (self.userId) {
				mnWebMain.chat(1, itemUserId, itemNickName);
			} else {
				mnWebMain.openViewController("TOLoginNavigationController"); //打开登录页面
			}
		};
	},
}
