/*
 * ==============================
 *  桔子筛选-语种选择
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		FilterLanguageController.init($scope);
	};
	//语种选择确定
	mnWebMain.cbNavRightClicked = function(){
		var params = {};
		var arr = [];
		var langStr = "";
		for(var i = 0; i < FilterLanguageController.languagesArr.length; i++)
		{
			if(FilterLanguageController.languagesArr[i].checked)
			{
				arr.push(FilterLanguageController.languagesArr[i].id);
				langStr += FilterLanguageController.languagesArr[i].languageName + "、";
			}
		}
		params.txt = langStr.substr(0, langStr.length-1);
		params.id = JSON.stringify(arr);
		
		mnWebMain.transferData(JSON.stringify(params));//页面传值
		mnWebMain.closeSelfViewController(0);//关闭当前页面
	}
});
var FilterLanguageController = 
{
	scope : null,
	languagesArr : [],
	init : function($scope)
	{
		this.scope = $scope;
		$Loading.start();
		this.getAllLanguage();
		this.onClickFunction();
	},
	//获取全部语种
	getAllLanguage : function()
	{
		var self = this;
		var params = {};
		var path = API_GET_ALL_LANGUAGE;
		mnWebMain.httpRequest(path, params, function(result)
		{
			$Loading.end();
			var resultJob = JSON.parse(result);
			if( resultJob.error == 0 ){
				var dataJob = resultJob.data;
				var languages = dataJob.languages;
				var languageItemNo = {};
				languageItemNo.id = -1;
				languageItemNo.languageName = "不限";
				languageItemNo.checked = "active";
				self.languagesArr.push(languageItemNo);
				for(var i in languages)
				{
					var languageItem = languages[i];
					languageItem.checked = "";
					self.languagesArr.push(languageItem);
				}
				self.scope.languagesArr = self.languagesArr;
				self.scope.$apply();
			}else{
			}
		});
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.itemClick = function(id, checked)
		{
			/**
			 * 如果选择不限，则其他选中语言变成未选中
			 */
			if(id == -1)
			{
				for(var i = 0; i < self.languagesArr.length; i++)
				{
					if(self.languagesArr[i].id == -1)
					{
						self.languagesArr[i].checked = "active";
					}
					else
					{
						self.languagesArr[i].checked = "";
					}
				}
				self.scope.languagesArr = self.languagesArr;
				self.scope.$apply();
			}
			else
			{
				try{
					self.languagesArr[0].checked = "";
				}catch(e){
				}
				for(var i = 0; i < self.languagesArr.length; i++)
				{
					if(self.languagesArr[i].id == id)
					{
						if(checked)
						{
							self.languagesArr[i].checked = "";
						}
						else
						{
							self.languagesArr[i].checked = "active";
						}
						break;
					}
				}
				self.scope.languagesArr = self.languagesArr;
				self.scope.$apply();
			}
		};
	}
};
