/*
 * ==============================
 *  足迹(包括所有足迹，我的足迹和查看他人足迹)
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	
	mnWebMain.cbBridgeInited = function()
	{
		try{
			FootController.guideId = _utility.getQueryString("guideId");
		}catch(e){
		}
		mnWebMain.refresh("2");
		FootController.init($scope);
	}
	
	mnWebMain.cbUpLoadData = function(){
		FootController.pageIndexFunction();
	}
	
	mnWebMain.cbDownRefreshData = function(){
		FootController.setDefault();
		FootController.getFootList();
	}
	mnWebMain.cbNavRightClicked = function(){
		var headObj = {};
		headObj.leftTitle = "取消";
		headObj.rightTitle = "发布";
		mnWebMain.openWebViewControllerWithDataTransfer(URL_PUBLISH_FOOTPRINT, "发布足迹", headObj, function(result){
			$Loading.start();
			FootController.setDefault();
			FootController.getFootList();
		});
	}
});

var FootController = {
	guideId : null,
	//全局变量
	scope : null,
	
	nickName : null,
	
	pageIndex : {
		currentPage : 1,
		totalPage : null,
		num : 10,
	},
	
	//数据模型
	footMarkArr : [],
	
	//初始化
	init : function($scope){
		
		$Loading.start();
		
		this.scope = $scope;
		
		this.getFootList();
		
		this.onClickFunction();
		
	},
	
	//设置默认
	setDefault : function(){
		this.footMarkArr = [];
		this.pageIndex.currentPage = 1;
		this.pageIndex.totalPage = null;
	},
	
	//获取足迹列表
	getFootList : function(){
		var self = this;
		
		var params = {};
		params.startIndex = (this.pageIndex.currentPage - 1) * this.pageIndex.num;
		params.num = this.pageIndex.num;
		if(this.guideId)
		{
			params.guideId = this.guideId;
		}
		else
		{
			params.guideId = "";
		}
		
		
		var path = API_GET_FOOTMARKS;
		mnWebMain.httpRequest(path, params, function(result){
			mnWebMain.refreshFinish(REFRESH_SUCCESS);
			var err = JSON.parse(result).error;
			if(err != 0)
			{
				return;
			}
			
			var footMarkArr = JSON.parse(result).data.footMarkArr;
			var count = JSON.parse(result).data.count;
			self.pageIndex.totalPage = self.getTotalpages(count,self.pageIndex.num);
			
			if(footMarkArr.length == 0)
			{
				self.isUnData(true);
				$Loading.end();
			}
			else
			{
				self.isUnData(false);
			    self.footListCallBack(footMarkArr);
			}
		});
	},
	
	//足迹列表回调
	footListCallBack : function(data){
		var self = this;
		
		mnWebMain.refreshFinish(REFRESH_SUCCESS);
		var userId = getUserId();
		for(var i = 0 ; i < data.length ; i ++)
		{
			var itemObj = {};
			itemObj.id = data[i].id;
			itemObj.guideId = data[i].guideId;
			itemObj.content = data[i].content;
			itemObj.locationName = JSON.parse(data[i].place).locationName;
			itemObj.placeClass = (JSON.parse(data[i].place).locationName == "") ? "hidden" : "";
			itemObj.nickName = self.setNickName(data[i].nickName);
			itemObj.gender = data[i].gender;
			itemObj.praiseNum = data[i].praiseNum;
			itemObj.commentNum = data[i].commentNum;
			var publishTime = getDaysBefore(data[i].publishTime);
			itemObj.publishTime = publishTime;
			if(userId)
			{
				var isPraised = isFPPraised(userId, data[i].id);
				if(isPraised)
				{
					itemObj.praiseIcon = "praised";//
				}
				else
				{
					itemObj.praiseIcon = "unpraise";//
				}
			}
			else
			{
				itemObj.praiseIcon = "unpraise";//
			}
			itemObj.genderIcon = (data[i].gender == 0) ? "male" : "female";
			itemObj.ageColor = (data[i].gender == 0) ? "age-male" : "age-female";
			itemObj.lvIcon = this.getLevelIcon(data[i].lv,data[i].status);
			itemObj.imgClass = (JSON.parse(data[i].pics).length > 1) ? "img-s2" : "img-s1";
			var picArr = [];
			for(var j = 0 ; j < JSON.parse(data[i].pics).length ; j++)
			{
				var imgItem = {};
				imgItem.imgSrc = JSON.parse(data[i].pics)[j] + IMG_CUT_WH;
				imgItem.imgBig = JSON.parse(data[i].pics)[j];
				picArr.push(imgItem);
			}
			itemObj.pics = picArr;
			itemObj.icon = this.judgeIconIsNull(data[i].icon);
			itemObj.age = this.getUserAge(data[i].birthday) + "岁";
			
			var commentsArr = [];
			for(var j = 0 ; j < data[i].commentsArr.length ; j++)
			{
				var commItem = {};
				commItem.nickName = data[i].commentsArr[j].nickName;
				commItem.commentContent = data[i].commentsArr[j].commentContent;
				commentsArr.push(commItem);
			}
			itemObj.commentsArr = commentsArr;
			this.footMarkArr.push(itemObj);
		}
		this.scope.footMarkArr = this.footMarkArr;
		this.scope.$apply();
		
		//ng-repeat完成回调
        this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
        	$Loading.end();
        });
	},
	
	setNickName : function(dataNick)
	{
		var retNick = "";
		
		if(dataNick.length > 7)
		{
			retNick = dataNick.substring(0,6) + "...";
		}
		else
		{
			retNick = dataNick;
		}
		
		return retNick;
	},
	
	
	//分页
	pageIndexFunction : function(){
		var self = this;
		
		if(this.pageIndex.currentPage < this.pageIndex.totalPage)
		{
			this.pageIndex.currentPage ++;
			
			var params = {};
			params.startIndex = (this.pageIndex.currentPage - 1) * this.pageIndex.num;
			params.num = this.pageIndex.num;
			params.guideId = "";
			
			var path = API_GET_FOOTMARKS;
			mnWebMain.httpRequest(path, params, function(result){
				var err = JSON.parse(result).error;
				if(err != 0)
				{
					return;
				}
				
				var footMarkArr = JSON.parse(result).data.footMarkArr;
				self.footListCallBack(footMarkArr);
			});
		}
		else
		{
			mnWebMain.refreshFinish(REFRESH_SUCCESS);
			mnWebMain.toastInfo("没有更多数据");
		}
	},
	
	onClickFunction : function(){
		var self = this;
		
		//头像点击事件
		this.scope.userIconClick = function(guideId){
			var userId = getUserId();
			if(self.guideId && self.guideId == userId)
			{
				//如果查看的是自己的足迹，则无响应
				return;
			}
			if (userId) {
				var jumpUrl = URL_PERSONAL_DETAILS + "?userId=" + guideId;
				mnWebMain.openWebViewController(jumpUrl, "个人详情");
			} else {
				mnWebMain.openViewController("TOLoginNavigationController");//打开登录页面
			}
		};
		
		//点赞
		this.scope.priaseClick = function(id){
			var userId = getUserId();
			if(self.guideId && self.guideId == userId)
			{
				//如果查看的是自己的足迹，则无响应
				return;
			}
			if(userId)
			{
				var params = {};
				params.footMarkId = id;
				var path = API_PRAISE;
				
				mnWebMain.httpRequest(path, params, function(result){
					var res = JSON.parse(result);
					if( res.error == 0 )
					{
						FootController.upDatePiarse(id, userId);
					}
					else
					{
						mnWebMain.toastInfo("点赞失败");
					}
				});
			}
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController");//打开登录页面
			}
		};
		
		//评论
		this.scope.commentsClick = function(id){
			var userId = getUserId();
			if(self.guideId && self.guideId == userId)
			{
				//如果查看的是自己的足迹，则无响应
				return;
			}
			
			if(userId)
			{
				mnWebMain.showOrDismissBottomInput(0, function(result){
					var res = JSON.parse(result);
					var data = res.data;
					var content = data.content;
					if(content)
					{
						FootController.submitComments(content,id);
					}
					else
					{
						mnWebMain.toastInfo("请输入评论内容！");
					}
				});
			}
			else
			{
				mnWebMain.openViewController("TOLoginNavigationController");//打开登录页面
			}
		};
		
		//预览图片
		this.scope.previewImage = function(pics,index){
			var imgArr = [];
			for(var i = 0 ; i < pics.length ; i ++)
			{
				imgArr.push(pics[i].imgBig); 
			}
			
		    mnWebMain.browserPics(index, JSON.stringify(imgArr));
		};
	},
	
	//更新点赞数据模型,并保存点赞数据到本地
	upDatePiarse : function(id, userId){
		var self = this;
		for(var i = 0 ; i < self.footMarkArr.length ; i++)
		{
			if(self.footMarkArr[i].id == id)
			{
				if(self.footMarkArr[i].praiseIcon == "praised")
				{
					mnWebMain.toastInfo("已点赞");
				}
				else
				{
					self.footMarkArr[i].praiseIcon = "praised";
					self.footMarkArr[i].praiseNum = parseInt(self.footMarkArr[i].praiseNum) + 1;
				}
				break;
			}
		}
		self.scope.$apply();
		setFPPraise(userId, id);
	},
	
	//提交评论
	submitComments : function(content,id){
		var self = this;
		var params = {};
		params.footMarkId = id;
		params.commentContent = content;
		var path = API_COMMENT_FOOTMARK;
		
		mnWebMain.httpRequest(path, params, function(result){
			var res = JSON.parse(result);
			try
			{
				var userId = getUserId();
				self.nickName = JSON.parse(getLocalString(USER_INFO)).userObjArr[userId].nickName;
			}catch(e){
			}
			if( res.error == 0 )
			{
				for(var i = 0 ; i < self.footMarkArr.length ; i ++)
				{
					if(self.footMarkArr[i].id == id)
					{
						var item = {};
						item.nickName = self.nickName;
						item.commentContent = content;
						self.footMarkArr[i].commentsArr.unshift(item);
						break;
					}
				}
				self.scope.$apply();
			}
			else
			{
				mnWebMain.toastInfo("评论失败");
			}
		});
		
	},
	
	getLevelIcon : function(lv,status){
		var iconName = 'a15.png';
		
		if(lv == 0)
		{
			iconName = 'b1.png';
		}
		if(4 == parseInt(status) && lv != 0)
		{
			iconName = 'a' + lv + '.png';
		}
		else if(lv != 0)
		{
			iconName = 'b' + lv + '.png';
		}
		
		var retVal = PATH_LEVEL_ICON + iconName;
		
		return retVal;
	},
	
	judgeIconIsNull : function(icon){
		var retVal = "";
		
		if(icon)
		{
			retVal = JSON.parse(icon).url + IMG_CUT_WH;
		}
		else
		{
			retVal = DefaultGudiesIcon;
		}
		return retVal;
	},
	
	getUserAge : function(birth){
		var age = 0;
		
		if(birth){
			var birthdayYear = birth.split(".")[0];
			var myDate = new Date();
			var nowYear = myDate.getFullYear();
			age = parseInt( nowYear ) - parseInt( birthdayYear );
		}
		
		return age;
	},
	
	isUnData : function(sta){
		if(sta)
		{
			$(".undata").show();
		}
		else
		{
			$(".undata").hide();
		}
	},
	
	getTotalpages : function(count,num)
	{
		var pagecount = "";
	   	var remainder = count%num;
	   	var integer = parseInt(count/num);
	   	if(remainder == 0)
	   	{
	   	 	pagecount = integer;
	   	}
	   	else
	   	{
	   	 	pagecount = integer + 1;
	   	}
	   	return pagecount;
	},

}