/*
 * ==============================
 *  导游评价列表
 * ==============================
 */


// 1. 获取module
var app = angular.module("app",[]).run(function() {
	FastClick.attach(document.body);
});

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	/**
	 * 页面初始化
	 */
	mnWebMain.cbBridgeInited = function()
	{
		mnWebMain.refresh("2");//支持上下拉刷新
		GuideEvaController.guideId = _utility.getQueryString('guideId');
		GuideEvaController.init($scope);
	}
	/**
	 * 下拉刷新
	 */
	mnWebMain.cbDownRefreshData = function()
	{
		GuideEvaController.setDefaultData();
		GuideEvaController.getEvaList(REFRESH);
	}
	/**
	 * 上拉加载更多
	 */
	mnWebMain.cbUpLoadData = function()
	{
		GuideEvaController.getEvaList(LOAD_MORE);
	}
});
var GuideEvaController = 
{
	//全局变量
	scope : null,
	guideId : null,
	currentIndex : 0,
	pageSize : 10,
	evaluationArr : [],
	init : function($scope)
	{
		$Loading.start();
		this.scope = $scope;
		this.setDefaultData();
		this.getEvaList(INIT);
		this.onClickFunction();
	},
	setDefaultData : function()
	{
		this.currentIndex = 0;
		this.evaluationArr = [];
	},
	/**
	 * 获取评价列表
	 */
	getEvaList : function(refreshType)
	{
		var self = this;
		if(refreshType == LOAD_MORE)
		{
			this.currentIndex ++;
		}
		else
		{
			this.currentIndex = 0;
		}
		var path = API_GET_GUIDE_EVALUATION;
		var params = {};
		var startIndex = this.currentIndex * this.pageSize;
		params.startIndex = startIndex;
		params.num = this.pageSize;
		params.guideId = this.guideId;
		mnWebMain.httpRequest(path, params, function(result)
		{
			$Loading.end();
			var resultData = JSON.parse(result);
			var error = resultData.error;
			if(error == 0)
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_SUCCESS);
				}
				var evaluationArr = resultData.data.evaluation;
				if(evaluationArr.length != 0)
				{
					$(".undata").hide();
					self.refreshUi(evaluationArr, refreshType);
				}
				else
				{
					//没有数据
					if(refreshType == INIT)
					{
						$(".undata").show();
					}
					else if(refreshType == LOAD_MORE)
					{
						mnWebMain.toastInfo("没有更多数据！");
					}
					else if(refreshType == REFRESH)
					{
						$(".undata").show();
					}
				}
			}
			else
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_FAILED);
				}
				//获取数据失败！
				mnWebMain.toast(resultData.errMsg);
			}
		});
	},
	refreshUi : function(data, refreshType)
	{
		for (var i = 0; i < data.length; i++)
		{
			var itemObj = {};
			itemObj.userId = data[i].userId;
			itemObj.groupId = data[i].groupId;
			itemObj.evaScore = data[i].evaScore;
			itemObj.evaContent = data[i].evaContent;
//			itemObj.evaContent = "一大堆文本一大堆文本一大堆文本一大堆文本一大堆文本一大堆文本一大堆文本一大堆文本";
			var nickName = data[i].nickName;
			try{
				nickName = nickName.substring(0, 1) + "***";				
			}catch(e){
				nickName = "****";
			}
			itemObj.nickName = nickName;
			var iconString = data[i].icon;
			try{
				itemObj.icon = JSON.parse(iconString).url + IMG_CUT_WH;				
			}catch(e){
				itemObj.icon = DefaultGudiesIcon;
			}
			try{
				itemObj.evaTime = data[i].evaTime.substring(0, 16);
			}catch(e){
			}
			var starArr = [];
			var score =	parseInt(itemObj.evaScore) - 1;
			for(var j = 0; j < 5; j++)
			{
				if(score >= j)
				{
					starArr.push("assets/images/mine/assess_2.png");
				}
				else
				{
					starArr.push("assets/images/mine/assess_1.png");
				}
			}
			itemObj.starArr = starArr;
			this.evaluationArr.push(itemObj);
		}
		
		this.scope.evaluationArr = this.evaluationArr;
		this.scope.$apply();
		//ng-repeat完成回调
        this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
        });
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.itemClick = function(evaUserId, groupId)
		{
			var showIconType = "0";
			var pageUrl = URL_EVA_DETAIL + "?evaUserId=" + evaUserId 
							+ "&evaedUserId=" + self.guideId
							+ "&groupId=" + groupId
							+ "&showIconType=" + showIconType;
			mnWebMain.openWebViewController(pageUrl, "TA的评价", {});
		}
	},
}
