/**
 * 
 * @param {Object} refreshType  	刷新类型
 * @param {Object} controller		调用该方法的controller
 * @param {Object} startIndex		起始位置
 * @param {Object} keyword			关键字
 * @param {Object} gender			性别
 * @param {Object} grade			等级
 * @param {Object} tourTime			带团时间
 * @param {Object} hasLegally		有无导游证
 * @param {Object} region			地区	
 * @param {Object} language			语言
 * @param {Object} sortType			排序
 * @param {Object} freeStartTime	空闲开始时间
 * @param {Object} freeEndTime		空闲结束时间
 */
var getCitrusList = function(refreshType,
							 controller,
							 startIndex, 
							 keyword, 
							 gender,
							 grade,
							 tourTime,
							 hasLegally,
							 region, 
							 language, 
							 sortType,
							 freeStartTime,
							 freeEndTime)
{
	var params = {};
	params.startIndex = startIndex;
	params.num = 10;
	if (!keyword) {
		params.keyword = "";
	} else {
		params.keyword = keyword;
	}
	if (gender != undefined && gender != -1) 
	{
		params.gender = gender;
	}

	if (grade) {
		params.grade = grade;
	} else {
		params.grade = 0;
	}

	if (tourTime && tourTime != -1) {
		params.tourTime = tourTime;
	}

	if (hasLegally && hasLegally != -1) {
		params.hasLegally = hasLegally;
	}

	if (region) {
		params.region = region;
	}

	if (language) {
		params.language = language;
	}

	if (sortType) {
		params.sortType = sortType;
	} else {
		params.sortType = 0;
	}
	if (freeStartTime && freeEndTime) {
		params.freeStartTime = freeStartTime;
		params.freeEndTime = freeEndTime;
	} else {
		params.freeStartTime = '';
		params.freeEndTime = '';
	}
	var path = API_GET_GUIDES;
	mnWebMain.httpRequest(path, params, function(result)
	{
		var resultJob = JSON.parse(result);
		$Loading.end();
		var error = resultJob.error;
		if(error == 0)
		{
			if(refreshType != INIT)
			{
				mnWebMain.refreshFinish(REFRESH_SUCCESS);
			}
			var guideArr = resultJob.data.guideArr;
			if(guideArr.length != 0)
			{
				$(".undata").hide();
				controller.refreshUi(guideArr, refreshType);
			}
			else
			{
				//没有数据
				if(refreshType == INIT)
				{
					$(".undata").show();
					controller.scope.guideArr = controller.guideArr;
					controller.scope.$apply();
				}
				else if(refreshType == LOAD_MORE)
				{
					mnWebMain.toastInfo("没有更多数据！");
				}
				else if(refreshType == REFRESH)
				{
					$(".undata").show();
					controller.scope.guideArr = controller.guideArr;
					controller.scope.$apply();
				}
			}
		}
		else
		{
			if(refreshType != INIT)
			{
				mnWebMain.refreshFinish(REFRESH_FAILED);
			}
			mnWebMain.toastInfo(resultData.errMsg);
		}
	});
};
