/*
 * ==============================
 *  评价详情
 * ==============================
 */

// 1. 获取module
var app = angular.module("app", []).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl', function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		OrangeEvaController.showIconType = _utility.getQueryString("showIconType");
		OrangeEvaController.evaUserId = _utility.getQueryString("evaUserId");
		OrangeEvaController.evaedUserId = _utility.getQueryString("evaedUserId");
		OrangeEvaController.groupId = _utility.getQueryString("groupId");
		OrangeEvaController.myUserId = getUserId();
		OrangeEvaController.init($scope);
		
	};
});
var OrangeEvaController = 
{
	//0:显示评价人头像，文字显示：您的好评是桔子们提升服务的动力
	//1：显示被评价人头像 ,文字显示：更多的服务更好的评价
	showIconType : "0", 
	evaUserId : null,//评价人id
	evaedUserId : null,//被评价人id
	groupId : null, //所评价的团的团id
	myUserId : null,//我的用户名
	scope : null,
	evaId : null,
	server1Arr : [],
	server2Arr : [],
	ability1Arr : [],
	ability2Arr : [],
	ability3Arr : [],
	evaScoreArr : [],
	init : function($scope)
	{
		this.scope = $scope;
		this.getUserInfo();
		this.getEvaInfo();
		this.onClickFunction();
	},
	getUserInfo : function()
	{
		var self = this;
		var arr = [];
		var showIconId = "";
		if(this.showIconType == "0")
		{
			showIconId = this.evaUserId
		}
		else
		{
			showIconId = this.evaedUserId
		}
		arr.push(showIconId);
		var params = {};
		params.userIds = JSON.stringify(arr);
		mnWebMain.httpRequest(API_GET_USEROBJ_WITH_USERIDS, params, function(result)
		{
			var resultJob = JSON.parse(result);
			if(resultJob.error == 0)
			{
				var dataJob = resultJob.data;
				var userObj = dataJob.userObjArr[showIconId];
				//昵称
				var nickName = userObj.nickName;
				self.scope.nickName = nickName;
				//头像	
				if(!userObj.icon || userObj.icon == null)
				{
					var orange_icon = DefaultGudiesIcon;
				} else {
					var icon = JSON.parse(userObj.icon);
					var orange_icon = icon.url + IMG_CUT_WH;
				}
				self.scope.groupIcon = orange_icon;
				var infomation = "";
				if(self.showIconType == "0")
				{
					infomation = "您的好评是桔子们提升服务的动力";
				}
				else 
				{
					infomation = "更多的服务更好的评价";
				}
				self.scope.infomation = infomation;
				self.scope.$apply();
			}
		});
	},
	getEvaInfo : function()
	{
		var self = this;
		var paramsEva = {};
		paramsEva.guideId = self.evaedUserId;
		paramsEva.visitorId = self.evaUserId;
		paramsEva.groupId = self.groupId;
		mnWebMain.httpRequest(API_GET_EVALUATION_INFO, paramsEva, function(result)
		{
			var resultJob = JSON.parse(result);
			if(resultJob.error == 0)
			{
				var dataJob = resultJob.data;
				var evaluation = dataJob.evaluation;
				self.evaId = evaluation[0].id;//评价id
				var server1 = parseInt(evaluation[0].server1);
				var server2 = parseInt(evaluation[0].server2);
				var ability1 = parseInt(evaluation[0].ability1);
				var ability2 = parseInt(evaluation[0].ability2);
				var ability3 = parseInt(evaluation[0].ability3);
				var evaScore = parseInt(evaluation[0].evaScore);
				//0不是默认评价，
				//1是默认评价
				var defaultEvaluation = evaluation[0].defaultEvaluation;
				if(defaultEvaluation == "1" && self.evaUserId == self.myUserId)
				{
					$("#evaContent").removeAttr("readonly");
					$("#submit").show();
				}
				else{}
				var evaContent = evaluation[0].evaContent;
				if(evaContent)
				{
					self.scope.evaContent = evaluation[0].evaContent;
				}
				else
				{
					self.scope.evaContent = "暂无评价！";
				}
				for(var i = 0; i < 5; i++)
				{
					if(i < server1)
						self.server1Arr.push("star-light");
					else
						self.server1Arr.push("star-gray");
				}
				for(var i = 0; i < 5; i++)
				{
					if(i < server2)
						self.server2Arr.push("star-light");
					else
						self.server2Arr.push("star-gray");
				}
				for(var i = 0; i < 5; i++)
				{
					if(i < ability1)
						self.ability1Arr.push("star-light");
					else
						self.ability1Arr.push("star-gray");
				}
				for(var i = 0; i < 5; i++)
				{
					if(i < ability2)
						self.ability2Arr.push("star-light");
					else
						self.ability2Arr.push("star-gray");
				}
				for(var i = 0; i < 5; i++)
				{
					if(i < ability3)
						self.ability3Arr.push("star-light");
					else
						self.ability3Arr.push("star-gray");
				}
				for(var i = 0; i < 5; i++)
				{
					if(i < evaScore)
						self.evaScoreArr.push("star-light");
					else
						self.evaScoreArr.push("star-gray");
				}
				self.scope.server1Arr = self.server1Arr;
				self.scope.server2Arr = self.server2Arr;
				self.scope.ability1Arr = self.ability1Arr;
				self.scope.ability2Arr = self.ability2Arr;
				self.scope.ability3Arr = self.ability3Arr;
				
				self.scope.evaScoreArr = self.evaScoreArr;
				self.scope.$apply();
			}
		});
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.submitClick = function()
		{
			self.modEvaContent();
		};
	},
	modEvaContent : function()
	{
		var self = this;
		var params = {};
		var evaContent = self.scope.evaContent;
		if(!evaContent)
		{
			var arr = ["确定"];
			mnWebMain.showDialog(0, "提示", "请先填写评价内容！", arr);
			return;
		}
		params.evaContent = evaContent;
		params.id = self.evaId;
		var path = "evaluation/modEvaluationContent";
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			var error = resultJob.error;
			if(error == 0)
			{
				$("#evaContent").attr("readonly", "readonly");
				$("#submit").hide();
				mnWebMain.toastInfo("修改评价成功！");
			}
			else
			{
				var arr = ["确定"];
				mnWebMain.showDialog(0, "提示", resultJob.errMsg, arr);
			}
		});
	}
};


