/*
 * ==============================
 *  桔子筛选
 * ==============================
 */

// 1. 获取module
var app = angular.module("app", []).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl', function($scope)
{
	mnWebMain.cbBridgeInited = function ()
	{
		OrangeFilterController.init($scope);
	};
	mnWebMain.cbViewWillAppear = function()
	{
//		var data = getLocalString(FILTER_CITY);
//		saveLocalString(FILTER_CITY);
//		if(data)
//		{
//			try
//			{
//				var cityName = JSON.parse(data).name;
//				OrangeFilterController.scope.locationContent = cityName;
//				OrangeFilterController.scope.$apply();
//			}catch(e){
//			}
//		}
	};
	mnWebMain.cbNavRightClicked = function()
	{
		var params = {};
		//性别
		params.gender = OrangeFilterController.sex;
		//等级
		params.grade = OrangeFilterController.grade;
		//带团时间
		params.tourTime = OrangeFilterController.tourTime;
		//有无导游证
		params.hasLegally = OrangeFilterController.card;
		//空闲时间++++++++++++++++++++++++++++++
		var statTime = OrangeFilterController.startTimeForServer;
		var endTime = OrangeFilterController.endTimeForServer;
		if(statTime)
		{
			params.freeStartTime = statTime;
		}
		else
		{
			params.freeStartTime = '';
		}
		if(endTime)
		{
			params.freeEndTime = endTime;
		}
		else
		{
			params.freeEndTime = '';
		}
		//地点--------------------------------------
		params.region = OrangeFilterController.scope.locationContent;
		//语言++++++++++++++++++++++++++++++
		var f_language = OrangeFilterController.languageIds;
		if(f_language)
		{
			params.language = f_language;
		}
		saveLocalString(FILTER_CITY, "");
		saveLocalString(FILTER_PARAMS, JSON.stringify(params));
		mnWebMain.transferData(JSON.stringify(params));//页面传值
		mnWebMain.closeSelfViewController(0);//关闭当前页面
	};
});
var OrangeFilterController = 
{
	scope : null,
	sex : -1,
	orangeSexArr : [],//桔子性别
	grade : 0,
	gradesArr : [],//桔子等级
	tourTime : -1,
	tourTimeArr : [],//带团时间
	card : -1,
	guideCardArr : [],//是否有导游证
	startTimeForServer　:　null,
	endTimeForServer : null,
	languageIds : null,
	init : function($scope)
	{
		this.scope = $scope;
		this.getSex();
		this.getGrade();
		this.getTourTime();
		this.getGuideCard();
		this.onClickFunction();
	},
	getSex : function()
	{
		this.orangeSexArr = orangeSex;
		this.scope.orangeSexArr = this.orangeSexArr;
		this.scope.$apply();
	},
	getGuideCard : function()
	{
		this.guideCardArr = guideCard;
		this.scope.guideCardArr = this.guideCardArr;
		this.scope.$apply();
	},
	//获取全部等级
	getGrade : function()
	{
		var self = this;
		var params = {};
		var path = API_GET_GRADE;
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			if(resultJob.error == 0)
			{
				var dataJob = resultJob.data;
				var grades = dataJob.grades;
				var itemNo = {};
				itemNo.id = 0;
				itemNo.name = "不限";
				itemNo.checked = "checked";
				self.gradesArr.push(itemNo);
				for(var i in grades)
				{
					var item = grades[i];
					item.checked = "unChecked";
					self.gradesArr.push(item);
				}
				self.scope.gradesArr = self.gradesArr;
				self.scope.$apply();
			}
			else
			{
			}
		});
	},
	//获取导游带团时间
	getTourTime : function()
	{
		var self = this;
		var params = {};
		var path = API_GET_TOURTIME;
		mnWebMain.httpRequest(path, params, function(result)
		{
			var resultJob = JSON.parse(result);
			if(resultJob.error == 0)
			{
				var dataJob = resultJob.data;
				var tourTime = dataJob.tourTime;
				var itemNo = {};
				itemNo.id = -1;
				itemNo.tourTime = "不限";
				itemNo.checked = "checked";
				self.tourTimeArr.push(itemNo);
				for(var i in tourTime)
				{
					var item = tourTime[i];
					item.checked = "unChecked";
					self.tourTimeArr.push(item);
				}
				self.scope.tourTimeArr = self.tourTimeArr;
				self.scope.$apply();
			}
			else
			{
			}
		});
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.sexItemClick = function(id)
		{
			for(var i = 0; i < self.gradesArr.length; i++)
			{
				if(self.orangeSexArr[i].id == id)
				{
					self.orangeSexArr[i].checked = "checked";
					self.sex = self.orangeSexArr[i].id;
				}
				else
				{
					self.orangeSexArr[i].checked = "unChecked";
				}
			}
			self.scope.orangeSexArr = self.orangeSexArr;
			self.scope.$apply();
		};
		this.scope.gradeItemClick = function(id)
		{
			for(var i = 0; i < self.gradesArr.length; i++)
			{
				if(self.gradesArr[i].id == id)
				{
					self.gradesArr[i].checked = "checked";
					self.grade = self.gradesArr[i].id;
				}
				else
				{
					self.gradesArr[i].checked = "unChecked";
				}
			}
			self.scope.gradesArr = self.gradesArr;
			self.scope.$apply();
		};
		this.scope.tourTimeItemClick = function(id)
		{
			for(var i = 0; i < self.tourTimeArr.length; i++)
			{
				if(self.tourTimeArr[i].id == id)
				{
					self.tourTimeArr[i].checked = "checked";
					self.tourTime = self.tourTimeArr[i].id;
				}
				else
				{
					self.tourTimeArr[i].checked = "unChecked";
				}
			}
			self.scope.tourTimeArr = self.tourTimeArr;
			self.scope.$apply();
		};
		this.scope.cardItemClick = function(id)
		{
			for(var i = 0; i < self.guideCardArr.length; i++)
			{
				if(self.guideCardArr[i].id == id)
				{
					self.guideCardArr[i].checked = "checked";
					self.card = self.guideCardArr[i].id;
				}
				else
				{
					self.guideCardArr[i].checked = "unChecked";
				}
			}
			self.scope.guideCardArr = self.guideCardArr;
			self.scope.$apply();
		};
		this.scope.idleClick = function()
		{
			mnWebMain.chooseTripDate(function(result)
			{
				var resultJob = JSON.parse(result);
				var error = resultJob.error;
				if(error == 0)
				{
					var dataJob = resultJob.data;
					var startTimeJob = dataJob.startTime;
					var startTime = startTimeJob.month + "月" + startTimeJob.day + "日";
					self.startTimeForServer = startTimeJob.year + "-" + startTimeJob.month + "-" + startTimeJob.day + " 00:00:00";
					
					var endTimeJob = dataJob.endTime;
					var endTime = endTimeJob.month + "月" + endTimeJob.day + "日";
					self.endTimeForServer = endTimeJob.year + "-" + endTimeJob.month + "-" + endTimeJob.day + " 00:00:00";
					
					var idleTime = startTime + " --> " + endTime;
					self.scope.idleContent = idleTime;
					self.scope.$apply();
				}
			});
		};
		this.scope.locationClick = function()
		{
			var headObj = {};
    		mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_COUNTRY, "选择地区", headObj, function(result)
    		{
    			var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var name = dataJob.params;
				self.scope.locationContent = name;
				self.scope.$apply();
    		});
		};
		this.scope.languageClick = function()
		{
			var headObj = {};
			headObj.leftTitle = "取消";
			headObj.rightTitle = "确定";
    		mnWebMain.openWebViewControllerWithDataTransfer(URL_SELECT_LANGUAGE, "语种选择", headObj, function(result){
				var resultJob = JSON.parse(result);
				var dataJob = resultJob.data;
				var params = JSON.parse(dataJob.params);
				var txt = params.txt;
				self.languageIds = params.id;
				self.scope.languageContent = txt;
				self.scope.$apply();
			});
		};
	},
};
