/*
 * ==============================
 *  桔树
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		mnWebMain.refresh("2");
		mnWebMain.removeLocalStorage(FILTER_PARAMS);
		OrangeTreeController.init($scope);
	}
	/**
	 * 下拉刷新
	 */
	mnWebMain.cbDownRefreshData = function()
	{
		saveLocalString(FILTER_PARAMS);
		OrangeTreeController.setDefault();
		getCitrusList(REFRESH, OrangeTreeController, OrangeTreeController.currentIndex);
	}
	/**
	 * 上拉加载更多
	 */
	mnWebMain.cbUpLoadData = function()
	{
		var filterString = getLocalString(FILTER_PARAMS);
		try 
		{
			var filterParamArr = JSON.parse(filterString);
		} catch (e) {
			var filterParamArr = {};
		}
		var gender = filterParamArr.gender;
		var grade = filterParamArr.grade;
		var tourTime = filterParamArr.tourTime;
		var hasLegally = filterParamArr.hasLegally;
		var region = filterParamArr.region;
		var language = filterParamArr.language;
		var freeStartTime = filterParamArr.freeStartTime;
		var freeEndTime = filterParamArr.freeEndTime;
		OrangeTreeController.currentIndex += 1;
		var startIndex = OrangeTreeController.currentIndex * 10;
		getCitrusList(LOAD_MORE, OrangeTreeController, startIndex, "", gender, grade, tourTime, hasLegally, region, language, 0, freeStartTime, freeEndTime); //筛选桔子
	}
	mnWebMain.cbNavRightClicked = function() 
	{
		var headObj = {};
		headObj.leftTitle = "取消";
		headObj.rightTitle = "确定";
		mnWebMain.openWebViewControllerWithDataTransfer(URL_ORANGE_FILTER, "筛选", headObj, function(result) 
		{
			var res = JSON.parse(result);
			var data = res.data;
			var filterParamArr = JSON.parse(data.params);
			$Loading.start();
			OrangeTreeController.setDefault();
			var gender = filterParamArr.gender;
			var grade = filterParamArr.grade;
			var tourTime = filterParamArr.tourTime;
			var hasLegally = filterParamArr.hasLegally;
			var region = filterParamArr.region;
			var language = filterParamArr.language;
			var freeStartTime = filterParamArr.freeStartTime;
			var freeEndTime = filterParamArr.freeEndTime;
			getCitrusList(INIT, OrangeTreeController, OrangeTreeController.currentIndex, "", gender, grade, tourTime, hasLegally, region, language, 0, freeStartTime, freeEndTime); //筛选桔子
		});
	};
});
var OrangeTreeController = 
{
	scope : null,
	currentIndex : 0,
	filterParamArr : {},//筛选条件
	guideArr : [],
	init : function($scope)
	{
		this.scope = $scope;
		$Loading.start();
		this.setDefault();
		getCitrusList(INIT, this, this.currentIndex);
		this.onClickFunction();
	},
	setDefault : function()
	{
		this.currentIndex = 0;
		this.filterParamArr = {};
		this.guideArr = [];
	},
	refreshUi : function(data, refreshType)
	{
		for(var i = 0; i < data.length; i++)
		{
			var itemObj = {};
			itemObj.userId = data[i].userId;//id
			
			itemObj.nickName = data[i].nickName;//昵称
			
			if (!data[i].icon || data[i].icon == null) {
				var orange_icon = DefaultGudiesIcon;
			} else {
				var icon = JSON.parse(data[i].icon);
				var orange_icon = icon.url + IMG_CUT_WH;
			}
			itemObj.icon = orange_icon;
			
			//性别
			if (data[i].gender == "0") {
				var sex_class = "icon_boy"; //男
			} else {
				var sex_class = "icon_girl"; //女
			}
			itemObj.sex_class = sex_class;
			//等级
			var iconName = 'a15.png';
			var status = data[i].status;
			var orangerLv = data[i].lv;
			if (orangerLv == 0) {
				iconName = 'b1.png';
			}
			if (4 == parseInt(status) && orangerLv != 0) {
				iconName = 'a' + orangerLv + '.png';
			} else if (orangerLv != 0) {
				iconName = 'b' + orangerLv + '.png';
			}
			itemObj.iconName = PATH_LEVEL_ICON + iconName;
			//地点
			if (data[i].location == "" || data[i].location == null) {
				var orange_location = "暂无数据"
			} else {
				var orange_location = data[i].location;
			}
			itemObj.location = orange_location;
			
			var eva = data[i].evaluation;
			if (eva && (eva != 0.00 || eva != 0)) {
				eva = "好评率：" + accMul(parseFloat(eva), 20) + "%";
			} else {
				eva = '好评率：暂无';
			}
			itemObj.eva = eva;
			this.guideArr.push(itemObj);
		}
		this.scope.guideArr = this.guideArr;
		this.scope.$apply();
		if (LOAD_MORE == refreshType) {
			var sHeight = document.body.scrollTop;
			document.body.scrollTop = sHeight + 50;
		}
		//ng-repeat完成回调
        this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
        	
        });
	},
	onClickFunction : function()
	{
		this.scope.itemClick = function(guideId)
		{
			var myUserId = getUserId();
			if (myUserId) 
			{
				var jumpUrl = URL_PERSONAL_DETAILS + "?userId=" + guideId;
				mnWebMain.openWebViewController(jumpUrl, "个人详情");
			} else {
				mnWebMain.openViewController("TOLoginNavigationController");//打开登录页面
			}
		};
		this.scope.itemChat = function(guideId, nickName, $event)
		{
			$event.stopPropagation();
			var myUserId = getUserId();
			if (myUserId) {
				mnWebMain.chat(1, guideId, nickName);
			} else {
				mnWebMain.openViewController("TOLoginNavigationController"); //打开登录页面
			}
		};
	},
};
