/*
 * ==============================
 *  导游发布足迹
 * ==============================
 */

// 1. 获取module
var app = angular.module("app",[]).run(function()
{
	FastClick.attach(document.body);
});

angularDirective.ngRepeatFinis(app);

// 2. 调用Controller
app.controller('ctrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		PublishFPController.init($scope);
	};
	//顶部左按钮点击事件
	mnWebMain.cbNavLeftClicked = function()
	{
		var question = $("#inputFootprint").val();
		if(question)
		{
			var arr = ["取消", "确定"];
			mnWebMain.showDialog(0, "提示：", "是否放弃正在编辑的内容", arr, function(result)
			{
				var res = JSON.parse(result);
				var data = res.data;
				if(data.index == "1")
				{
					mnWebMain.closeSelfViewController(0);
				}
			});
		}
		else
		{
			mnWebMain.closeSelfViewController(0);
		}
	};
	//发布问题
	mnWebMain.cbNavRightClicked = function()
	{
		var len = PublishFPController.picArr.length;
		var content = $("#inputFootprint").val();
		if(!content && len == 0)
		{
			var arr = ["确定"];
			mnWebMain.showDialog(0, "提示：", "请输入内容或上传图片", arr);
			return;
		}
		PublishFPController.publishFootprint(content);
	};
});
var PublishFPController = 
{
	scope : null,
	picArr : [],
	location : null,
	permissionId : 1,
	init : function($scope)
	{
		this.scope = $scope;
		this.onClickFunction();
	},
	//导游发布足迹
	publishFootprint : function(content){
		var params = {};
		params.content = content;
		var pics = [];
		for(var i = 0; i < this.picArr.length; i++)
		{
			pics.push(this.picArr[i].big);
		}
		params.pics = JSON.stringify(pics);
		var place = {};
		var location = this.location;
		if(location)
		{
			place.locationName = this.location;
		}
		else
		{
			place.locationName = "";
		}
		params.place = JSON.stringify(place);
		params.readPermissions = this.permissionId;
		var path = API_PUBLISH_FOOTMARK;
		mnWebMain.httpRequest(path, params, function(result){
			var resultJob = JSON.parse(result);
			if( resultJob.error == 0 ){
				var params = {};
				mnWebMain.transferData(JSON.stringify(params));//页面传值
				mnWebMain.closeSelfViewController(0);//关闭当前页面
			}else{
				mnWebMain.toastInfo(resultJob.errMsg);
			}
		});
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.addIcon = function()
		{
			var imgLength = self.picArr.length;
			if(imgLength >= 9){
				var arr = ["确定"];
				mnWebMain.showDialog(0, "提示", "最多只能上传9张图片！", arr)
				return;
			}
			var arr = ["拍照", "从相册选择", "取消"];
			mnWebMain.showDialog("2", "", "", arr, function(result){
				var resultJob = JSON.parse(result);
				var data = resultJob.data;
				if(data.index == "0"){	//拍照
					mnWebMain.photoPicker(1, 0, 1, function(result2){
						var res2 = JSON.parse(result2);
						var data2 = res2.data;
						var myImgs = JSON.parse(data2.imageURLs);
						for(var i in myImgs){
							var picItem = {};
							picItem.small = myImgs[i] + IMG_CUT_WH;
							picItem.big = myImgs[i];
							self.picArr.push(picItem);
						}
						if(self.picArr != 0)
						{
							$(".pub-img-item").show();
						}
						else
						{
							$(".pub-img-item").hide();
						}
						self.scope.picArr = self.picArr;
						self.scope.$apply();
					})
				}else if(data.index == "1"){	//相册
					mnWebMain.photoPicker(1, 2, 9 - imgLength, function(result2){
						var res2 = JSON.parse(result2);
						var data2 = res2.data;
						var myImgs = JSON.parse(data2.imageURLs);
						for(var i in myImgs){
							var picItem = {};
							picItem.small = myImgs[i] + IMG_CUT_WH;
							picItem.big = myImgs[i];
							self.picArr.push(picItem);
						}
						if(self.picArr != 0)
						{
							$(".pub-img-item").show();
						}
						else
						{
							$(".pub-img-item").hide();
						}
						self.scope.picArr = self.picArr;
						self.scope.$apply();
					})
				}
			});
		};
		this.scope.picItemClick = function(index)
		{
			var pics = [];
			for(var i in self.picArr)
			{
				pics.push(self.picArr[i].big)
			}
			mnWebMain.browserPics(index, JSON.stringify(pics));
		};
		this.scope.itemDelete = function(index)
		{
			try
			{
				self.picArr.splice(index, 1);
				self.scope.picArr = self.picArr;
				self.scope.$apply();
			}catch(e){
			}
		}
		this.scope.locationClick = function()
		{
			mnWebMain.openViewControllerWithDataTransfer("ChooseFootprintController", "选择足迹地点", "", function(result){
				var res = JSON.parse(result);
				var data = res.data;
				self.location = data.location;
				self.scope.location = self.location;
				self.scope.$apply();
			});
		};
		this.scope.permissionClick = function()
		{
			mnWebMain.openWebViewControllerWithDataTransfer(URL_FOOT_PERMISSIONS + "?id=" + self.permissionId, "谁可以看", "", function(result){
				var res = JSON.parse(result);
				var data = res.data;
				var params = JSON.parse(data.params);
				self.permissionId = params.id;
				self.scope.permission = params.text;
				self.scope.$apply();
			});
		};
	},
};
