/**
 * 模版列表
 */
// 1. 获取module
var NoticeModelApp = angular.module("NoticeModelApp",[]).run(function(){
	FastClick.attach(document.body);
});
// 2. controller初始化
NoticeModelApp.controller('NoticeModelCtrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		mnWebMain.refresh("2");
		NoticeModelController.init($scope);
	};
	mnWebMain.cbDownRefreshData = function()
	{
		NoticeModelController.setDefault();
		NoticeModelController.getModelList(REFRESH);
	};
	mnWebMain.cbUpLoadData = function()
	{
		NoticeModelController.getModelList(LOAD_MORE);
	};
});
var NoticeModelController = 
{
	scope : null,
	currentPage : 0,
	pageSize : 10,
	templateArr : [],
	init : function($scope)
	{
		this.scope = $scope;
		$Loading.start();
		this.getModelList(INIT);
		this.onClickFunction();
	},
	setDefault : function()
	{
		this.currentPage = 0;
		this.templateArr = [];
	},
	getModelList : function(refreshType)
	{
		var self = this;
		var path = "client/getTemplateList";
		var params = {};
		if(refreshType == LOAD_MORE)
		{
			this.currentIndex++;
		}
		else
		{
			this.currentIndex = 0;
		}
		var startIndex = this.currentIndex * this.pageSize;
		params.startIndex = startIndex;
		params.num = this.pageSize;
		mnWebMain.httpRequest(path, params, function(result)
		{
			$Loading.end();
			var resultJob = JSON.parse(result);
			var error = resultJob.error;
			if(error == 0)
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_SUCCESS);
				}
				var templateArr = resultJob.data.templateList;
				if(templateArr.length == 0)
				{
					if(refreshType == INIT || refreshType == REFRESH)
					{
						$(".undata").show();
					}
					else if(refreshType == LOAD_MORE)
					{
						mnWebMain.toastInfo("没有更多数据！");
					}
				}
				else
				{
					$(".undata").hide();
					self.refreshUi(templateArr);
				}
			}
			else
			{
				if(refreshType != INIT)
				{
					mnWebMain.refreshFinish(REFRESH_FAILED);
				}
				mnWebMain.toastInfo(resultJob.errMsg);
			}
		});
	},
	refreshUi : function(templateArr)
	{
		for(var i = 0; i < templateArr.length; i ++)
		{
			var itemObj = {};
			var template = templateArr[i].template;
			itemObj.realTemplate = templateArr[i].template;
			template = template.replace(/{time}/g, "(___)");
			template = template.replace(/{input}/g, "(___)");
			itemObj.template = template;
			this.templateArr.push(itemObj);
		}
	 	this.scope.templateArr = this.templateArr;
		this.scope.$apply();
		//ng-repeat完成回调
        this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
        });
	},
	onClickFunction : function()
	{
		this.scope.itemClick = function(content)
		{
			saveLocalString(NOTICE_MODEL, content);
			var page_url = BASE_PATH + "notice_model_mod.html";
			var headObj = {};
			headObj.rightTitle = "确定";
			mnWebMain.openWebViewControllerWithDataTransfer(page_url, "模版详情", headObj, function(result)
			{
				var resultJob = JSON.parse(result);
				var error = resultJob.error;
				if(error == 0)
				{
					var params = resultJob.data.params;
					mnWebMain.transferData(params);
					mnWebMain.closeSelfViewController(0);
				}
			});
		};
		
	},
}
// 自定义repeat完成事件
NoticeModelApp.directive('onFinishRenderFilters', function ($timeout) {
    return {
        restrict: 'A',
        link: function(scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function() {
                    scope.$emit('ngRepeatFinished');
                });
            }
        }
    };
});
