/**
 * 模版详情
 */
// 1. 获取module
var NoticeModelModApp = angular.module("NoticeModelModApp",[]).run(function(){
	FastClick.attach(document.body);
});
// 2. controller初始化
NoticeModelModApp.controller('NoticeModelModCtrl',function($scope)
{
	mnWebMain.cbBridgeInited = function()
	{
		var content = getLocalString(NOTICE_MODEL);
		NoticeModelModController.serverContent = content;
		NoticeModelModController.init($scope);
	};
	mnWebMain.cbNavRightClicked = function()
	{
		var model = NoticeModelModController;
		for(i = 0; i < model.params.length; i++)
		{
			var type = "{}";
			if(model.params[i].type == "time")
			{
				type = "{time}";
			}
			else if(model.params[i].type == "input")
			{
				type = "{input}";
				
			}
			var value = model.params[i].value;
			if(!value)
			{
				value = "()";
			}
			model.serverContent = model.serverContent.replace(type, value);
		}
		mnWebMain.transferData(model.serverContent);
		mnWebMain.closeSelfViewController(0);
	}
});
var NoticeModelModController = 
{
	scope : null,
	serverContent : null,
	showContent : null,
	params : [],
	init : function($scope)
	{
		this.scope = $scope;
		this.refreshUi();
	},
	refreshUi : function()
	{
		var content = this.serverContent.replace(/{time}/g, "(时间)");
		this.showContent = content.replace(/{input}/g, "(输入)");
		this.scope.content = this.showContent;
		this.scope.$apply();
		this.getParamsWithContent();
		this.onClickFunction();
	},
	getParamsWithContent : function()
	{
		/**
		 * 从文本中取出所有参数
		 */
		this.params = [];
		var index = 0;
		var letterArr = this.serverContent.split("");
		for(var i = 0; i < letterArr.length; i++)
		{
			if(i != (letterArr.length - 1))
			{
				if(letterArr[i] == "{")
				{
					if(letterArr[i + 1] == 't')
					{
						var itemObj = {};
						itemObj.index = index;
						index++;
						itemObj.value = "";
						itemObj.type = "time";
						this.params.push(itemObj);
					}
					else if(letterArr[i + 1] == 'i')
					{
						var itemObj = {};
						itemObj.index = index;
						index++;
						itemObj.value = "";
						itemObj.type = "input";
						this.params.push(itemObj);
					}
				}	
			}
		}
		this.scope.params = this.params;
		this.scope.$apply();
		//ng-repeat完成回调
        this.scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
        });
	},
	onClickFunction : function()
	{
		var self = this;
		this.scope.itemClick = function(paramsIndex, value, type)
		{
			if(type == "time")
			{
				mnWebMain.chooseDate(function(result)
				{
					var resultJob = JSON.parse(result).data;
					var returnTime = resultJob.result;//集合时间字符串
					var year = returnTime.substring(0, 4);
					var month = returnTime.substring(5, 7);
					var day = returnTime.substring(8, 10);
					var hour = returnTime.substring(11, 13);
					var minute = returnTime.substring(14, 16);
					var time = year + '年' + month + '月' + day + "日" + hour + '时' + minute + '分';
					self.params[paramsIndex].value = time;
					self.scope.$apply();
				}, 0);
			}
			else if(type == "input")
			{
				var arr = ["取消", "确定"];
				mnWebMain.showDialog(1, "参数", value, arr, function(result)
				{
					var resultJob = JSON.parse(result);
					var error = resultJob.error;
					if(error == 0)
					{
						if(resultJob.data.index == 1)
						{
							self.params[paramsIndex].value = resultJob.data.inputContent;
							self.scope.$apply();
						}
					}
				});
			}
		};
	},
};

