//citrus.html桔树
//获取桔子列表
/**
 * @param {Object} refreshType       刷新类型
 * @param {Object} startIndex  		  起始位置
 * @param {Object} keyword		         关键字
 * @param {Object} gender		         性别
 * @param {Object} grade		         等级
 * @param {Object} tourTime		         带团时间
 * @param {Object} hasLegally		  有无导游证
 * @param {Object} region			  地区		 
 * @param {Object} language			  语言
 * @param {Object} sortType          排序
 * @param {Object} freeStartTime     空闲开始
 * @param {Object} freeEndTime		  空闲结束时间
 */
function getCitrusList(containerName, refreshType, startIndex, keyword, gender, grade, tourTime, hasLegally, region, language, sortType, freeStartTime, freeEndTime) {
	if(!containerName)
	{
		containerName = "citrus_list";
	}
	var params = {};
	params.startIndex = startIndex;
	params.num = PAGE_NUM;

	if (!keyword) {
		params.keyword = "";
	} else {
		params.keyword = keyword;
	}

	if (gender && gender != -1) {
		params.gender = gender;
	}

	if (grade) {
		params.grade = grade;
	} else {
		params.grade = 0;
	}

	if (tourTime && tourTime != -1) {
		params.tourTime = tourTime;
	}

	if (hasLegally && hasLegally != -1) {
		params.hasLegally = hasLegally;
	}

	if (region) {
		params.region = JSON.parse(region)[0];
	}

	if (language) {
		params.language = language;
	}

	if (sortType) {
		params.sortType = sortType;
	} else {
		params.sortType = 0;
	}
	if (freeStartTime && freeEndTime) {
		params.freeStartTime = freeStartTime;
		params.freeEndTime = freeEndTime;
	} else {
		params.freeStartTime = '';
		params.freeEndTime = '';
	}
	var path = CLIENT_GET_GUIDES;

	mnWebMain.httpRequest(path, params, function(result) {
		var res = JSON.parse(result);
		$("#load_gif").hide();
		if (res.error == 0) {
			if(refreshType != INIT)
			{
				mnWebMain.refreshFinish(REFRESH_SUCCESS);
			}
			var dataInfo = res.data;
			var data = dataInfo.guideArr;
			if (!data || data.length == 0) {
				if (refreshType == INIT || refreshType == REFRESH) {
					var none_list = '<div class="search_none">' +
						'<p><img src="icon/search_no.png"/></p>' +
						'<span>对不起没有找到你想要的哟~</span>' +
						'</div>';
					$("#" + containerName).html(none_list);
				} else if (LOAD_MORE == refreshType) {
					//没有更多数据
					mnWebMain.toastInfo("没有更多的导游！");
				} 
			} else {
				var orange_list = '';
				for (var i in data) {
					//头像	
					if (!data[i].icon || data[i].icon == null) {
						var orange_icon = 'icon/default.png';
					} else {
						var icon = JSON.parse(data[i].icon);
						var orange_icon = icon.url + IMG_CUT_WH;
					}

					//年龄
					var birthdayYear = data[i].birthday.split("-")[0];
					var myDate = new Date();
					var nowYear = myDate.getFullYear();
					var age = parseInt(nowYear) - parseInt(birthdayYear);

					//性别
					if (data[i].gender == "0") {
						var sex_class = "icon_boy"; //男
					} else {
						var sex_class = "icon_girl"; //女
					}

					//等级
					var iconName = 'a15.png';
					var status = data[i].status;
					var orangerLv = data[i].lv;
					if (orangerLv == 0) {
						iconName = 'b1.png';
					}
					if (4 == parseInt(status) && orangerLv != 0) {
						iconName = 'a' + orangerLv + '.png';
					} else if (orangerLv != 0) {
						iconName = 'b' + orangerLv + '.png';
					}
					//地点
					if (data[i].location == "" || data[i].location == null) {
						var orange_location = "暂无数据"
					} else {
						var orange_location = data[i].location;
					}
					var eva = data[i].evaluation;
					if (eva && (eva != 0.00 || eva != 0)) {
						eva = accMul(parseFloat(eva), 20) + "%";
					} else {
						eva = '暂无';
					}
					var item = getItemLayout(data[i].userId, orange_icon, data[i].nickName, sex_class, iconName, orange_location, eva);
					orange_list += item;
				}
				if (INIT == refreshType || REFRESH == refreshType) {
					$("#" + containerName).html(orange_list);
				} else if (LOAD_MORE == refreshType) {
					$("#" + containerName).append(orange_list);
					var sHeight = document.body.scrollTop;
					document.body.scrollTop = sHeight + 50;
				}
				//设置点击事件
				itemClick(myUserId);
			}
		} else {
			if (refreshType != INIT) {
				mnWebMain.refreshFinish(REFRESH_FAILED);
			}
			mnWebMain.toastInfo("获取数据失败！");
		}
	});
}