/**
 * 
 * @param {Object} keyword
 * @param {Object} startIndex
 * @param {Object} refreshType
 * @param {Object} containerName, 容器的名字
 */
function allSearchQuestion(keyword, startIndex, refreshType, containerName, sortType) {
	var params = {};
	params.keyword = keyword;
	if(sortType)
	{
		params.sortType = sortType;
	}
	params.startIndex = startIndex;
	params.num = PAGE_NUM;
	var path = QUESTION_SEARCHE_QUESTION;
	mnWebMain.httpRequest(path, params, function(result) {
		var res = JSON.parse(result);
		if (res.error == 0) {
			if (refreshType != INIT) {
				mnWebMain.refreshFinish(REFRESH_SUCCESS);
			}
			var dataInfo = res.data;
			var data = dataInfo.questionObjArr;
			if (!data || data.length == 0) {
				if (refreshType == INIT || refreshType == REFRESH) {
					var none_list = '<div class="search_none">' +
						'<p><img src="icon/search_no.png"/></p>' +
						'<span>对不起没有找到你想要的哟~</span></div>';
						none_list += '<div class="publish-question">发起提问</div>';
					$("#load_gif").hide();
					$("#" + containerName).html(none_list);
					$(".publish-question").off("tap").on("tap", function()
					{
						var userId = getUserId();
						mnWebMain.closeSelfViewController(0);
						if(userId)
						{
							var headObj = {}; 
							headObj.leftTitle = "取消";
							headObj.rightTitle = "发布";
							var userType = getUserType();
				    		mnWebMain.openWebViewController(URL_PUBLISH_QUES + "?type=" + userType, "我要提问", headObj);
						}
						else
						{
							mnWebMain.openViewController("TOLoginNavigationController");
						}
					});
				} else if (refreshType == LOAD_MORE) {
					//没有更多数据
					mnWebMain.toastInfo("没有更多的导游！");
				} 
				
			} else {
				var list = '';
				for (var i in data) {
					list += '<li data-id="' + data[i].id + '"><p style="white-space: pre-line; font-size: 14px;">' + data[i].questionContent + '</p>' +
						'<div><span>' + data[i].replyNum + '回答</span><span style="margin-left: 10px">' + data[i].praiseNum + '赞</span><i>' + data[i].questionTime + '</i></div>' +
						'</li>';
				}
				$("#load_gif").hide();
				if (refreshType == INIT || refreshType == REFRESH) {
					$("#" + containerName).html(list); //下拉刷新
				} else if (refreshType == LOAD_MORE) {
					$("#" + containerName).append(list); //上拉加载
				}

				$("#" + containerName + " li").off("tap").on("tap", function() {
					var qid = $(this).attr("data-id");
					if(myUserId)
					{
						var page_url = BASE_PATH + "ui-question-details.html?id=" + qid;
						mnWebMain.openWebViewController(page_url, "问题详情");
					}
					else
					{
						mnWebMain.openViewController("TOLoginNavigationController"); //打开登录页面
					}
				});
			}
		} else {
			if (refreshType != INIT) {
				mnWebMain.refreshFinish(REFRESH_SUCCESS);
			}
		}
	});
}
/**
 * 根据关键字获取所有的桔子
 * @param {Object} keyword
 * @param {Object} startIndex
 * @param {Object} refreshType
 * @param {Object} containerName ul的class
 * @param {Object} containerId  ul的id，用于点击事件方法
 */
function allSearchOrange(keyword, startIndex, refreshType, containerName, containerId) {
	var params = {};
	params.startIndex = startIndex;
	params.num = PAGE_NUM;
	
	if(!keyword || keyword == undefined){
		params.keyword = "";
	}else{
		params.keyword = keyword;
	}
	var path = CLIENT_GET_GUIDES;
	mnWebMain.httpRequest(path,params, function(result)
	{
		var res = JSON.parse(result);
		$("#load_gif").hide();
		if (res.error == 0) {
			//初始化时不需要关闭加载效果
			if(refreshType != INIT)
			{
				mnWebMain.refreshFinish(REFRESH_SUCCESS);
			}
			var dataInfo = res.data;
			var data = dataInfo.guideArr;
			if (!data || data.length == 0) {
				if (refreshType == INIT || refreshType == REFRESH) {
					var none_list = '<div class="search_none">' +
						'<p><img src="icon/search_no.png"/></p>' +
						'<span>对不起没有找到你想要的哟~</span>' +
						'</div>';
					$("#" + containerName).html(none_list);
				} else if (refreshType == LOAD_MORE) {
					//没有更多数据
					mnWebMain.toastInfo("没有更多的导游！");
				} 
			} else {
				var orange_list = '';
				for (var i in data) {
					//头像	
					if (!data[i].icon || data[i].icon == null) {
						var orange_icon = 'icon/default.png';
					} else {
						var icon = JSON.parse(data[i].icon);
						var orange_icon = icon.url + IMG_CUT_WH;
					}
					//年龄
					var birthdayYear = data[i].birthday.split("-")[0];
					var myDate = new Date();
					var nowYear = myDate.getFullYear();
					var age = parseInt(nowYear) - parseInt(birthdayYear);

					//性别
					if (data[i].gender == "0") {
						var sex_class = "icon_boy"; //男
					} else {
						var sex_class = "icon_girl"; //女
					}

					//等级
					var iconName = 'a15.png';
					var status = data[i].status;
					var orangerLv = data[i].lv;
					if (orangerLv == 0) {
						iconName = 'b1.png';
					}
					if (4 == parseInt(status) && orangerLv != 0) {
						iconName = 'a' + orangerLv + '.png';
					} else if (orangerLv != 0) {
						iconName = 'b' + orangerLv + '.png';
					}
					//地点
					if (data[i].location == "" || data[i].location == null) {
						var orange_location = "暂无数据"
					} else {
						var orange_location = data[i].location;
					}
					var eva = data[i].evaluation;
					if (eva && (eva != 0.00 || eva != 0)) {
						eva = accMul(parseFloat(eva), 20) + "%";
					} else {
						eva = '暂无评价';
					}
					var item = getItemLayout(data[i].userId, orange_icon, data[i].nickName, sex_class, iconName, orange_location, eva);
					orange_list += item;
				}
				if (INIT == refreshType || REFRESH == refreshType) {
					$("#" + containerName).html(orange_list);
				} else if (LOAD_MORE == refreshType) {
					$("#" + containerName).append(orange_list);
				}
				//设置点击事件
				itemClick(myUserId, containerId);
			}
		} else {
			if (refreshType != INIT) {
				mnWebMain.refreshFinish(REFRESH_FAILED);
			}
		}
	});
}